#include "azimutal.h"

void carte_du_ciel3(date2 *datum,systeme *sys,TMemoryDC *memdc,int x2,int x1,int y2,int y1,HBRUSH pinceau[16],HPEN crayon[16],bool lignes,bool ngcs,bool messier, bool asteroides,double Magnitudes,bool PPrint,bool NB,bool RColor,bool NAME)
{
//azimutal!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//sys: pointeur sur le systeme
double longitude=sys->getlongitude();       //11.5
double latitude=sys->getlatitude();       //45.5
double Az,ha,hasol;;


date2* datetronquee=new date2();
double H,teta,tsj;//teta temps sideral local a greenwich a0 hUT, tsj le temps en siecle juliens local

// calcul de teta temps sideral
datetronquee->setjour(datum->getjour());
datetronquee->setmois(datum->getmois());
datetronquee->setannee(datum->getannee());
datetronquee->miseajour();
tsj=datetronquee->getsieclejulien();
teta=6.6460656+2400.051262*tsj+0.00002581*tsj*tsj;
teta=teta/24.0;
teta=teta-floor(teta);
teta=teta*24.0;//temps sideral a greenwich a 0h
teta=teta+(  (double) datum->getheure()+ ( (double)datum->getminute()/60.0 )*1.002737908);

teta=15.0*teta;//nous voila en degre


  //------------------
  // couleur du ciel
  double a,r;
  r=sys->getsun()->getdeclinaison();
  a=sys->getsun()->getascensiondroite();
  H=teta-(longitude+a);
  //assert( (sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H))) * (sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H))))<1);
  ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
  hasol=ha;
if(PPrint==true){
		memdc->SelectObject(pinceau[1]); //blanc
		memdc->SelectObject(crayon[0]);}
else {

  // si dans ellipse : il fait jour
  if (ha>5.0) memdc->SelectObject(pinceau[4]); //jour
  if (ha>4.0 && ha<=5.0) memdc->SelectObject(pinceau[29]);
  if (ha>3.0 && ha<=4.0) memdc->SelectObject(pinceau[28]);
  if (ha>2.0 && ha<=3.0) memdc->SelectObject(pinceau[27]);
  if (ha>1.0 && ha<=2.0) memdc->SelectObject(pinceau[26]);
  if (ha>0.0 && ha<=1.0) memdc->SelectObject(pinceau[25]);
  if (ha>-1.0 && ha<=0.0) memdc->SelectObject(pinceau[24]);
  if (ha>-3.0 && ha<=-1.0) memdc->SelectObject(pinceau[23]);
  if (ha>-5.0 && ha<=-3.0) memdc->SelectObject(pinceau[22]);
  if (ha>-10.0 && ha<=-5.0) memdc->SelectObject(pinceau[21]);
  if (ha<=-10.0) memdc->SelectObject(pinceau[3]); //nuit

}

sys->calculposition(datum);

memdc->Rectangle(5,30,sys->ScrL()-20,sys->ScrH()-15);


//j'initialise mes variables
int i,Couleur;
int x,y,antex,antey,temp,k;
int consligne;
double angle;
int iccon;
if (NB==true) iccon=20; else iccon=0;

//j'initialise mes icones
TIcon Galaxie(_hInstance,(TResId)(galaxie-iccon));
TIcon GalaxieSpirale(_hInstance,(TResId)(galaxies-iccon));
TIcon GalaxieSpiraleBarree(_hInstance,(TResId)(galaxiesb-iccon));
TIcon GalaxieElliptique(_hInstance,(TResId)(galaxiee-iccon));
TIcon AmasOuvert(_hInstance,(TResId)(amaso-iccon));
TIcon AmasGlobulaire(_hInstance,(TResId)(amasg-iccon));
TIcon Nebuleuse(_hInstance,(TResId)(nebuleuse-iccon));

TIcon Merc(_hInstance,(TResId)(merc-iccon));
TIcon Venu(_hInstance,(TResId)(venu-iccon));
TIcon Mar(_hInstance,(TResId)(mar-iccon));
TIcon Jupi(_hInstance,(TResId)(jupi-iccon));
TIcon Satu(_hInstance,(TResId)(satu-iccon));
TIcon sol(_hInstance,(TResId)(solei-iccon));
TIcon Uranus(_hInstance,(TResId)(uranus-iccon));
TIcon Neptune(_hInstance,(TResId)(neptune-iccon));
TIcon Plut(_hInstance,(TResId)(pluton-iccon));
TIcon Lune(_hInstance,(TResId)(lune));
TIcon Comet(_hInstance,(TResId)(commet-iccon));

TIcon Eclipse1(_hInstance,(TResId)(ECLIPSE1));
TIcon Eclipse2(_hInstance,(TResId)(ECLIPSE2));


if (PPrint==false) {memdc->SetTextColor(RGB(200,200,200));memdc->SetBkColor(RGB(0,0,0));}
else {memdc->SetTextColor(RGB(0,0,0));memdc->SetBkColor(RGB(255,255,255));}
char inter[3];
char inter2[4];
memdc->SetBkMode(TRANSPARENT);

//x1=10;x2=100;

if(y1>y2) {temp=y1; y1=y2; y2=temp;}
if(x1<=x2) x1+=360; // on fait un petit tour
if(x2<0) x2+=360;
while (x1<=x2) x1+=360;

if(x2<360) itoa(x2-180,inter,10);
else itoa((x2-540),inter,10);
  strncat(inter,"",1);
  memdc->TextOut(7,sys->ScrH()-30,inter,strlen(inter));
  itoa(x1,inter,10);
if(x1<360) itoa(x1-180,inter,10);
else itoa((x1-540),inter,10);
  strncat(inter,"",1);
  memdc->TextOut(sys->ScrL()-50,sys->ScrH()-30,inter,strlen(inter));
itoa(max(y1,y2),inter2,10);
  strncat(inter2,"",1);
  memdc->TextOut(sys->ScrL()-50,32,inter2,strlen(inter2));
itoa(min(y1,y2),inter2,10);
  strncat(inter2,"",1);
  memdc->TextOut(sys->ScrL()-50,sys->ScrH()-50,inter2,strlen(inter2));
if(x1>380 && x2<340) memdc->TextOut(7+(sys->ScrL()-20)*(float)(360-x2)/(float)(x1-x2),sys->ScrH()-30,"S",1);
if(x1>200 && x2<160) memdc->TextOut(7+(sys->ScrL()-20)*(float)(180-x2)/(float)(x1-x2),sys->ScrH()-30,"N",1);
if(x1>110 && x2<50) memdc->TextOut(7+(sys->ScrL()-20)*(float)(90-x2)/(float)(x1-x2),sys->ScrH()-30,"O",1);
if(x1>290 && x2<250) memdc->TextOut(7+(sys->ScrL()-20)*(float)(270-x2)/(float)(x1-x2),sys->ScrH()-30,"E",1);

//if(x1>20 && x2<700) memdc->TextOut(7+(sys->ScrL()-20)*(float)(360-x2)/(float)(x1-x2),sys->ScrH()-30,"S",1);
if(x1>560 && x2<520) memdc->TextOut(7+(sys->ScrL()-20)*(float)(540-x2)/(float)(x1-x2),sys->ScrH()-30,"N",1);
if(x1>470 && x2<410) memdc->TextOut(7+(sys->ScrL()-20)*(float)(450-x2)/(float)(x1-x2),sys->ScrH()-30,"O",1);
if(x1>650 && x2<610) memdc->TextOut(7+(sys->ScrL()-20)*(float)(630-x2)/(float)(x1-x2),sys->ScrH()-30,"E",1);
//HELP LOLO
//plus besoin je suis en azimutal   --->je met a jour l'heure des ascensions droite->en deg
//x1=x1*15;
//x2=x2*15;

// maintenant on peut avoir 23 h  1h

//if(x1>x2) {temp=x1; x1=x2; x2=temp;}

//j'aime pas les divisions par 0
//if((x1==x2) || (y1==y2)) goto fincausediv0;
if (x1==x2) x1=x2-1;
if (y1==y2) y1=y2+1;

int sauvex1,sauvex2,sauvey1,sauvey2;
sauvex1=x1;
sauvex2=x2;
sauvey1=y1;
sauvey2=y2;



//****************************************
// dessin des lignes entre etoiles
int l;
if (lignes==true) {
  memdc->SelectObject(crayon[16]);// crayon pointille bleu
  for(i=0;i<sys->getnbrconstellation();i++){
	for(l=0;l<sys->getconstellation(i)->Nombre;l++){
	 k=0;
	 r=sys->getconstellation(i)->Star[l]->getdeclinaison();
	a=sys->getconstellation(i)->Star[l]->getascensiondroite();
//*************modif begin***********************************
//calcul de teta temps sideral

			 //c'est parti conversion des declin ascdr en azimut hauteur
			 H=teta-(longitude+a);
			if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
			ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
			 //maintenant conversion des azimuts/hauteurs en coordonnees *memdc
			 ha=90.0-ha;
			 Az=360.0-Az;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			  if(Az>x2) Az-=360;
			 y=(int)(sys->ScrH()-15 -((ha-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((Az-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));
		 antey=y;
		 antex=x;
		 x1=sauvex1;
		 x2=sauvex2;
		 y1=sauvey1;
		 y2=sauvey2;

if (antex>5 && antex<sys->ScrL()-20 && antey>30 && antey<sys->ScrH()-15){

		  consligne=sys->getconstellation(i)->Star[l]->getligne(k);
		  while(consligne>=0 && k<max_lignes){
			r=sys->getconstellation(i)->Star[consligne]->getdeclinaison();
			a=sys->getconstellation(i)->Star[consligne]->getascensiondroite();
//*************modif begin***********************************
//calcul de teta temps sideral

			 //c'est parti conversion des declin ascdr en azimut hauteur
			 H=teta-(longitude+a);
			if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
			ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
			 //maintenant conversion des azimuts/hauteurs en coordonnees *memdc
			 ha=90.0-ha;
			 Az=360.0-Az;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			  if(Az>x2) Az-=360;
			 y=(int)(sys->ScrH()-15 -((ha-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((Az-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));
          //restauration apres le bordel
				x1=sauvex1;
				x2=sauvex2;
				y1=sauvey1;
				y2=sauvey2;

			if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
			  if (abs(antex-x)>sys->ScrL()/2 ){   // probleme au bord
				if (antex>sys->ScrL()-sys->ScrL()/4 && x<sys->ScrL()/4){
				  memdc->MoveTo(antex,antey);
				  memdc->LineTo(sys->ScrL()-20,antey+(y-antey)*(sys->ScrL()-20-antex)/(sys->ScrL()-20-antex+x-5));
				  memdc->MoveTo(5,antey+(y-antey)*(sys->ScrL()-20-antex)/(sys->ScrL()-20-antex+x-5));
				  memdc->LineTo(x,y);
				 }
				 if (x>sys->ScrL()-sys->ScrL()/4 && antex<sys->ScrL()/4){
				  memdc->MoveTo(x,y);
				  memdc->LineTo(sys->ScrL()-20,y+(antey-y)*(sys->ScrL()-20-x)/(sys->ScrL()-20-x+antex-5));
				  memdc->MoveTo(5,y+(antey-y)*(sys->ScrL()-20-x)/(sys->ScrL()-20-x+antex-5));
				  memdc->LineTo(antex,antey);
				 }
			 }// if abs
			 else {
			  memdc->MoveTo(antex,antey);
			  memdc->LineTo(x,y);
			 } //else
			}// if x, y e fenetre
         k++;
			consligne=sys->getconstellation(i)->Star[l]->getligne(k);
		}// while
	 }// if anter e fenetre
    }//for l
  }//for i
}// if ligne=true


//******************************
//dessin des etoiles
double magg;
 if (RColor==false){
	if (PPrint==false){
		memdc->SelectObject(crayon[1]);memdc->SelectObject(pinceau[1]); }
	else {memdc->SelectObject(crayon[0]);memdc->SelectObject(pinceau[0]); }
 }

 memdc->SetBkMode(TRANSPARENT);
memdc->SetTextColor(RGB(250,150,100));
int SkyR,SkyG,SkyB;
if (PPrint==true){SkyR=255;SkyG=255;SkyB=255;}
else {
  ha=hasol;
	  // si dans ellipse : il fait jour
  if (ha>5.0) {SkyR=0;SkyG=0;SkyB=255;} //jour
  if (ha>4.0 && ha<=5.0) {i=29;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (ha>3.0 && ha<=4.0) {i=28;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (ha>2.0 && ha<=3.0) {i=27;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (ha>1.0 && ha<=2.0) {i=26;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (ha>0.0 && ha<=1.0) {i=25;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (ha>-1.0 && ha<=0.0) {i=24;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (ha>-3.0 && ha<=-1.0) {i=23;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (ha>-5.0 && ha<=-3.0) {i=22;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (ha>-10.0 && ha<=-5.0) {i=21;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (ha<=-10.0) {SkyR=0;SkyG=0;SkyB=0;} //nuit
 	
  }
for(i=0;i<sys->getnbrconstellation();i++)
	{
  for(l=0;l<sys->getconstellation(i)->Nombre;l++){
  // choix de la couleur
  if (RColor==true){
		Couleur=CouleurEtoile(sys,i,l);
		memdc->SelectObject(crayon[Couleur]);memdc->SelectObject(pinceau[Couleur]);
  }
	r=sys->getconstellation(i)->Star[l]->getdeclinaison();
	a=sys->getconstellation(i)->Star[l]->getascensiondroite();
//*************modif begin***********************************
//calcul de teta temps sideral

			 //c'est parti conversion des declin ascdr en azimut hauteur
			 H=teta-(longitude+a);
			 if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
		  ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
			 //maintenant conversion des azimuts/hauteurs en coordonnees *memdc
			 ha=90.0-ha;
			 Az=360.0-Az;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			  if(Az>x2) Az-=360;
			 y=(int)(sys->ScrH()-15 -((ha-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((Az-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));
			 sys->getconstellation(i)->Star[l]->setx(x);
			 sys->getconstellation(i)->Star[l]->sety(y);

//******************************modif end *************************************************
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
	  magg=sys->getconstellation(i)->Star[l]->getmagnitude()+0.01;
				if(magg<Magnitudes) DrawStar(memdc,x,y,magg,CouleurEtoile(sys,i,l),SkyR,SkyG,SkyB,pinceau,crayon,PPrint,NB,RColor,1.,NAME,sys->getconstellation(i)->Star[l]->getnom());

			  }// if x>
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;

  }//for l
}//for i

//******************************
//dessin des messier
if(messier==true){
for(i=0;i<sys->getnbrngc();i++)
	{
	if(sys->getngc(i)->getabrev()[0]=='M'){
	r=sys->getngc(i)->getdeclinaison();
	a=sys->getngc(i)->getascensiondroite();

	if(r<120.0) //si visible de l'hemisphere nord
	  {
			 //c'est parti conversion des declin ascdr en azimut hauteur
			 H=teta-(longitude+a);
			 if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
		  ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
			 //maintenant conversion des azimuts/hauteurs encoordonnees *memdc
			 ha=90.0-ha;
			 Az=360.0-Az;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			  if(Az>x2) Az-=360;
			 y=(int)(sys->ScrH()-15 -((ha-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((Az-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));



			 sys->getngc(i)->setx(x);
			 sys->getngc(i)->sety(y);
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
				x-=16;y-=16;

				if(sys->getngc(i)->gettype()==1 ) memdc->DrawIcon(x,y,Nebuleuse);
				if(sys->getngc(i)->gettype()==2 ) memdc->DrawIcon(x,y,AmasGlobulaire);
				if(sys->getngc(i)->gettype()==3 ) memdc->DrawIcon(x,y,AmasOuvert);
				if(sys->getngc(i)->gettype()==4 ) memdc->DrawIcon(x,y,Galaxie);
				if(sys->getngc(i)->gettype()==5 ) memdc->DrawIcon(x,y,GalaxieElliptique);
				if(sys->getngc(i)->gettype()==6 ) memdc->DrawIcon(x,y,GalaxieSpirale);
				if(sys->getngc(i)->gettype()==7 ) memdc->DrawIcon(x,y,GalaxieSpiraleBarree);
				if(sys->getngc(i)->gettype()==8 ) memdc->DrawIcon(x,y,Galaxie);
				} // if x>
	  x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
	} // if r
	}// if M
}//for i
} //if ngc

//******************************
//dessin des ngc
if(ngcs==true){
for(i=0;i<sys->getnbrngc();i++)
	{
	if (sys->getngc(i)->getabrev()[0]=='N'){
	r=sys->getngc(i)->getdeclinaison();
	a=sys->getngc(i)->getascensiondroite();

	if(r<120.0) //si visible de l'hemisphere nord
	  {
			 //c'est parti conversion des declin ascdr en azimut hauteur
			 H=teta-(longitude+a);
			 if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
		  ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
			 //maintenant conversion des azimuts/hauteurs encoordonnees *memdc
			 ha=90.0-ha;
			 Az=360.0-Az;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			  if(Az>x2) Az-=360;
			 y=(int)(sys->ScrH()-15 -((ha-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((Az-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));



			 sys->getngc(i)->setx(x);
			 sys->getngc(i)->sety(y);
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
				x-=16;y-=16;

				if(sys->getngc(i)->gettype()==1 ) memdc->DrawIcon(x,y,Nebuleuse);
				if(sys->getngc(i)->gettype()==2 ) memdc->DrawIcon(x,y,AmasGlobulaire);
				if(sys->getngc(i)->gettype()==3 ) memdc->DrawIcon(x,y,AmasOuvert);
				if(sys->getngc(i)->gettype()==4 ) memdc->DrawIcon(x,y,Galaxie);
				if(sys->getngc(i)->gettype()==5 ) memdc->DrawIcon(x,y,GalaxieElliptique);
				if(sys->getngc(i)->gettype()==6 ) memdc->DrawIcon(x,y,GalaxieSpirale);
				if(sys->getngc(i)->gettype()==7 ) memdc->DrawIcon(x,y,GalaxieSpiraleBarree);
				if(sys->getngc(i)->gettype()==8 ) memdc->DrawIcon(x,y,Galaxie);
				} // if x>
	  x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
	} // if r
	}// if N
}//for i
} //if messier


//******************************************************************************
// dessin des cometes
int j=0;
while (sys->tabselected[j]!=-1&& j<2999){
	i=sys->tabselected[j++];

	sys->getcomet(i)->calculposition(datum,sys->getsun());
	r=sys->getcomet(i)->getdeclinaison();
	a=sys->getcomet(i)->getascensiondroite();
    H=teta-(longitude+a);
			 if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
		  ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
			 //maintenant conversion des azimuts/hauteurs encoordonnees *memdc
			 ha=90.0-ha;
			 Az=360.0-Az;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			  if(Az>x2) Az-=360;
			 y=(int)(sys->ScrH()-15 -((ha-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((Az-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));
			 // sauvegarde
			 sys->getcomet(i)->setx(x);
			 sys->getcomet(i)->sety(y);
			 // affichage
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
					x-=16;y-=16;
					memdc->DrawIcon(x,y,Comet);
			 } // if x>5...
			 x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;

} // while asteroides
//****************************
// pour le soleil

r=sys->getsun()->getdeclinaison();
a=sys->getsun()->getascensiondroite();

  //	if(((y1<r) && (r<y2)) && ((x1<a) && (a<x2))) //si visible ds la fenetre demande
  //	  {


			 //c'est parti conversion des declin ascdr en azimut hauteur
			 H=teta-(longitude+a);
			 if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
		  ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
			 //maintenant conversion des azimuts/hauteurs encoordonnees *memdc
			 ha=90.0-ha;
			 Az=360.0-Az;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			 if(Az>x2) Az-=360;
			 y=(int)(sys->ScrH()-15 -((ha-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((Az-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));
			  if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){

		 float lx,ly;
					 lx=0.533/2.;
					 ly=lx/float(y2-y1)*(sys->ScrH()-55);
					 lx=lx/float(x2-x1)*(sys->ScrH()-55);
					 if(lx<0) lx=-lx;
					 if(ly<0) ly=-ly;
					 if(lx<3.) lx=3.;
					 if(ly<3.) ly=3.;
					 if(NB==false){
					 memdc->SelectObject(pinceau[6]);
					 memdc->SelectObject(crayon[6]);
					 }
					 else {
					 memdc->SelectObject(pinceau[3]);
					 memdc->SelectObject(crayon[3]);
					 }
						 memdc->Ellipse(x-lx,y-ly,x+lx,y+ly);
					 /*
					y-=16;
			 		x-=16;


					 memdc->DrawIcon(x,y,sol);
					 */


		}  // if x>5...

		//restauration apres le bordel
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
//*************************************************
//lecture du tableau de planete jusqu'a epuisement

for(i=0;i<sys->getnbrplanete();i++)
		{
  if (i==2) i++; // saute la Terre
	angle=sys->getplanete(2)->getlongitude()-sys->getplanete(i)->getlongitude();
  if (angle<-180) angle+=360;
  if (angle>180) angle-=360;
  if (abs(angle)<177){
	r=sys->getplanete(i)->getdeclinaison();
	a=sys->getplanete(i)->getascensiondroite();

  //	if(((y1<r) && (r<y2)) && ((x1<a) && (a<x2))) //si visible ds la fenetre demande
				 //c'est parti conversion des declin ascdr en azimut hauteur
			 H=teta-(longitude+a);
			if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
			ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
			 //maintenant conversion des azimuts/hauteurs encoordonnees *memdc
			 ha=90.0-ha;
			 Az=360.0-Az;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			 if(Az>x2) Az-=360;
			 y=(int)(sys->ScrH()-15 -((ha-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((Az-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));


		 // sauvegarde pour information
		 sys->getplanete(i)->setx(x);
		 sys->getplanete(i)->sety(y);
			  if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
			 y-=16;
			 x-=16;
			//epuisons les objets connus

			if(strcmp(sys->getplanete(i)->getnom(),"Mercure")==0)
				{  memdc->DrawIcon(x,y,Merc);}

			if(strcmp(sys->getplanete(i)->getnom(),"Venus")==0)
				{  memdc->DrawIcon(x,y,Venu);}

			if(strcmp(sys->getplanete(i)->getnom(),"Mars")==0)
				{  memdc->DrawIcon(x,y,Mar);}

			if(strcmp(sys->getplanete(i)->getnom(),"Jupiter")==0)
				{  memdc->DrawIcon(x,y,Jupi);}

			if(strcmp(sys->getplanete(i)->getnom(),"Saturne")==0)
				{  memdc->DrawIcon(x,y,Satu);}

			if(strcmp(sys->getplanete(i)->getnom(),"Uranus")==0)
				{  memdc->DrawIcon(x,y,Uranus);}

			if(strcmp(sys->getplanete(i)->getnom(),"Neptune")==0)
				{  memdc->DrawIcon(x,y,Neptune);}

			if(strcmp(sys->getplanete(i)->getnom(),"Pluton")==0)
				{  memdc->DrawIcon(x,y,Plut);
				}
			}// if x>5 ...
			//restauration apres le bordel
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;

	  }// if 170
}  // for planete
//************************************
 // pour la lune

			r=sys->getplanete(2)->getsatellite(0)->getdeclinaison();
			 a=sys->getplanete(2)->getsatellite(0)->getascensiondroite();

			// if(((y1<r) && (r<y2)) && ((x1<a) && (a<x2))){ //si visible ds la fenetre demande


			 //c'est parti conversion des declin ascdr en azimut hauteur
			 H=teta-(longitude+a);
			 if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
		   ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
			 //maintenant conversion des azimuts/hauteurs encoordonnees *memdc
			 ha=90.0-ha;
			 Az=360.0-Az;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			  if(Az>x2) Az-=360;
			 y=(int)(sys->ScrH()-15 -((ha-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((Az-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));



					 sys->getplanete(2)->getsatellite(0)->setx(x);
					 sys->getplanete(2)->getsatellite(0)->sety(y);
					  if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
				 double lx,ly;
					 lx=180./M_PI*sys->getplanete(2)->getsatellite(0)->getrayon()/1000*sys->getplanete(2)->getsatellite(0)->getdistancealamere();
					 ly=lx/float(y2-y1)*(sys->ScrH()-55);
					 lx=lx/float(x2-x1)*(sys->ScrH()-55);
                if(lx<0) lx=-lx;
					 if(ly<0) ly=-ly;
					 if(lx<3.) lx=3.;
					 if(ly<3.) ly=3.;
					 if(NB==false){
					 memdc->SelectObject(pinceau[1]);
					 memdc->SelectObject(crayon[1]);
					 }
					 else {
					 memdc->SelectObject(pinceau[3]);
					 memdc->SelectObject(crayon[3]);
					 }
					 memdc->Ellipse(x-lx,y-ly,x+lx,y+ly);


			  //	  x-=16;y-=16;		memdc->DrawIcon(x,y,Lune);

			  } // if x>5 ...
	  //restauration apres le bordel
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;

			fincausediv0 :


Neptune.~TIcon();
Uranus.~TIcon();
Comet.~TIcon();
Lune.~TIcon();
GalaxieSpirale.~TIcon();
GalaxieSpiraleBarree.~TIcon();
GalaxieElliptique.~TIcon();
AmasOuvert.~TIcon();
AmasGlobulaire.~TIcon();
Galaxie.~TIcon();
Merc.~TIcon();
Venu.~TIcon();
Mar.~TIcon();
Jupi.~TIcon();
Satu.~TIcon();
Plut.~TIcon();
Nebuleuse.~TIcon();
sol.~TIcon();
Eclipse1.~TIcon();
Eclipse2.~TIcon();

delete datetronquee;
}