//--------------------------------------------------------------------------
// Plantarium -- Copyright (c) 1998 
//--------------------------------------------------------------------------
#include <owl\owlpch.h>
#include <stdlib.h> // conversion int -> string

#pragma hdrstop

#include "conjdial.h"

// pour entrer la date

// pour les combobox
static dialogs1Xfer dialogs1Data;


TDialogConjonctions::TDialogConjonctions( TWindow* parent,date2* datum1,date2* datum2 ):
	 TDialog( parent, DIALOG_CONJ) {

	 box_annee=new TComboBox(this,IDC_COMBOBOX_ANNEE);
	 box_mois=new TComboBox(this,IDC_COMBOBOX_MOIS);
	 box_jour=new TComboBox(this,IDC_COMBOBOX_JOUR);
	 box_heure=new TComboBox(this,IDC_COMBOBOX_HEURE);

	 box_annee2=new TComboBox(this,IDC_COMBOBOX_ANNEE2);
	 box_mois2=new TComboBox(this,IDC_COMBOBOX_MOIS2);
	 box_jour2=new TComboBox(this,IDC_COMBOBOX_JOUR2);
	 box_heure2=new TComboBox(this,IDC_COMBOBOX_HEURE2);

	 SetTransferBuffer(&dialogs1Data); // l ou stocke les donnees des combobo
	 d=datum1;
	 d2=datum2;
  }
TDialogConjonctions::~TDialogConjonctions(){
	box_annee->~TComboBox();
	box_mois->~TComboBox();
	box_jour->~TComboBox();
	box_heure->~TComboBox();

	box_annee2->~TComboBox();
	box_mois2->~TComboBox();
	box_jour2->~TComboBox();
	box_heure2->~TComboBox();
	}
/// -----------------------------------------------------------
void TDialogConjonctions::SetupWindow() {
	 TDialog::SetupWindow();
	 // sauvegarde pour le cas ou cancel
	 annee=d->getannee();
	 mois=d->getmois();
	 jour=d->getjour();
	 heure=d->getheure();
	 //
	 int i=1;
	 char string[5];
	 // entree des annee;
	 for(i=anneedebut;i<anneefin;i++){
		box_annee->AddString(itoa(i,string,10));
	 }
	 box_annee->SetText(itoa(d->getannee(),string,10));

	 // entree des mois
	 box_mois->AddString("Janvier");
	 box_mois->AddString("Fvrier");
	 box_mois->AddString("Mars");
	 box_mois->AddString("Avril");
	 box_mois->AddString("Mai");
	 box_mois->AddString("Juin");
	 box_mois->AddString("Juillet");
	 box_mois->AddString("Aout");
	 box_mois->AddString("Septembre");
	 box_mois->AddString("Octobre");
	 box_mois->AddString("Novembre");
	 box_mois->AddString("Dcembre");

	 box_mois->SetSelIndex(d->getmois()-1);

	 // entree des jours

	 for(i=1;i<=31;i++){
	 box_jour->AddString(itoa(i,string,10));
	 }
	 ModifMois();// pour supprimer le 31 ...
	 box_jour->SetSelIndex(d->getjour()-1);

	  // entree des heures

	 for(i=0;i<=23;i++){
	 box_heure->AddString(itoa(i,string,10));
	 }
	 box_heure->SetSelIndex(d->getheure());
// date 2

for(i=anneedebut;i<anneefin;i++){
		box_annee2->AddString(itoa(i,string,10));
	 }
	 box_annee2->SetText(itoa(d2->getannee(),string,10));

	 // entree des mois
	 box_mois2->AddString("Janvier");
	 box_mois2->AddString("Fvrier");
	 box_mois2->AddString("Mars");
	 box_mois2->AddString("Avril");
	 box_mois2->AddString("Mai");
	 box_mois2->AddString("Juin");
	 box_mois2->AddString("Juillet");
	 box_mois2->AddString("Aout");
	 box_mois2->AddString("Septembre");
	 box_mois2->AddString("Octobre");
	 box_mois2->AddString("Novembre");
	 box_mois2->AddString("Dcembre");

	 box_mois2->SetSelIndex(d2->getmois()-1);

	 // entree des jours

	 for(i=1;i<=31;i++){
	 box_jour2->AddString(itoa(i,string,10));
	 }
	 ModifMois2();// pour supprimer le 31 ...
	 box_jour2->SetSelIndex(d2->getjour()-1);

	  // entree des heures

	 for(i=0;i<=23;i++){
	 box_heure2->AddString(itoa(i,string,10));
	 }
	 box_heure2->SetSelIndex(d2->getheure());
  }
  /// -----------------------------------------------------------
  /// -----------------------------------------------------------
void TDialogConjonctions::EvPaint() {
	 TDialog::EvPaint();
	 }

void TDialogConjonctions::Ignore() {}
void TDialogConjonctions::Fin2(){   // cancel
	d->setannee(annee);
	d->setmois(mois);
	d->setjour(jour);
	d->setheure(heure);
		d->miseajour();
 // vide les boites
      	  int i;
	for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
	for(i=0;i<12;i++) box_mois->DeleteString(0);
	for(i=0;i<31;i++) box_jour->DeleteString(0);
	for(i=0;i<24;i++) box_heure->DeleteString(0);
	for(i=0;i<anneefin-anneedebut;i++) box_annee2->DeleteString(0);
	for(i=0;i<12;i++) box_mois2->DeleteString(0);
	for(i=0;i<31;i++) box_jour2->DeleteString(0);
	for(i=0;i<24;i++) box_heure2->DeleteString(0);
	CloseWindow(IDCANCEL);
}
void TDialogConjonctions::Fin(){ // OK

	 d->setannee(box_annee->GetSelIndex()+anneedebut);
	 d->setmois(box_mois->GetSelIndex()+1);
	 d->setjour(box_jour->GetSelIndex()+1);
	 d->setheure(box_heure->GetSelIndex());
	 d->miseajour();

	 d2->setannee(box_annee2->GetSelIndex()+anneedebut);
	 d2->setmois(box_mois2->GetSelIndex()+1);
	 d2->setjour(box_jour2->GetSelIndex()+1);
	 d2->setheure(box_heure2->GetSelIndex());
	 d2->miseajour();

	int i;
	for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
	for(i=0;i<12;i++) box_mois->DeleteString(0);
	for(i=0;i<31;i++) box_jour->DeleteString(0);
	for(i=0;i<24;i++) box_heure->DeleteString(0);
	for(i=0;i<anneefin-anneedebut;i++) box_annee2->DeleteString(0);
	for(i=0;i<12;i++) box_mois2->DeleteString(0);
	for(i=0;i<31;i++) box_jour2->DeleteString(0);
	for(i=0;i<24;i++) box_heure2->DeleteString(0);

	CloseWindow(IDOK);
  }
  /// -----------------------------------------------------------
  /// -----------------------------------------------------------

void TDialogConjonctions::ModifAnnee(){

	int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();
	  //regarde si annee bixetile ou non et si on est au mois de fevrier
	 if ((year)%4!=0){ //annee non bixetile
			if (mois==1 && box_jour->FindString("29", 0)>=0 ){
					box_jour->DeleteString(28);
					if (day==29) box_jour->SetText("28");
			}
	 }
	 else {
		 if (mois==1 && box_jour->FindString("29", 1)<0 ){
					box_jour->AddString("29");
			}

	 }

}
/// -----------------------------------------------------------
void TDialogConjonctions::ModifMois(){

	 int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();

	 if ( box_jour->FindString("29", 0)<0) box_jour->AddString("29");
	 if ( box_jour->FindString("30", 0)<0) box_jour->AddString("30");
	 // il y a au moins trente jours pour chaque mois
	 if (mois==0 || mois==2 || mois==4 || mois==6 || mois==7 || mois==9 || mois==11){

			// mois a 31 jour mais il manque le 31e jour
			if (box_jour->FindString("31", 0)<0) box_jour->AddString("31");
	 }
	 else{// autres mois sauf fevrier (fevrier=1)
			if (mois!=1 && box_jour->FindString("31", 0)>=0 ){
					box_jour->DeleteString(30);
					if (day==31) box_jour->SetText("30");
			}
			else{   // mois de fevrier
				if (mois==1){
					  if ((year)%4!=0){ // annee non bissextile
							if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (box_jour->FindString("29", 0)>=0) box_jour->DeleteString(28);
							if (day>28) box_jour->SetText("28");
					  }
					  else {  // annee bissextile
							if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (day>28) box_jour->SetText("29");
					  }
				}
			}
	 }

}
/// -----------------------------------------------------------
void TDialogConjonctions::ModifJour(){
	
}
/// -----------------------------------------------------------
/// -----------------------------------------------------------

// pour la 2e date
void TDialogConjonctions::ModifAnnee2(){

	int year,mois,day;

	 year=box_annee2->GetSelIndex()+anneedebut;
	 day=box_jour2->GetSelIndex()+1;
	 mois=box_mois2->GetSelIndex();
	  //regarde si annee bixetile ou non et si on est au mois de fevrier
	 if ((year)%4!=0){ //annee non bixetile
			if (mois==1 && box_jour2->FindString("29", 0)>=0 ){
					box_jour2->DeleteString(28);
					if (day==29) box_jour2->SetText("28");
			}
	 }
	 else {
		 if (mois==1 && box_jour2->FindString("29", 1)<0 ){
					box_jour2->AddString("29");
			}

	 }

}

void TDialogConjonctions::ModifMois2(){

	 int year,mois,day;

	 year=box_annee2->GetSelIndex()+anneedebut;
	 day=box_jour2->GetSelIndex()+1;
	 mois=box_mois2->GetSelIndex();

	 if ( box_jour2->FindString("29", 0)<0) box_jour2->AddString("29");
	 if ( box_jour2->FindString("30", 0)<0) box_jour2->AddString("30");
	 // il y a au moins trente jours pour chaque mois
	 if (mois==0 || mois==2 || mois==4 || mois==6 || mois==7 || mois==9 || mois==11){
			// mois a 31 jour mais il manque le 31e jour
			if (box_jour2->FindString("31", 0)<0)box_jour2->AddString("31");
	 }
	 else{// autres mois sauf fevrier et il y a le 31e jour en trop
			if (mois!=1 && box_jour2->FindString("31", 0)>=0 ){
					box_jour2->DeleteString(30);
					if (day==31) box_jour2->SetText("30");
			}
			else{   // mois de fevrier
				if (mois==1){
					  if ((year)%4!=0){ // annee non bissextile
							if (box_jour2->FindString("31", 0)>=0) box_jour2->DeleteString(30);
							if (box_jour2->FindString("30", 0)>=0) box_jour2->DeleteString(29);
							if (box_jour2->FindString("29", 0)>=0) box_jour2->DeleteString(28);
							if (day>28) box_jour2->SetText("28");
					  }
					  else {  // annee bissextile
							if (box_jour2->FindString("31", 0)>=0) box_jour2->DeleteString(30);
							if (box_jour2->FindString("30", 0)>=0) box_jour2->DeleteString(29);
							if (day>28) box_jour2->SetText("29");
					  }
				}
			}
	 }

}
void TDialogConjonctions::ModifJour2(){
	
}



DEFINE_RESPONSE_TABLE1( TDialogConjonctions, TDialog )
  EV_WM_PAINT,

  EV_COMMAND( IDOK, Fin ),
  EV_COMMAND( IDCANCEL, Fin2 ),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_ANNEE,ModifAnnee),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_MOIS,ModifMois),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_JOUR,ModifJour),

  EV_CBN_SELCHANGE(IDC_COMBOBOX_ANNEE2,ModifAnnee2),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_MOIS2,ModifMois2),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_JOUR2,ModifJour2),

END_RESPONSE_TABLE;


