#ifndef _DATE
#define _DATE
#include <assert.h>
#include <math.h>   // pour utiliser floor dans date2::miseajour(void)
#include <owl/dc.h>


class date2 {
	public:
	  //GMT, la date
	  int heure;
	  int jour;
	  int mois;
	  int annee;
	  int minute;
	  long double sieclejulien;

	  double sbgmt,slgmt;//shift babasse GMT, et shift lieu utilis GMT
	  int saison; //heure d't ou d'hiver?

  public:
	  date2(void);
	  date2(int,int,int,int,int); // contruit et met  jour sieclejulien
	  ~date2(void);       // destructeur
	  int getheure(void);
	  int getjour(void);
	  int getmois(void);
	  int getannee(void);
	  int getminute(void);
	  long double getsieclejulien(void);


	  void setheure(int);
	  void setjour(int);
	  void setmois(int);
	  void setannee(int);
	  void setminute(int);
	  void setsieclejulien(long double);

	  void miseajour(void);    // calcul sieclejulien a partir des autres donnees
	  void antimiseajour(void);  //  operation inverse

	  void ajoutheure(long int);   //fonction d'incrmentation utile pour les animations, ajoute int heures
	  void ajoutminute(int);   //fonction d'incrmentation utile pour les animations, ajoute int heures
	  void ajouterheuredecimale(double); //incrementation d'un certain pas d'heure

	  //gestion decalages horaires
	  double setshift(char*); //donne un pays et une saison et retourne le dec horaire
     void setsaison();//heure d'ete ou d'hiver?
     

	  // pour l'affichage gmt
	  void afficherdate(TMemoryDC&memdc, int x,int y,bool PPrint=false);    // affiche la date sous le format "date:jj/mm/aa" a la position x,y de l'ecran
	  void afficherdateheure(TMemoryDC&memdc, int x,int y,bool PPrint=false,bool opaq=false);// affiche l'heure en plus de la date
	  void afficherj(TMemoryDC&memdc, int x,int y,bool PPrint=false);  // affiche la date en siecle julien
	  void date3(char* datte);  // renvoie la date
     void date4(char *datte); //renvoie'heure + la date

	  






};

#endif
