//--------------------------------------------------------------------------
// Le plantarium -- Copyright (c) 1998
//--------------------------------------------------------------------------
#ifndef DIALOGS_H
#define DIALOGS_H

#include <owl/dialog.h>
#include <owl/static.h>
#include <owl/button.h>
#include <owl/listbox.h>
#include <owl/combobox.h>

#include "constant.h"
#include "date.h"

#include "planetar.rh"


// pour les combobox
struct dialogsXfer {
//{{mainXFER_DATA}}
	 TComboBoxData  box_annee;
	 TComboBoxData  box_mois;
	 TComboBoxData  box_jour;
	 TComboBoxData  box_heure;
//{{mainXFER_DATA_END}}
};

class TDialogDate: public TDialog {
private:

	TComboBox * box_annee;
	TComboBox * box_mois;
	TComboBox * box_jour;
	TComboBox * box_heure;
   int annee,mois,jour,heure; // sauvegarde pour le cas ou cancel
   date2 *d;
	int result;  //=0 si cancel, 1 sinon

public:
  TDialogDate( TWindow* parent,date2*datum );
  ~TDialogDate();
  void SetupWindow() ;
  void EvPaint() ;

  int  Execute() ;
  void Ignore();
  void Fin();
  void Fin2();

  void ModifAnnee();
  void ModifMois();
  void ModifJour();

  // pour les fonctions declenches par les boutons
  DECLARE_RESPONSE_TABLE( TDialogDate );
};

class TDialogAbout: public TDialog {
private:

public:
  TDialogAbout( TWindow* parent );
  ~TDialogAbout();
  void SetupWindow();
  void EvPaint() ;
  void EvLButtonDown(uint modKeys, TPoint& point);
  void Fin();

  // pour les fonctions declenches par les boutons
  DECLARE_RESPONSE_TABLE( TDialogAbout );
};



#endif // DIALOGS_H
