#include "cartecie.h"

// dessin des etoiles avec une tache flou

void mercator_affichercoordonnee(double asc,double dec,TMemoryDC &memdc,systeme* sys){
	memdc.SetBkColor(RGB(200,200,200));
	memdc.SetBkMode(OPAQUE);
	memdc.SetTextColor(RGB(0,0,0));
		char txt[50];
		char decc[15],ascc[15];
		Convert_A_H(asc,ascc);
		Convert_A_H2(dec,decc);
	sprintf(txt,"Asc:%s Dc:%s    ",ascc,decc);
 //	sprintf(txt,"Asc:%3.2lf Dc:%3.2lf    ",asc,dec);
	memdc.TextOut(sys->ScrL()+30,sys->ScrH()-20,txt,strlen(txt));
	memdc.SetBkMode(TRANSPARENT);
}

void azimutal_affichercoordonnee(double azim,double haut,TMemoryDC &memdc,systeme* sys){
	memdc.SetBkColor(RGB(200,200,200));
	memdc.SetBkMode(OPAQUE);
	memdc.SetTextColor(RGB(0,0,0));
		char txt[50];

	sprintf(txt,"Azim:%3.2lf Haut:%3.2lf    ",azim,haut);
	memdc.TextOut(sys->ScrL()+30,sys->ScrH()-20,txt,strlen(txt));
	memdc.SetBkMode(TRANSPARENT);
}

//----------------

void DrawStar(TMemoryDC *memdc,int x,int y,double magni,int Couleur,int SkyR,int SkyG,int SkyB,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB,bool RColor,double coef,bool NAME,char* name){
 if (PPrint==true){
 			if(magni<=coef*2.5 && magni>0 && NAME==TRUE && strlen(name)>2){
					 memdc->SetTextColor(RGB(0,0,0));
					 //memdc->SetBkColor(RGB(255,200,180));
					 memdc->SetBkMode(TRANSPARENT);
					 memdc->TextOut(x+5,y-3,name,strlen(name));
					// memdc->SetBkMode(TRANSPARENT);
				 }
         memdc->SelectObject(crayon[Couleur]);memdc->SelectObject(pinceau[Couleur]);
			if(magni>90&&magni<190){  //etoile variable
					magni-=100;
			}
			if(magni>190&&magni<290){  //etoile double
					 magni-=200;
			}
			if(magni>=coef*3.5 && magni<90){
					if (NB==true ||RColor==false) memdc->SetPixel(x,y,RGB(0,0,0));
					else{
							if (Couleur==0) {memdc->SetPixel(x,y,RGB(0,0,70));}
							if (Couleur==1) {memdc->SetPixel(x,y,RGB(255,255,255));}
							if (Couleur==2) {memdc->SetPixel(x,y,RGB(255,0,0));}
							if (Couleur==3) {memdc->SetPixel(x,y,RGB(0,0,0));}
							if (Couleur==4) {memdc->SetPixel(x,y,RGB(0,0,255));}
							if (Couleur==5) {memdc->SetPixel(x,y,RGB(200,0,0));}
							if (Couleur==6) {memdc->SetPixel(x,y,RGB(255,255,0));}
							if (Couleur==7) {memdc->SetPixel(x,y,RGB(255,125,0));}
							if (Couleur==8) {memdc->SetPixel(x,y,RGB(255,0,255));}
							if (Couleur==9) {memdc->SetPixel(x,y,RGB(0,255,0));}
							if (Couleur==10) {memdc->SetPixel(x,y,RGB(0,255,255));}
							if (Couleur==11) {memdc->SetPixel(x,y,RGB(100,150,0));}
							if (Couleur==12) {memdc->SetPixel(x,y,RGB(100,200,200));}
							if (Couleur==13) {memdc->SetPixel(x,y,RGB(120,120,200));}
							if (Couleur==14) {memdc->SetPixel(x,y,RGB(255,255,155));}
							if (Couleur==15) {memdc->SetPixel(x,y,RGB(0,0,100));}
                  }
			}
			 if(magni<=coef*3.5 && magni>coef*2.5)
				{  //DrawIcon(*memdc,x,y,Moyenneetoile);
					if (NB==true||RColor==false){ memdc->SelectObject(crayon[0]);memdc->SelectObject(pinceau[0]);}
					memdc->Ellipse(x-1,y-1,x+1,y+1);

				}
			 if(magni<=coef*2.5 && magni>0)
				{  //DrawIcon(*memdc,x,y,Moyenneetoile);
					 if (NB==true||RColor==false){ memdc->SelectObject(crayon[0]);memdc->SelectObject(pinceau[0]);}
					memdc->Ellipse(x-2,y-2,x+2,y+2);

				}

			if(magni<=0)
				{ 	 if (NB==true||RColor==false) {memdc->SelectObject(crayon[0]);memdc->SelectObject(pinceau[0]);}
					memdc->Ellipse(x-3,y-3,x+3,y+3);

				} //if magni
 }
 else { // pas d'impression
				 // nom des toiles
				 if(magni<=coef*2.5 && magni>0 && NAME==TRUE && strlen(name)>2){
					 memdc->SetTextColor(RGB(255,255,255));
					// memdc->SetBkColor(RGB(255,200,180));
					 memdc->SetBkMode(TRANSPARENT);
					 memdc->TextOut(x+5,y-3,name,strlen(name));
				 //   memdc->SetBkMode(TRANSPARENT);
				 }
		  if (RColor==true){memdc->SelectObject(crayon[Couleur]);memdc->SelectObject(pinceau[Couleur]);}
		  else{memdc->SelectObject(crayon[1]);memdc->SelectObject(pinceau[1]);}
		  int StarR,StarG,StarB;
		  if (RColor==false) {StarR=255,StarB=255,StarG=255;}
		  else{
							if (Couleur==0) {StarR=0,StarG=0,StarB=70;}
							if (Couleur==1) {StarR=255,StarG=255,StarB=255;}
							if (Couleur==2) {StarR=255,StarG=0,StarB=0;}
							if (Couleur==3) {StarR=0,StarG=0,StarB=0;}
							if (Couleur==4) {StarR=0,StarG=0,StarB=255;}
							if (Couleur==5) {StarR=200,StarG=0,StarB=70;}
							if (Couleur==6) {StarR=255,StarG=255,StarB=0;}
							if (Couleur==7) {StarR=255,StarG=125,StarB=0;}
							if (Couleur==8) {StarR=255,StarG=0,StarB=255;}
							if (Couleur==9) {StarR=0,StarG=255,StarB=0;}
							if (Couleur==10) {StarR=0,StarG=255,StarB=255;}
							if (Couleur==11) {StarR=100,StarG=150,StarB=0;}
							if (Couleur==12) {StarR=100,StarG=200,StarB=200;}
							if (Couleur==13) {StarR=120,StarG=120,StarB=200;}
							if (Couleur==14) {StarR=255,StarG=255,StarB=155;}
							if (Couleur==15) {StarR=0,StarG=0,StarB=100;}
						}
			if(magni>90&&magni<190){  //etoile variable
					magni-=100;
			}
			if(magni>190&&magni<290){  //etoile double
					 magni-=200;
			}
			if(magni>=coef*3.5 && magni<90){

					 //
					 //magni=magni*magni;
					 StarR=(float)(StarR-SkyR)*coef*2.5/((magni))+SkyR;
					 StarG=(float)(StarG-SkyG)*coef*2.5/((magni))+SkyG;
					 StarB=(float)(StarB-SkyB)*coef*2.5/((magni))+SkyB;
					 memdc->SetPixel(x,y,RGB(StarR,StarG,StarB));


			}
			 if(magni<=coef*3.5 && magni>coef*2.5)
				{  //DrawIcon(*memdc,x,y,Moyenneetoile);
					if (NB==true){ memdc->SelectObject(crayon[0]);memdc->SelectObject(pinceau[0]);}
			  //		memdc->Ellipse(x-1,y-1,x+1,y+1);
					//
               memdc->SetPixel(x,y,RGB(StarR,StarG,StarB));
					 StarR=(StarR+SkyR)/2.;
					 StarG=(StarG+SkyG)/2.;
					 StarB=(StarB+SkyB)/2.;
					 memdc->SetPixel(x,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y,RGB(StarR,StarG,StarB));
					 //
					 StarR=(StarR*2.+SkyR)/3.;
					 StarG=(StarG*2.+SkyG)/3.;
					 StarB=(StarB*2.+SkyB)/3.;
					 memdc->SetPixel(x+1,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y-1,RGB(StarR,StarG,StarB));

				}
			 if(magni<=coef*2.5 && magni>0)
				{  //DrawIcon(*memdc,x,y,Moyenneetoile);
					 if (NB==true){ memdc->SelectObject(crayon[0]);memdc->SelectObject(pinceau[0]);}
					//
					 memdc->SetPixel(x,y,RGB(StarR,StarG,StarB));
					 StarR=(StarR*2.+SkyR)/3.;
					 StarG=(StarG*2.+SkyG)/3.;
					 StarB=(StarB*2.+SkyB)/3.;
					 memdc->SetPixel(x,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y,RGB(StarR,StarG,StarB));
					 StarR=(StarR*2.+SkyR)/3.;
					 StarG=(StarG*2.+SkyG)/3.;
					 StarB=(StarB*2.+SkyB)/3.;
					 memdc->SetPixel(x+1,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y-1,RGB(StarR,StarG,StarB));
					 StarR=(StarR*2.+SkyR)/3.;
					 StarG=(StarG*2.+SkyG)/3.;
					 StarB=(StarB*2.+SkyB)/3.;
					 memdc->SetPixel(x,y+2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x,y-2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+2,y,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-2,y,RGB(StarR,StarG,StarB));
					 StarR=(StarR*2.+SkyR)/3.;
					 StarG=(StarG*2.+SkyG)/3.;
					 StarB=(StarB*2.+SkyB)/3.;
					 memdc->SetPixel(x+2,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+2,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y+2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y-2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y+2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y-2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-2,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-2,y-1,RGB(StarR,StarG,StarB));
									}

			if(magni<=0)
				{ 	 if (NB==true) {memdc->SelectObject(crayon[0]);memdc->SelectObject(pinceau[0]);}
					 memdc->SetPixel(x,y,RGB(StarR,StarG,StarB));
					 StarR=(StarR*4.+SkyR)/5.;
					 StarG=(StarG*4.+SkyG)/5.;
					 StarB=(StarB*4.+SkyB)/5.;
					 memdc->SetPixel(x,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y,RGB(StarR,StarG,StarB));
					 StarR=(StarR*4.+SkyR)/5.;
					 StarG=(StarG*4.+SkyG)/5.;
					 StarB=(StarB*4.+SkyB)/5.;
					 memdc->SetPixel(x+1,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y-1,RGB(StarR,StarG,StarB));
					 StarR=(StarR*4.+SkyR)/5.;
					 StarG=(StarG*4.+SkyG)/5.;
					 StarB=(StarB*4.+SkyB)/5.;
					 memdc->SetPixel(x,y+2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x,y-2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+2,y,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-2,y,RGB(StarR,StarG,StarB));
					 StarR=(StarR*4.+SkyR)/5.;
					 StarG=(StarG*4.+SkyG)/5.;
					 StarB=(StarB*4.+SkyB)/5.;
					 memdc->SetPixel(x+2,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+2,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y+2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y-2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y+2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y-2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-2,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-2,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x,y+3,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x,y-3,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+3,y,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-3,y,RGB(StarR,StarG,StarB));
					 StarR=(StarR*2.+SkyR)/3.;
					 StarG=(StarG*2.+SkyG)/3.;
					 StarB=(StarB*2.+SkyB)/3.;
					 memdc->SetPixel(x+1,y+3,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+1,y-3,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y+3,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-1,y-3,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+3,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+3,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-3,y+1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-3,y-1,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+2,y+2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+2,y-2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-2,y+2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-2,y-2,RGB(StarR,StarG,StarB));
					 StarR=(StarR+SkyR)/2.;
					 StarG=(StarG+SkyG)/2.;
					 StarB=(StarB+SkyB)/2.;
					 memdc->SetPixel(x+2,y+3,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+2,y-3,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-2,y+3,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-2,y-3,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+3,y+2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x+3,y-2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-3,y+2,RGB(StarR,StarG,StarB));
					 memdc->SetPixel(x-3,y-2,RGB(StarR,StarG,StarB));

				} //if magni



 }

}
