#ifndef GSC_FIT_FORMAT_H
#define GSC_FIT_FORMAT_H


struct ListeFichierGsc{
	int Nombre;
	int Numero[40]; // 10: nombre maximum de fichier gsc a ouvrir
	double Dec[40]; // pour connaitre le rpertoire : abscisse du bas
};
struct GscInfo{
	double asc;
	double dec;
	double mag;
};

// connaitre la page
 int AllerDebutFichierRegion(FILE * fitfile);
 int LireRegion(FILE *fitfile,double Asclo,double Aschi,double Declo,double Dechi);
 ListeFichierGsc LireFichierRegion (int disk,double Asclo,double Aschi,double Declo,double Dechi);
 char * RepertoireCd(int n);

 // lire la position et la magnitude d'une toile
GscInfo LireGSC(FILE *fitfile);
int AllerDebutFichierGSC(FILE * fitfile);
// lire petite region
int AllerDebutFichierSmallRegion(FILE * fitfile);
void LireSmallRegion(FILE *fitfile,ListeFichierGsc &tableau);
void LireRegionS(FILE *fitfile,int n,ListeFichierGsc &tableau);
// convertir un tableau d'octets en double
double AssemblerOctets(int *tab,int n);
int AssemblerOctetsInt(int *tab,int n);




#endif
