#include "heliocen.h"
#include "horaire.h"

void helio_trajec(systeme *sys,TMemoryDC & memdc2, Plan P,int k,HBRUSH pinceau[16],HPEN crayon[16],bool PPrint,bool ){
	// dessin du fond
	if (PPrint==false){ memdc2.SelectObject (crayon[2]); memdc2.SelectObject (pinceau[3]);}
		else { memdc2.SelectObject(crayon[0]); memdc2.SelectObject(pinceau[1]);}
	memdc2.Rectangle(5,45,sys->ScrL()-5,sys->ScrH()-7);

	// dessin des lignes
	if (PPrint==false) {memdc2.SelectObject (pinceau[1]);memdc2.SelectObject(crayon[1]);}  // blanc
	else {memdc2.SelectObject(pinceau[3]);memdc2.SelectObject(crayon[3]);}    // noir

	FILE*fptr1=fopen("trajec.spi","rt");
  //	FILE*fptr2=fopen("test.txt","wt");
	int i,num;
	char name[30];
	//contre les warning
			strcpy(name,"");
	//
	Vecteur Data;      // pt 3d
	BPoint Sortie,Ante;     // pt 2d
	//contre les warning
			Ante.X=0;Ante.Y=0;
	//
	float zoom;
	if (k>=1) zoom=k;
	else zoom=sqrt(1./(2.-(float)k));
	double Zoom=1000.*zoom;

	fscanf(fptr1,"%s",name);
  //	fprintf(fptr2,"%s",name);
	while(strcmp(name,"fin")!=0){
		fscanf(fptr1," %d\n",&num);
		//fprintf(fptr2," %d\n",num);
		for(i=0;i<num;i++){
			// calcul position
			fscanf(fptr1,"%lf %lf %lf\n",&Data.X,&Data.Y,&Data.Z);
		 //	fprintf(fptr2,"%lf %lf %lf\n",Data.X,Data.Y,Data.Z);
			// conversion en 2d
			Sortie=InterPlan2(Data,P);

			Sortie.X=(int)(Zoom*Sortie.X)+(sys->ScrL()-10)/2;
			Sortie.Y=40-(int)(Zoom*Sortie.Y)+(sys->ScrH()-45)/2;
			if(i>0
				&&	(Sortie.X>6) && (Sortie.Y>41)&&(Sortie.X<sys->ScrL()-6) && (Sortie.Y<sys->ScrH()-8)
				&& (Ante.X>6) && (Ante.Y>41)&&(Ante.X<sys->ScrL()-6) && (Ante.Y<sys->ScrH()-8)
				 )
			{
				 if (PPrint==false) {
						if(Data.Z>=0.) memdc2.SelectObject(crayon[1]);
						else memdc2.SelectObject(crayon[20]);
				 }
				memdc2.MoveTo(Ante.X,Ante.Y);
				memdc2.LineTo(Sortie.X,Sortie.Y);
			}
			Ante.X=Sortie.X;
			Ante.Y=Sortie.Y;
		}
		fscanf(fptr1,"\n%s",name);
	 //	fprintf(fptr2,"\n%s",name);
	}  // while
	fclose(fptr1);
  //	fclose(fptr2);


}  // fin fonction

void helio3d(date2* datum,systeme *sys,TMemoryDC & memdc,TMemoryDC & memdc2, Plan P,int k,HBRUSH pinceau[16],HPEN crayon[16],bool PPrint,bool NB){
//sys: pointeur sur le systeme
sys->calculposition(datum);
if (PPrint==false) {memdc.SelectObject(pinceau[0]);memdc.SelectObject(crayon[0]);}
else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[1]);}
	memdc.SetTextColor(RGB(200,0,0));
//	SetBkColor(memdc,RGB(120,120,200));
//definition d'un carre sur lequel est affiche les planetes

int iccon;
if (NB==true && PPrint==true) iccon=20;
	else iccon=0;
TIcon Mars(_hInstance,(TResId)(mar-iccon));  // mars = surnom de l'icone
TIcon Merc(_hInstance,(TResId)(merc-iccon));
TIcon Venu(_hInstance,(TResId)(venu-iccon));
TIcon Satu(_hInstance,(TResId)(satu-iccon));
TIcon Jupi(_hInstance,(TResId)(jupi-iccon));
TIcon Uran(_hInstance,(TResId)(uranus-iccon));
TIcon Nept(_hInstance,(TResId)(neptune-iccon));
TIcon Plut(_hInstance,(TResId)(pluton-iccon));
TIcon Sole(_hInstance,(TResId)(solei-iccon));  //Icone du soleil
//TIcon Lune(_hInstance,moyen);  //Icone de la lune
TIcon Terr(_hInstance,(TResId)(terr-iccon)); //Icone de la Terre
TIcon Planeteinconnue(_hInstance,(TResId)(grand));
TIcon Comet(_hInstance,(TResId)(commet-iccon));


float zoom;
if (k>=1) zoom=k;
else zoom=sqrt(1./(2.-(float)k));
	// dessin du fond
	if (PPrint==false){ memdc2.SelectObject (crayon[2]); memdc2.SelectObject (pinceau[3]);}
		else { memdc2.SelectObject(crayon[0]); memdc2.SelectObject(pinceau[1]);}
	Rectangle(memdc2,5,30,sys->ScrL()-5,10);


// copie du fond avec les lignes
	memdc.BitBlt(5,45,sys->ScrL()-5-5,sys->ScrH()-7-45,memdc2,5,45);
// affichage des icones :
//memdc.DrawIcon((sys->ScrL()-10)/2-abscisses*zoom-16,30+(sys->ScrH()-40)/2-ordonnees*zoom-16,Sole);
memdc.DrawIcon((sys->ScrL()-10)/2-16,40+(sys->ScrH()-45)/2-16,Sole);


int x,y,i,j;
bool affiche=false;
Vecteur Data;      // pt 3d
BPoint Sortie;     // pt 2d
double Zoom=1000.*zoom;
double r,la,lo;


// pour les planetes
 for (i=0;i<sys->getnbrplanete();i++) {
			// calcul position
			r=dr(sys->getplanete(i)->getdistanceausoleil());
			la=dr(sys->getplanete(i)->getlatitude());
			lo=dr(sys->getplanete(i)->getlongitude());

			Data.X=r*cos(la)*cos(lo);
			Data.Y=r*cos(la)*sin(lo);
			Data.Z=r*sin(la);
			/*
			if(strcmp(sys->getplanete(i)->getnom(),"Saturne")==0){
				FILE * fptr1;
				fptr1=fopen("Trajec.spi","at+");
				fprintf(fptr1,"%lf %lf %lf\n",Data.X,Data.Y,Data.Z);
				fclose(fptr1);
			}
			*/
			// conversion en 2d
			Sortie=InterPlan2(Data,P);

			x=(int)(Zoom*Sortie.X)+(sys->ScrL()-10)/2;
			y=40-(int)(Zoom*Sortie.Y)+(sys->ScrH()-45)/2;

          // sauvegarde pour information
		 			sys->getplanete(i)->setx(x);
		 			sys->getplanete(i)->sety(y);

			// affichage
			//epuisons les planetes connues
			 if(strcmp(sys->getplanete(i)->getnom(),"Terre")==0){affiche=true;
					if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8)) memdc.DrawIcon(x-16,y-16,Terr);
 			 }
			if(strcmp(sys->getplanete(i)->getnom(),"Mars")==0){affiche=true;
					if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8)) memdc.DrawIcon(x-16,y-16,Mars);
			 }
			if(strcmp(sys->getplanete(i)->getnom(),"Mercure")==0){affiche=true;
					if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8)) memdc.DrawIcon(x-16,y-16,Merc);
			 }
			if(strcmp(sys->getplanete(i)->getnom(),"Venus")==0){affiche=true;
					if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8)) memdc.DrawIcon(x-16,y-16,Venu);
	 			}
			if(strcmp(sys->getplanete(i)->getnom(),"Saturne")==0){affiche=true;
					if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8)) memdc.DrawIcon(x-16,y-16,Satu);
				}
			 if(strcmp(sys->getplanete(i)->getnom(),"Jupiter")==0){affiche=true;
				  if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Jupi);
			  }
			 if(strcmp(sys->getplanete(i)->getnom(),"Uranus")==0){affiche=true;
				  if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Uran);
			  }
			 if(strcmp(sys->getplanete(i)->getnom(),"Neptune")==0){affiche=true;
				 if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Nept);
			 }
			 if(strcmp(sys->getplanete(i)->getnom(),"Pluton")==0){affiche=true;
				 if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Plut);
			 }
			 if (affiche==false) {
				  if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Planeteinconnue);
				}
 }

 //******************************************************************************
// dessin des cometes
j=0;
while (sys->tabselected[j]!=-1&& j<2999){
	i=sys->tabselected[j];

	sys->getcomet(i)->calculposition(datum,sys->getsun());
	// calcul position
			r=dr(sys->getcomet(i)->getdistanceausoleil());
			la=dr(sys->getcomet(i)->getlatitude());
			lo=dr(sys->getcomet(i)->getlongitude());

			Data.X=r*cos(la)*cos(lo);
			Data.Y=r*cos(la)*sin(lo);
			Data.Z=r*sin(la);

         // conversion en 2d
			Sortie=InterPlan2(Data,P);

			x=(int)(Zoom*Sortie.X)+(sys->ScrL()-10)/2;
			y=40-(int)(Zoom*Sortie.Y)+(sys->ScrH()-45)/2;

         sys->getcomet(i)->setx(x);
         sys->getcomet(i)->sety(y);

	 if ((x>6) && (y>41)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Comet);
    j++;
} // while asteroides

//LEGENDE
memdc.SetBkMode(TRANSPARENT);
if (PPrint==false){
	memdc.SetTextColor(RGB(0,0,0));
}
else {
	memdc.SetTextColor(RGB(0,0,0));
}
memdc.TextOut(sys->ScrL()+70,5,"LEGENDE",7);
int b,c;
b=40;c=20;
//planetes
memdc.DrawIcon(sys->ScrL()+10,b,Merc);
memdc.TextOut(sys->ScrL()+50,b+5,"Mercure",7);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Venu);
memdc.TextOut(sys->ScrL()+50,b+5,"Venus",5);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Mars);
memdc.TextOut(sys->ScrL()+50,b+5,"Mars",4);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Jupi);
memdc.TextOut(sys->ScrL()+50,b+5,"Jupiter",7);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Satu);
memdc.TextOut(sys->ScrL()+50,b+5,"Saturne",7);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Uran);
memdc.TextOut(sys->ScrL()+50,b+5,"Uranus",6);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Nept);
memdc.TextOut(sys->ScrL()+50,b+5,"Neptune",7);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Plut);
memdc.TextOut(sys->ScrL()+50,b+5,"Pluton",6);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Terr);
memdc.TextOut(sys->ScrL()+50,b+5,"Terre",5);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Comet);
memdc.TextOut(sys->ScrL()+50,b+5,"Astroide",9);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Sole);
memdc.TextOut(sys->ScrL()+50,b+5,"Soleil",6);
b+=c+10;
memdc.SetBkMode(TRANSPARENT);
// date
char txt[30];
char txt1[30];
datum->date4(txt1);
sprintf(txt,"Heure GMT : %s",txt1 );
memdc.TextOut(sys->ScrL()+30,b,txt,strlen(txt));
b+=c;
date4l(datum,txt1);
sprintf(txt,"Heure Locale : %s",txt1);
memdc.TextOut(sys->ScrL()+30,b,txt,strlen(txt));
b+=c+10;


//dessiner la Terre au dessus

//DESTRUCTION DES ICONES
Merc.~TIcon();
Venu.~TIcon();
Mars.~TIcon();
Jupi.~TIcon();
Satu.~TIcon();
Nept.~TIcon();
Uran.~TIcon();
Plut.~TIcon();
Sole.~TIcon();
Terr.~TIcon();
Comet.~TIcon();
//Lune.~TIcon();
Planeteinconnue.~TIcon();
}

void HelioInformations(int x,int y,systeme *sys,TMemoryDC *memdc,HBRUSH Pinceau[30],HPEN Crayon[30],bool ngcs,bool messier,double Magnitudes){

//initialisation des variables
  int i,l,ni=0,nl=0,t=-10,tb=450;
  char string[20];
  TIcon Choix1(_hInstance,(TResId)choix0);
  memdc->SetBkMode(TRANSPARENT);

//regarde  quoi correspondent les coordonnees

//-------
// planete
for(i=sys->getnbrplanete()-1;i>=0;i--){
	if (x>sys->getplanete(i)->getx()-3
		&& x<sys->getplanete(i)->getx()+3
		&& y>sys->getplanete(i)->gety()-3
		&& y<sys->getplanete(i)->gety()+3
		&& t<0){
		ni=i; // numero
		t=1; //type d'objet
		sprintf(string,"Plante:%s",sys->getplanete(i)->getnom());
		memdc->TextOut(sys->ScrL()+65,tb,string,strlen(string));
	}//if
}// for i


  // asteroide
 int j=0;
while (sys->tabselected[j]!=-1&& j<2999){
	i=sys->tabselected[j];
   
	if(x>sys->getcomet(i)->getx()-3
			&& x<sys->getcomet(i)->getx()+3
			&& y>sys->getcomet(i)->gety()-3
			&& y<sys->getcomet(i)->gety()+3
			&& t<0){
			ni=i;nl=0;
         t=11;
			sprintf(string,"Astroide:%s",sys->getcomet(i)->getnom());
			memdc->TextOut(sys->ScrL()+70,tb,string,strlen(string));

       // memdc->DrawIcon(-16+sys->getcomet(sys->tabselected[i])->getx(),-16+sys->getcomet(sys->tabselected[i])->gety(),Choix1);

		  }    //if x
        j++;
	 }// while i

	 Choix1.~TIcon();

}