#include "heliocen.h"
#include "horaire.h"
/*
double r,la,lo,x,y,z;
r=dr(sys->getplanete(i)->getdistanceausoleil());
la=dr(sys->getplanete(i)->getlatitude());
lo=dr(sys->getplanete(i)->getlongitude());

x=r*cos(lat)*cos(lo);
y=r*cos(lat)*sin(lo);
z=r*sin(lat);
*/

void heliocentrique(date2* datum,systeme *sys,TMemoryDC & memdc, int k,HBRUSH pinceau[16],HPEN crayon[16],int abscisses, int ordonnees,bool PPrint,bool NB){
//sys: pointeur sur le systeme
sys->calculposition(datum);
if (PPrint==false) {memdc.SelectObject(pinceau[0]);memdc.SelectObject(crayon[0]);}
else {memdc.SelectObject(pinceau[1]);memdc.SelectObject(crayon[1]);}
	memdc.SetTextColor(RGB(200,0,0));
//	SetBkColor(memdc,RGB(120,120,200));
//definition d'un carre sur lequel est affiche les planetes
if (PPrint==false) memdc.SelectObject(crayon[2]);
else memdc.SelectObject(crayon[0]);
if (PPrint==false) memdc.SelectObject(pinceau[3]);
else memdc.SelectObject(pinceau[1]);
Rectangle(memdc,5,30,sys->ScrL()-5,sys->ScrH()-7);
int iccon;
if (NB==true && PPrint==true) iccon=20; else iccon=0;
TIcon Mars(_hInstance,(TResId)(mar-iccon));  // mars = surnom de l'icone
TIcon Merc(_hInstance,(TResId)(merc-iccon));
TIcon Venu(_hInstance,(TResId)(venu-iccon));
TIcon Satu(_hInstance,(TResId)(satu-iccon));
TIcon Jupi(_hInstance,(TResId)(jupi-iccon));
TIcon Uran(_hInstance,(TResId)(uranus-iccon));
TIcon Nept(_hInstance,(TResId)(neptune-iccon));
TIcon Plut(_hInstance,(TResId)(pluton-iccon));
TIcon Sole(_hInstance,(TResId)(solei-iccon));  //Icone du soleil
//TIcon Lune(_hInstance,moyen);  //Icone de la lune
TIcon Terr(_hInstance,(TResId)(terr-iccon)); //Icone de la Terre
TIcon Planeteinconnue(_hInstance,(TResId)(grand));


float zoom;
if (k>=1) zoom=k;
else zoom=sqrt(1./(2.-(float)k));

// affichage des icones :
memdc.DrawIcon((sys->ScrL()-10)/2-abscisses*zoom,30+(sys->ScrH()-40)/2-ordonnees*zoom,Sole);
		 // 244
int x,y,i;
bool affiche=false;

 for (i=0;i<sys->getnbrplanete();i++) {
			 //262
			x = 16+(sys->ScrL()-10)/2+25*sys->getplanete(i)->getdistanceausoleil()
					*cos(-dr(sys->getplanete(i)->getlongitude()))*zoom - abscisses*zoom;
			y = 46+(sys->ScrH()-40)/2+25*sys->getplanete(i)->getdistanceausoleil()
					*sin(-dr(sys->getplanete(i)->getlongitude()))*zoom - ordonnees*zoom;

			//epuisons les planetes connues
			 if(strcmp(sys->getplanete(i)->getnom(),"Terre")==0){affiche=true;
					if ((x>6) && (y>31)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8)) memdc.DrawIcon(x-16,y-16,Terr);
			 }
			if(strcmp(sys->getplanete(i)->getnom(),"Mars")==0){affiche=true;
					if ((x>6) && (y>31)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8)) memdc.DrawIcon(x-16,y-16,Mars);
			  }
			if(strcmp(sys->getplanete(i)->getnom(),"Mercure")==0){affiche=true;
					if ((x>6) && (y>31)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8)) memdc.DrawIcon(x-16,y-16,Merc);
			 }
			if(strcmp(sys->getplanete(i)->getnom(),"Venus")==0){affiche=true;
					if ((x>6) && (y>31)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8)) memdc.DrawIcon(x-16,y-16,Venu);
			  }
			if(strcmp(sys->getplanete(i)->getnom(),"Saturne")==0){affiche=true;
					if ((x>6) && (y>31)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8)) memdc.DrawIcon(x-16,y-16,Satu);
			  }
			 if(strcmp(sys->getplanete(i)->getnom(),"Jupiter")==0){affiche=true;
				  if ((x>6) && (y>31)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Jupi);
			  }
			 if(strcmp(sys->getplanete(i)->getnom(),"Uranus")==0){affiche=true;
				  if ((x>6) && (y>31)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Uran);
			  }
			 if(strcmp(sys->getplanete(i)->getnom(),"Neptune")==0){affiche=true;
				 if ((x>6) && (y>31)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Nept);
			 }
			 if(strcmp(sys->getplanete(i)->getnom(),"Pluton")==0){affiche=true;
				 if ((x>6) && (y>31)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Plut);
			 }
			 if (affiche==false) {
				  if ((x>6) && (y>31)&&(x<sys->ScrL()-6) && (y<sys->ScrL()-8))	memdc.DrawIcon(x-16,y-16,Planeteinconnue);
				}
 }


//LEGENDE
memdc.SetBkMode(TRANSPARENT);
if (PPrint==false){
	memdc.SetTextColor(RGB(0,0,0));
}
else {
	memdc.SetTextColor(RGB(0,0,0));
}
memdc.TextOut(sys->ScrL()+70,5,"LEGENDE",7);
int b,c;
b=40;c=20;
//planetes
memdc.DrawIcon(sys->ScrL()+10,b,Merc);
memdc.TextOut(sys->ScrL()+50,b+5,"Mercure",7);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Venu);
memdc.TextOut(sys->ScrL()+50,b+5,"Venus",5);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Mars);
memdc.TextOut(sys->ScrL()+50,b+5,"Mars",4);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Jupi);
memdc.TextOut(sys->ScrL()+50,b+5,"Jupiter",7);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Satu);
memdc.TextOut(sys->ScrL()+50,b+5,"Saturne",7);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Uran);
memdc.TextOut(sys->ScrL()+50,b+5,"Uranus",6);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Nept);
memdc.TextOut(sys->ScrL()+50,b+5,"Neptune",7);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Plut);
memdc.TextOut(sys->ScrL()+50,b+5,"Pluton",6);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Terr);
memdc.TextOut(sys->ScrL()+50,b+5,"Terre",5);
b+=c;
memdc.DrawIcon(sys->ScrL()+10,b,Sole);
memdc.TextOut(sys->ScrL()+50,b+5,"Soleil",6);
b+=c+10;
memdc.SetBkMode(TRANSPARENT);
// date
char txt[30];
char txt1[30];
datum->date4(txt1);
sprintf(txt,"Heure GMT : %s",txt1 );
memdc.TextOut(sys->ScrL()+30,b,txt,strlen(txt));
b+=c;
date4l(datum,txt1);
sprintf(txt,"Heure Locale : %s",txt1);
memdc.TextOut(sys->ScrL()+30,b,txt,strlen(txt));
b+=c+10;



//dessiner la Terre au dessus

//DESTRUCTION DES ICONES
Merc.~TIcon();
Venu.~TIcon();
Mars.~TIcon();
Jupi.~TIcon();
Satu.~TIcon();
Nept.~TIcon();
Uran.~TIcon();
Plut.~TIcon();
Sole.~TIcon();
Terr.~TIcon();
//Lune.~TIcon();
Planeteinconnue.~TIcon();
}
