#ifndef NGC_H
#define NGC_H
#include "constant.h"
class Lactee{
private:
	int nombre1,nombre2;
	double ligne1[max_lactee][2],ligne2[max_lactee][2];
public:
  Lactee(){nombre1=0;nombre2=0;}
  ~Lactee(){}
  double getdeclinaison(int ligne,int pt){
		if (ligne==1) return ligne1[pt][2];
		else return ligne2[pt][2];
		}
  double getascensiondroite(int ligne,int pt){
		if (ligne==1) return ligne1[pt][1];
		else return ligne2[pt][1];
		}
  void setpoint(int ligne, double asc,double dec){
		if (ligne==1){ ligne1[nombre1][1]=asc;ligne1[nombre1][2]=dec;nombre1++;}
		else { ligne2[nombre2][1]=asc;ligne2[nombre2][2]=dec;nombre2++;}
		}
  int getnombre1(){return nombre1;}
  int getnombre2(){return nombre2;}
};
class ngc {
  private:
	 double declinaison;
	 double ascensiondroite;
	 double magnitude;
	 char nom [30];
	 int typet; 		// 1-> nebuleuse
							// 2-> amas globulaire
							// 3-> amas ouvert
							// 4-> galaxie
							// 5-> galaxie elliptique
							// 6-> galaxie spirale
							// 7-> galaxie spirale barree
							// 8-> galaxie irreguliere
	 char abrev[30];
	 int X,Y;

  public:
	 // constructeur et destructeur
	 ngc(char *,char*, double , double ,int,double);
	 ~ngc(void);

    // acces aux attributs prives
	 double getdeclinaison(void);
	 double getascensiondroite(void);
    double getmagnitude(void);
	 int gettype(void);
	 char* getabrev(void);

	 void setx(int);
	 void sety(int);
	 int getx(void);
	 int gety(void);

	 char* getnom();
};

#endif
