//--------------------------------------------------------------------------
// Plantarium -- Copyright (c) 1998
//--------------------------------------------------------------------------
#ifndef POSITION_H
#define POSITION_H

#include <owl/dialog.h>
#include <owl/static.h>
#include <owl/button.h>
#include <owl/listbox.h>
#include <owl/combobox.h>

#include "planetar.rh"
#include "date.h"
#include "systeme.h"


// pour les combobox
struct positionXfer {
//{{mainXFER_DATA}}
	 TComboBoxData  box_annee;
	 TComboBoxData  box_mois;
	 TComboBoxData  box_jour;
	 TComboBoxData  box_heure;

	 TComboBoxData  box_objet;
//{{mainXFER_DATA_END}}
};

class TDialogPosition: public TDialog {
private :

	systeme* system;

	// TCombobox
	TComboBox * box_annee;
	TComboBox * box_mois;
	TComboBox * box_jour;
	TComboBox * box_heure;
	TComboBox * box_objet;

	// Tstatic *
	TStatic * edit_dec1;
	TStatic * edit_dec2;
	TStatic * edit_dec3;
	TStatic * edit_asc1;
	TStatic * edit_asc2;
	TStatic * edit_asc3;
	TStatic * edit_distance;

	date2 *d;
   int result;//=0 si cancel, 1 sinon

public:
  TDialogPosition( TWindow* parent,systeme*syst,date2*datum );
  ~TDialogPosition();
  void SetupWindow() ;
  void EvPaint() ;

  int Execute() ;
  void Ignore();
  void Fin();
  void Fin2();

  void ModifAnnee();
  void ModifMois();
  void ModifJour();
  void ModifHeure();
  void ModifObjet();
  void ModifResultat();
  void Verif();

  // pour les fonctions declenches par les boutons
  DECLARE_RESPONSE_TABLE( TDialogPosition );
};

#endif // POSITION_H
