#include "spherpro.h"

// creer le fichier de couleur pour saturne

/*
int main (void){
	ConvertirFichierBmpSpi("saturne", 197, 200);

	FILE*fptr1=fopen("saturne.spi","rb");

	int i;
   int largeur,hauteur;
	fscanf(fptr1,"%d %d\n",&largeur, &hauteur);
	for(i=0;i<9;i++){
		printf("%d ",fgetc(fptr1));
	}
	for(i=9;i<194;i++){
		fgetc(fptr1);
		fgetc(fptr1);
		fgetc(fptr1);
	}
   for(i=0;i<10;i++){
		printf("%d ",fgetc(fptr1));
	}
   fclose(fptr1);
            
 return 0;
}
*/
void ConvertirFichierBmpSpi(char* filename, int largeur, int hauteur){
 char text1[30];
 char text2[30];
 sprintf(text1,"%s.bmp",filename);
 sprintf(text2,"%s.spi",filename);
  FILE*fptr1,*fptr2;
 fptr1=fopen(text1,"rb");
 fptr2=fopen(text2,"wb");
 int i,j;
 // lire entete
 for(i=0;i<54;i++){
	fgetc(fptr1);
 }
 fprintf(fptr2,"%d %d\n",largeur,hauteur);
 //copier l'image sauf les zeos en fin de ligne
 for(i=0;i<hauteur;i++){
	for(j=0;j<largeur;j++){

		fputc(fgetc(fptr1),fptr2);
		fputc(fgetc(fptr1),fptr2);
      fputc(fgetc(fptr1),fptr2);
	}
	// lire les 0 en trop
	for(j=0;j<(largeur)%4;j++)fgetc(fptr1);
 }
 fclose(fptr1);
 fclose(fptr2);

}

void CollerFichierSurEllipse(TMemoryDC * memdc,char* filename,int Rx,int Ry,int CentreX,int CentreY, int MargeAutorisee, int &MargeDemandee){
   FILE* carte=fopen(filename,"rb");

   int kkl,kkm,X,Y,cblolo,crlolo,cglolo;
   int largeur=197,hauteur=200;  // largeur et hauteur image
   int patienterx=0,patientery=0;
   int R;	// rayon de la sphere pour un X donn
   int helllo;
   long i,j;

   fscanf(carte,"%d %d\n",&largeur,&hauteur);
   int pasx,pasy;
   float paspasx=(float)(2.*Rx)/(float)(largeur);  // largeur d'un pixel affich
   float paspasy=(float)(2.*Ry)/(float)(hauteur-MargeAutorisee);  // hauteur d'un pixel affich
   // tient compte de la marge sur les y (rotation de la planete)
   if(MargeDemandee<0) MargeDemandee=0;
   if(MargeDemandee>MargeAutorisee) MargeDemandee=MargeAutorisee;
   fgetc(carte);
   fgetc(carte);
   for(j=0;j<(int)(MargeDemandee*largeur);j++){
    	fgetc(carte);
      fgetc(carte);
      fgetc(carte);
   }

   //position du debut
   Y=Ry-1;
   R=Rx*sqrt(Ry*Ry-Y*Y)/Ry;
   X=-R;
   paspasx=(float)(2.*R)/(float)(largeur);  // largeur d'un pixel affich

   pasx=ceil(paspasx);
   pasy=ceil(paspasy);

   patientery=0;  // je ne patiente pas jusqu'a la fin de la ligne

   //FILE * fptr3=fopen("test.txt","wt");
   // dessin planete
   for(j=0;j<hauteur-MargeAutorisee;j++){
     patienterx=0;  // je ne patiente pas jusqu'a la fin de la ligne
     patientery--;  // je ne patiente pas jusqu'a la fin de la ligne
     //fprintf(fptr3,"%d %d %d %d\n",Y,R,X,pasx);
     for(i=0;i<largeur;i++){
     		// chopper pixel

        	cblolo=fgetc(carte);
      	cglolo=fgetc(carte);
      	crlolo=fgetc(carte);
         // savoir si on l'affiche

            if(pasx<=1) helllo=largeur/2+X/pasx;
            else if (i>=largeur/2-R/pasx-1 && i<=largeur/2+R/pasx-1) helllo=i;
            		else helllo=i+1;
          	if(i==helllo && patienterx==0 && patientery<=0){
            	// on l'affiche

             //  memdc->SetPixel(CentreX+i,CentreY+j,RGB(crlolo,cglolo,cblolo));

             	for(kkl=0;kkl<pasx;kkl++){
               	for(kkm=0;kkm<pasy;kkm++){
               		memdc->SetPixel(CentreX+X+kkl,CentreY+Y-kkm,RGB(crlolo,cglolo,cblolo));
                  }
               }

               X+=pasx;
               if(X>=R){
               	Y-=pasy;
                  patienterx=1;
                  patientery=(hauteur-MargeAutorisee)/(2*Ry);
                  if(Y>-Ry){
                     R=Rx*sqrt(Ry*Ry-Y*Y)/Ry;
   						X=-R;
                     paspasx=(float)(2.*R)/(float)(largeur);  // largeur d'un pixel affich
							pasx=ceil(paspasx);
                  }
                  else j=hauteur;
               }
            }
     }  //for i
   }  // for j
   //fclose(fptr3);
   fclose(carte);


}
