//--------------------------------------------------------------------------
// Plantarium -- Copyright (c) 1998
//--------------------------------------------------------------------------
#ifndef ASTEROIDESS_H
#define ASTEROIDESS_H

#include <owl/dialog.h>
#include <owl/static.h>
#include <owl/button.h>
#include <owl/listbox.h>
#include <owl/scrollba.h>

#include "planetar.rh"
#include "date.h"
#include "systeme.h"
#include "aster.h"  // pour la conversion de fichiers

// pour les combobox
struct asteroidesXfer {
//{{mainXFER_DATA}}
	 TListBoxData  box_list_objets;
	 TListBoxData  box_selectionnes;

//{{mainXFER_DATA_END}}
};

class TDialogAsteroides: public TDialog {
private :

	systeme* system;

	// TCombobox
	TListBox  *box_list_objets;
   TListBox  *box_selectionnes;

   TStatic *MagReel;
   TStatic *MagMax;

   int tabaste[3000];
   int sauveselected[3000];

   int result;//=0 si cancel, 1 sinon
   double Mag;

public:
  TDialogAsteroides( TWindow* parent,systeme*syst );
  ~TDialogAsteroides();
  void SetupWindow() ;
  void EvPaint() ;

  int Execute() ;
  void Ignore();
  void Fin();
  void Fin2();

  void UpdateListe();
  void Magnitude1();
  void Magnitude2();
  void  EvHScroll(UINT, UINT, HWND);
  void Ajout();
  void AjoutAll();
  void Supp();
  void SuppAll();

  // pour les fonctions declenches par les boutons
  DECLARE_RESPONSE_TABLE( TDialogAsteroides );
};


void AsteroideFileConversion();

#endif // ASTEROIDESS_H
