//--------------------------------------------------------------------------
// Plantarium -- Copyright (c) 1998 
//--------------------------------------------------------------------------
#include <owl\owlpch.h>
#include <stdlib.h> // conversion int -> string
#include <math.h>
#include <stdio.h>

#include <windows.h>
#include <string.h>
const char IniFilename[] = "Spica.ini";


#pragma hdrstop

#include "cartdial.h"
#include "constant.h"  // pour les decmin decmax...
#include "horaire.h"

//-------------------------
// locali
//---------------------------------------------------------
//  carte

// pour entrer la date

// pour les combobox
static dialogs4Xfer dialogs4Data;


TDialogLocali::TDialogLocali( TWindow* parent,date2 * datum,int *numcit,int *numcit1, double* lon, double* lat,char*city2,char*city3,int * ete2,int *ordi2,int *obs2):
	 TDialog( parent, DIALOG_LOCALISATION) {

	 box_ville=new TComboBox(this,IDC_COMBOBOX_VILLE);
    box_ville2=new TComboBox(this,IDC_COMBOBOX_VILLE_ORDI);
    box_obs=new TComboBox(this,IDC_COMBOBOX_GMT_OBS);
    box_ete=new TComboBox(this,IDC_COMBOBOX_ETE);
    box_ordi=new TComboBox(this,IDC_COMBOBOX_GMT_ORDI);

	 edit_longi=new TStatic(this,IDC_EDIT_LONGI);
	 edit_latit=new TStatic(this,IDC_EDIT_LATIT);

	 SetTransferBuffer(&dialogs4Data); // l ou stocke les donnees des combobo

	 numcity=numcit;
    numcity1=numcit1;
    longi=lon;latit=lat;
	 oldnum=*numcit;
	 city=city3;
    city1=city2;
    obs=obs2;
    ete=ete2;
    ordi=ordi2;
    d=datum;

    lordi=*ordi;


  }
TDialogLocali::~TDialogLocali(){

	edit_longi->~TStatic();
	edit_latit->~TStatic();
   box_ville->~TComboBox();
   box_ville2->~TComboBox();
   box_obs->~TComboBox();
   box_ordi->~TComboBox();
   box_ete->~TComboBox();
	delete[] longi2;delete[] latit2;

	}

	/// -----------------------------------------------------------
void TDialogLocali::SetupWindow() {
	 TDialog::SetupWindow();
	 IniVille();
    IniVille2();
    IniEte();
    IniOrdi();
    IniObs();

	 }


void TDialogLocali::IniEte(){
		box_ete->AddString("d'hiver");
      box_ete->AddString("d't");
      box_ete->SetSelIndex(*ete);
}
void TDialogLocali::IniOrdi(){
   int i;
   char text[12];
	for(i=-12;i<12;i++){

   	if( i>=0) sprintf(text,"+ %d h",i);
      else sprintf(text,"%d h",i);
      box_ordi->AddString(text);
      if( i>=0) sprintf(text,"+ %d h 30",i);
      else if(i+1==0) sprintf(text,"- %d h 30",i+1);
      		else sprintf(text,"%d h 30",i+1);
      box_ordi->AddString(text);
   }

	 box_ordi->SetSelIndex(*ordi);
}
void TDialogLocali::IniObs(){
	int i;
   char text[12];
	for(i=-12;i<12;i++){
   	if( i>=0) sprintf(text,"+ %d h",i);
      else sprintf(text,"%d h",i);
      box_obs->AddString(text);
      if( i>=0) sprintf(text,"+ %d h 30",i);
      else if(i+1==0) sprintf(text,"- %d h 30",i+1);
      		else sprintf(text,"%d h 30",i+1);
      if(i<11) box_obs->AddString(text);
   }
	 box_obs->SetSelIndex(*obs);
}

void TDialogLocali::DelEte(){
     int i;
	 for(i=0;i<2;i++){
		box_ete->DeleteString(0);
	 }
    }
void TDialogLocali::DelOrdi(){
     int i;
	 for(i=0;i<48;i++){
		box_ordi->DeleteString(0);
	 }
    }
void TDialogLocali::DelObs(){
    int i;
	 for(i=0;i<=48;i++){
		box_obs->DeleteString(0);
	 }
    }
void TDialogLocali::IniVille(){
	 // 3e colone : coor de la vue
	 int i;
	 char string[30];
	 FILE* fcity=fopen("ville.syt","rt");
	 fscanf(fcity,"Nombre:%d",&num);
	 longi2=new double[num];
	 latit2=new double[num];
	 for(i=0;i<num;i++){
		fscanf(fcity,"\n%s %lf %lf",string,&latit2[i],&longi2[i]);
		box_ville->AddString(string);
	 }
	 fclose(fcity);
	 box_ville->AddString("Autre");
	 box_ville->SetSelIndex(*numcity);
	 double ll;
	 if (*numcity<num) {ll=longi2[*numcity]; moddi=2;}
	 else {ll=*longi; moddi=0;}
	 sprintf(string,"%lf",ll); edit_longi->SetText(string);
	 //
	 if (*numcity<num) ll=latit2[*numcity];
	 else ll=*latit;
	sprintf(string,"%lf",ll); edit_latit->SetText(string);

  }
void TDialogLocali::DelVille(){
	 // 3e colone : coor de la vue
	 int i;
	 for(i=0;i<=num+1;i++){
		box_ville->DeleteString(0);
	 }
}

void TDialogLocali::IniVille2(){
	 // 3e colone : coor de la vue
	 int i;
	 char string[30];
	 FILE* fcity=fopen("ville.syt","rt");
	 fscanf(fcity,"Nombre:%d",&num);
	 double longi2;
	 double latit2;
	 for(i=0;i<num;i++){
		fscanf(fcity,"\n%s %lf %lf",string,&latit2,&longi2);
		box_ville2->AddString(string);
	 }
	 fclose(fcity);
	 box_ville2->AddString("Autre");
	 box_ville2->SetSelIndex(*numcity1);


  }
void TDialogLocali::DelVille2(){
	 // 3e colone : coor de la vue
	 int i;
	 for(i=0;i<=num+1;i++){
		box_ville2->DeleteString(0);
	 }
}

  /// -----------------------------------------------------------
  /// -----------------------------------------------------------
void TDialogLocali::EvPaint() {
	 TDialog::EvPaint();
	 }

int TDialogLocali::Execute() {
	 TDialog::Execute();

		 return result;

  }
void TDialogLocali::Ignore() {}
void TDialogLocali::Fin2(){ // cancel
	result=1;
  // vide les boites

	 DelVille();
    DelVille2();
    DelEte();
    DelOrdi();
    DelObs();
	CloseWindow(result);
}
void TDialogLocali::Fin(){ // fin pour OK
	 result=0;
/// calcul les variables

	 *numcity=box_ville->GetSelIndex();
    char stringoo[40];
	 if (*numcity<num) {*longi=longi2[*numcity];*latit=latit2[*numcity];}
	 else{

		double ll1,ll2;


		edit_longi->GetText(stringoo,7);
		sscanf(stringoo,"%lf",&ll1);
		edit_latit->GetText(stringoo,7);
		sscanf(stringoo,"%lf",&ll2);

		if (ll1>=-90. && ll1<=90. && ll2>=0. && ll2<=360.) {
				*longi=ll1;
				*latit=ll2;
				*numcity=num;
		}
		else {
			*numcity=oldnum;
		}

	 }
	 box_ville->GetString(city1,*numcity);

    *numcity1=box_ville2->GetSelIndex();
    box_ville2->GetString(city,*numcity1);

    *ete=box_ete->GetSelIndex();
    *obs=box_obs->GetSelIndex();
    *ordi=box_ordi->GetSelIndex();

	 sprintf(stringoo,"%d",*numcity);
	 WritePrivateProfileString("Position", "N ville",stringoo,IniFilename);
	 sprintf(stringoo,"%d",(int)(*latit*100.));
	 WritePrivateProfileString("Position", "Latitude", stringoo,IniFilename);
	 sprintf(stringoo,"%d",(int)((*longi+180.)*100.));
	 WritePrivateProfileString("Position", "Longitude", stringoo,IniFilename);
	 //WritePrivateProfileString("Position", "Ville", city,IniFilename);
    WritePrivateProfileString("Position", "Ville", city1,IniFilename);

    sprintf(stringoo,"%d",*numcity1);
	 WritePrivateProfileString("Position ordinateur", "N ville",stringoo,IniFilename);
    WritePrivateProfileString("Position ordinateur", "Ville",city,IniFilename);


    sprintf(stringoo,"%d",*ete);
    WritePrivateProfileString("Heure", "Saison", stringoo,IniFilename);
    sprintf(stringoo,"%d",*obs);
	 WritePrivateProfileString("Heure", "Lieu d'observation", stringoo,IniFilename);
    sprintf(stringoo,"%d",*ordi);
	 WritePrivateProfileString("Heure", "Lieu de l'ordinateur", stringoo,IniFilename);

    // variables grant l'affichage et les animations
      d->sbgmt=(double) (-24.+(float)*ordi)/2.;
      d->slgmt=(double) (-24.+(float)*obs)/2.;//shift babasse GMT, et shift lieu utilis GMT
	  	d->saison=*ete; //heure d't ou d'hiver?

	 DelVille();
    DelVille2();
    DelEte();
    DelOrdi();
    DelObs();

		CloseWindow(result);
  }

/// -----------------------------------------------------------
void TDialogLocali::ModifVille(){
int numi=box_ville->GetSelIndex();
double ll;
char string[30];
char stringoo[30];
	 if (numi<num) {
	 moddi=2;
	 ll=longi2[numi];
	 sprintf(string,"%lf",ll); edit_longi->SetText(string);
	//
	 ll=latit2[numi];
	 sprintf(string,"%lf",ll); edit_latit->SetText(string);
	 }/// if

    // trouver le nom du pays
    box_ville->GetText(stringoo,30);
    for(numi=0;numi<strlen(stringoo);numi++){
    	if(stringoo[numi]=='-' || stringoo[numi]==' ' ){
         string[numi]='\0';
         numi=60;
      }
      else string[numi]=stringoo[numi];
    }
    // mettre a jour le decalage horaire
    d->slgmt=d->setshift(string);
    *obs=(int)(2.*(12.+d->slgmt));
    box_obs->SetSelIndex(*obs);

}

void TDialogLocali::ModifVille2(){
int numi=box_ville->GetSelIndex();
double ll;
char string[30];
char stringoo[30];

    // trouver le nom du pays
    box_ville2->GetText(stringoo,30);
    for(numi=0;numi<strlen(stringoo);numi++){
    	if(stringoo[numi]=='-'){
         string[numi]='\0';
         numi=60;
      }
      else string[numi]=stringoo[numi];
    }
    // mettre a jour le decalage horaire
    d->sbgmt=d->setshift(string);
    *ordi=(int)(2.*(12.+d->sbgmt));
    box_ordi->SetSelIndex(*ordi);
    miseajourGMT(d,(double)(-24.+(float)lordi)/2.);
    lordi=*ordi;
}
void TDialogLocali::ModifEte(){
int numi;
char string[30];
char stringoo[30];

    // trouver le nom du pays
    box_ville->GetText(stringoo,30);
    for(numi=0;numi<strlen(stringoo);numi++){
    	if(stringoo[numi]=='-'){
         string[numi]='\0';
         numi=60;
      }
      else string[numi]=stringoo[numi];
    }
    // mettre a jour le decalage horaire
    d->saison=box_ete->GetSelIndex();

    d->slgmt=d->setshift(string);
    *obs=(int)(2.*(12.+d->slgmt));
    box_obs->SetSelIndex(*obs);


    box_ville2->GetText(stringoo,30);
    for(numi=0;numi<strlen(stringoo);numi++){
    	if(stringoo[numi]=='-'){
         string[numi]='\0';
         numi=60;
      }
      else string[numi]=stringoo[numi];
    }
    d->sbgmt=d->setshift(string);
    *ordi=(int)(2.*(12.+d->sbgmt));
    box_ordi->SetSelIndex(*ordi);
    miseajourGMT(d,(double)(-24.+(float)lordi)/2.);
    lordi=*ordi;

}

void TDialogLocali::ModifEdit(){
  if (moddi<=0) {box_ville->SetSelIndex(num); moddi=0;}
  else moddi--;
}



/// -----------------------------------------------------------
/// -----------------------------------------------------------


DEFINE_RESPONSE_TABLE1( TDialogLocali, TDialog )
  EV_WM_PAINT,

  EV_COMMAND( IDC_OK, Fin ),
  EV_COMMAND( IDC_CANCEL, Fin2 ),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_VILLE,ModifVille),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_VILLE_ORDI,ModifVille2),
  EV_EN_CHANGE	(IDC_EDIT_LONGI,ModifEdit),
  EV_EN_CHANGE	(IDC_EDIT_LATIT,ModifEdit),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_ETE,ModifEte),

END_RESPONSE_TABLE;


//---------------------------------------------------------
//  carte

// pour entrer la date

// pour les combobox
static dialogs2Xfer dialogs2Data;


TDialogCarte::TDialogCarte( TWindow* parent,date2* datum,int* typ, int* de1,int* de2,int* as1,int* as2,int* azim1,int* azim2,int* haut1, int* haut2,int *numcit, double* lon, double* lat,char*city2):
	 TDialog( parent, DIALOG_CARTE) {

	 box_annee=new TComboBox(this,IDC_COMBOBOX_ANNEE);
	 box_mois=new TComboBox(this,IDC_COMBOBOX_MOIS);
	 box_jour=new TComboBox(this,IDC_COMBOBOX_JOUR);
	 box_heure=new TComboBox(this,IDC_COMBOBOX_HEURE);

	 box_dec1=new TComboBox(this,IDC_CARTDEC1);
	 box_dec2=new TComboBox(this,IDC_CARTDEC2);
	 box_asc1=new TComboBox(this,IDC_CARTASC1);
	 box_asc2=new TComboBox(this,IDC_CARTASC2);

	 box_type=new TComboBox(this,IDC_CARTTYPE);
	 box_ville=new TComboBox(this,IDC_COMBOBOX_VILLE);


	 edit_f1=new TStatic(this,IDC_F1);
	 edit_f2=new TStatic(this,IDC_F2);
	edit_f3=new TStatic(this,IDC_F3);
	edit_f4=new TStatic(this,IDC_F4);

	edit_af1=new TStatic(this,IDC_AF1);
	edit_af2=new TStatic(this,IDC_AF2);
	edit_af3=new TStatic(this,IDC_AF3);
	edit_af4=new TStatic(this,IDC_AF4);

	edit_titre=new TStatic(this,IDC_TITRE);
	edit_longi=new TStatic(this,IDC_EDIT_LONGI);
	edit_latit=new TStatic(this,IDC_EDIT_LATIT);

	 SetTransferBuffer(&dialogs2Data); // l ou stocke les donnees des combobo
	 d=datum;
	 type=typ;
	 dec1=de1;dec2=de2;asc1=as1;asc2=as2;
	 azi1=azim1;azi2=azim2;hau1=haut1;hau2=haut2;
	 numcity=numcit;longi=lon;latit=lat;
	 oldnum=*numcit;
	 city=city2;

  }
TDialogCarte::~TDialogCarte(){
	box_annee->~TComboBox();
	box_mois->~TComboBox();
	box_jour->~TComboBox();
	box_heure->~TComboBox();

   box_type->~TComboBox();
	box_dec1->~TComboBox();
	box_dec2->~TComboBox();
	box_asc1->~TComboBox();
	box_asc2->~TComboBox();
	edit_titre->~TStatic();
	edit_longi->~TStatic();
   edit_latit->~TStatic();
	edit_f1->~TStatic();edit_f2->~TStatic();edit_f4->~TStatic();edit_f3->~TStatic();
	edit_af1->~TStatic();	edit_af2->~TStatic();edit_af4->~TStatic();edit_af3->~TStatic();
	delete[] longi2;delete[] latit2;

	}

	/// -----------------------------------------------------------
void TDialogCarte::SetupWindow() {
	 TDialog::SetupWindow();
	 // sauvegarde de la date pour le cas ou cancel
	 annee=d->getannee();
	 mois=d->getmois();
	 jour=d->getjour();
	 heure=d->getheure();
	 //
	 int i=1;
	 char string[5];
	 // entree des annee;
	 for(i=anneedebut;i<anneefin;i++){
		box_annee->AddString(itoa(i,string,10));
	 }
	 box_annee->SetText(itoa(d->getannee(),string,10));

	 // entree des mois
	 box_mois->AddString("Janvier");
	 box_mois->AddString("Fvrier");
	 box_mois->AddString("Mars");
	 box_mois->AddString("Avril");
	 box_mois->AddString("Mai");
	 box_mois->AddString("Juin");
	 box_mois->AddString("Juillet");
	 box_mois->AddString("Aout");
	 box_mois->AddString("Septembre");
	 box_mois->AddString("Octobre");
	 box_mois->AddString("Novembre");
	 box_mois->AddString("Dcembre");

	 box_mois->SetSelIndex(d->getmois()-1);

	 // entree des jours

	 for(i=1;i<=31;i++){
	 box_jour->AddString(itoa(i,string,10));
	 }
    ModifMois();// pour supprimer le 31 ...
	 box_jour->SetSelIndex(d->getjour()-1);

	  // entree des heures

	 for(i=0;i<=23;i++){
	 box_heure->AddString(itoa(i,string,10));
	 }
	 box_heure->SetSelIndex(d->getheure());


	 // 2e colonne : type de vue
	 box_type->AddString("Projection circulaire");
	 box_type->AddString("Vue azimutale");
	 box_type->AddString("Proj. quidistante");
	 box_type->AddString("Proj. quadratique");
	 box_type->AddString("Quadratique avec trajectoire");
	 if (*type<=3) box_type->SetSelIndex(*type+1);
	 else box_type->SetSelIndex(*type-4);
	 if (*type<=3) IniMerc();
	 else IniAzim();
	 IniVille();
	 lasttype=*type;

	 }
void TDialogCarte::IniMerc(){
	 // 3e colone : coor de la vue
	 int i;
	 char string[15];
	 for(i=DecMax;i>=DecMin;i--){
		box_asc1->AddString(itoa(i,string,10));
	 }
	 for(i=DecMax;i>=DecMin;i--){
		box_asc2->AddString(itoa(i,string,10));
	 }
	 for(i=AscMin;i<=AscMax;i++){
		box_dec1->AddString(itoa(i,string,10));
	 }
	 for(i=AscMin;i<=AscMax;i++){
		box_dec2->AddString(itoa(i,string,10));
	 }
	 box_dec1->SetText(itoa(*asc1,string,10));
	 box_dec2->SetText(itoa(*asc2,string,10));
	 box_asc1->SetText(itoa(*dec1,string,10));
	 box_asc2->SetText(itoa(*dec2,string,10));
	 edit_titre->SetText("Coordonnes de la fenetre (proj quadratique)");
	 edit_af1->SetText("Ascension du coin sup. gauche :");edit_f1->SetText("h");
	 edit_af3->SetText("Ascension du coin inf. droit :");edit_f3->SetText("h");
	 edit_af2->SetText("Dclinaison du coin sup. gauche :");edit_f2->SetText("");
	 edit_af4->SetText("Dclinaison du coin inf. droit :");edit_f4->SetText("");
  }
void TDialogCarte::IniAzim(){
	 // 3e colone : coor de la vue
		  int i;
			 char string[15];
	 for(i=0;i<=360;i++){
		box_dec1->AddString(itoa(i,string,10));
	 }
	 for(i=0;i<=360;i++){
		box_dec2->AddString(itoa(i,string,10));
	 }
	 for(i=90;i>=-5;i--){
		box_asc1->AddString(itoa(i,string,10));
	 }
	 for(i=90;i>=-5;i--){
		box_asc2->AddString(itoa(i,string,10));
	 }
	 box_dec1->SetText(itoa(*azi1,string,10));
	 box_dec2->SetText(itoa(*azi2,string,10));
	 box_asc2->SetText(itoa(*hau1,string,10));
	 box_asc1->SetText(itoa(*hau2,string,10));
     edit_titre->SetText("Coordonnes de la fenetre (vue Azimutale)");
	 edit_af1->SetText("Azimut du coin sup. gauche :");edit_f1->SetText("");
	 edit_af3->SetText("Azimut du coin inf. droit :");edit_f3->SetText("");
	 edit_af2->SetText("Hauteur du coin sup. gauche :");edit_f2->SetText("");
	 edit_af4->SetText("Hauteur du coin inf. droit :");edit_f4->SetText("");
  }
void TDialogCarte::IniVille(){
	 // 3e colone : coor de la vue
	 int i;
	 char string[30];
	 FILE* fcity=fopen("ville.syt","rt");
	 fscanf(fcity,"Nombre:%d",&num);
	 longi2=new double[num];
	 latit2=new double[num];
	 for(i=0;i<num;i++){
		fscanf(fcity,"\n%s %lf %lf",string,&latit2[i],&longi2[i]);
		box_ville->AddString(string);
	 }
	 fclose(fcity);
	 box_ville->AddString("Autre");
	 box_ville->SetSelIndex(*numcity);
	 double ll;
	 if (*numcity<num) {ll=longi2[*numcity]; moddi=2;}
	 else {ll=*longi; moddi=0;}
	 sprintf(string,"%lf",ll); edit_longi->SetText(string);
	 //
	 if (*numcity<num) ll=latit2[*numcity];
	 else ll=*latit;
	sprintf(string,"%lf",ll); edit_latit->SetText(string);

  }
void TDialogCarte::DelVille(){
	 // 3e colone : coor de la vue
	 int i;
	 for(i=0;i<=num+1;i++){
		box_ville->DeleteString(0);
	 }
}
void TDialogCarte::DelMerc(){
	 // 3e colone : coor de la vue
	 int i;
	 for(i=DecMax;i>=DecMin;i--){
		box_asc1->DeleteString(0);
	 }
	 for(i=DecMax;i>=DecMin;i--){
		box_asc2->DeleteString(0);
	 }
	 for(i=AscMin;i<=AscMax;i++){
		box_dec1->DeleteString(0);
	 }
	 for(i=AscMin;i<=AscMax;i++){
		box_dec2->DeleteString(0);
	 }
}
void TDialogCarte::DelAzim(){
	 // 3e colone : coor de la vue
		  int i;
	 for(i=0;i<=360;i++){
		box_dec1->DeleteString(0);
	 }
	 for(i=0;i<=360;i++){
		box_dec2->DeleteString(0);
	 }
	 for(i=90;i>=-5;i--){
		box_asc1->DeleteString(0);
	 }
	 for(i=90;i>=-5;i--){
		box_asc2->DeleteString(0);
	 }

  }
  /// -----------------------------------------------------------
  /// -----------------------------------------------------------
void TDialogCarte::EvPaint() {
	 TDialog::EvPaint();
	 }

int TDialogCarte::Execute() {
	 TDialog::Execute();

		 return result;

  }
void TDialogCarte::Ignore() {}
void TDialogCarte::Fin2(){ // cancel
	d->setannee(annee);
	d->setmois(mois);
	d->setjour(jour);
	d->setheure(heure);
	d->miseajour();
	result=1;
  // vide les boites
        int i;
 for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
 for(i=0;i<12;i++) box_mois->DeleteString(0);
 for(i=0;i<31;i++) box_jour->DeleteString(0);
 for(i=0;i<24;i++) box_heure->DeleteString(0);

	 if (lasttype<=3) DelMerc();
	 else DelAzim();

	 for(i=0;i<5;i++) box_type->DeleteString(0);
	 DelVille();
	CloseWindow(result);
}
void TDialogCarte::Fin(){ // fin pour OK
	 result=0;
/// calcul les variables
	 d->setannee(box_annee->GetSelIndex()+anneedebut);
	 d->setmois(box_mois->GetSelIndex()+1);
	 d->setjour(box_jour->GetSelIndex()+1);
	 d->setheure(box_heure->GetSelIndex());
	 d->miseajour();

	 *type=box_type->GetSelIndex()-1;
	 if (*type<=0) *type+=5;

	 if (*type<=3){
		*dec1=90-box_asc1->GetSelIndex();
		*asc1=box_dec1->GetSelIndex();
		*dec2=90-box_asc2->GetSelIndex();
		*asc2=box_dec2->GetSelIndex();
		DelMerc();
	 }
	 else{
		*hau2=90-box_asc1->GetSelIndex();
		*azi1=box_dec1->GetSelIndex();
		*hau1=90-box_asc2->GetSelIndex();
		*azi2=box_dec2->GetSelIndex();
		DelAzim();
	 }
	 *numcity=box_ville->GetSelIndex();
	 char string[40];
	 if (*numcity<num) {*longi=longi2[*numcity];*latit=latit2[*numcity];}
	 else{

		double ll1,ll2;


		edit_longi->GetText(string,7);
		sscanf(string,"%lf",&ll1);
		edit_latit->GetText(string,7);
		sscanf(string,"%lf",&ll2);

		if (ll1>=-90. && ll1<=90. && ll2>=0. && ll2<=360.) {
				*longi=ll1;
				*latit=ll2;
				*numcity=num;
		}
		else {
			*numcity=oldnum;
		}

	 }
	 box_ville->GetString(city,*numcity);

	 sprintf(string,"%d",*numcity);
	 WritePrivateProfileString("Position", "N ville",string,IniFilename);
	 sprintf(string,"%d",(int)(*latit*100.));
	 WritePrivateProfileString("Position", "Latitude", string,IniFilename);
	 sprintf(string,"%d",(int)((*longi+180.)*100.));
	 WritePrivateProfileString("Position", "Longitude", string,IniFilename);
	 WritePrivateProfileString("Position", "Ville", city,IniFilename);
	 
	 DelVille();


//  vide les boites
		 int i;
		 for(i=0;i<anneefin-anneedebut;i++) box_annee->DeleteString(0);
		 for(i=0;i<12;i++) box_mois->DeleteString(0);
		 for(i=0;i<31;i++) box_jour->DeleteString(0);
		 for(i=0;i<24;i++) box_heure->DeleteString(0);
		 for(i=0;i<5;i++) box_type->DeleteString(0);

		CloseWindow(result);
  }
/// -----------------------------------------------------------
/// -----------------------------------------------------------
void TDialogCarte::ModifAnnee(){

	int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();
	  //regarde si annee bixetile ou non et si on est au mois de fevrier
	 if ((year)%4!=0){ //annee non bixetile
			if (mois==1 && box_jour->FindString("29", 0)>=0 ){
					box_jour->DeleteString(28);
					if (day==29) box_jour->SetText("28");
			}
	 }
	 else {
		 if (mois==1 && box_jour->FindString("29", 1)<0 ){
					box_jour->AddString("29");
			}

	 }

}
/// -----------------------------------------------------------
void TDialogCarte::ModifMois(){

	 int year,mois,day;

	 year=box_annee->GetSelIndex()+anneedebut;
	 day=box_jour->GetSelIndex()+1;
	 mois=box_mois->GetSelIndex();

	 if ( box_jour->FindString("29", 0)<0) box_jour->AddString("29");
	 if ( box_jour->FindString("30", 0)<0) box_jour->AddString("30");
	 // il y a au moins trente jours pour chaque mois
	 if (mois==0 || mois==2 || mois==4 || mois==6 || mois==7 || mois==9 || mois==11){
			// mois a 31 jour mais il manque le 31e jour
		  if (box_jour->FindString("31", 0)<0) box_jour->AddString("31");
	 }
	 else{// autres mois sauf fevrier et il y a le 31e jour en trop
			if (mois!=1 && box_jour->FindString("31", 0)>=0 ){
					box_jour->DeleteString(30);
					if (day==31) box_jour->SetText("30");
			}
			else{   // mois de fevrier
				if (mois==1){
					  if ((year)%4!=0){ // annee non bissextile
							if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (box_jour->FindString("29", 0)>=0) box_jour->DeleteString(28);
							if (day>28) box_jour->SetText("28");
					  }
					  else {  // annee bissextile
                   	if (box_jour->FindString("31", 0)>=0) box_jour->DeleteString(30);
							if (box_jour->FindString("30", 0)>=0) box_jour->DeleteString(29);
							if (day>28) box_jour->SetText("29");
					  }
				}
			}
	 }

}
/// -----------------------------------------------------------
void TDialogCarte::ModifJour(){

}

/// -----------------------------------------------------------
void TDialogCarte::ModifType(){
  *type=box_type->GetSelIndex()-1;
  if (*type<=0) *type+=5;

  if (*type<=3 && lasttype>3) {
		DelAzim();
		IniMerc();
  }
  if (*type>3 && lasttype<=3) {
		DelMerc();
		IniAzim();
  }
  lasttype=*type;

}
void TDialogCarte::ModifVille(){
int numi=box_ville->GetSelIndex();
double ll;
char string[15];
	 if (numi<num) {
	 moddi=2;
	 ll=longi2[numi];
	 sprintf(string,"%lf",ll); edit_longi->SetText(string);
	//
	 ll=latit2[numi];
	 sprintf(string,"%lf",ll); edit_latit->SetText(string);
	 }/// if

}
void TDialogCarte::ModifEdit(){
  if (moddi<=0) {box_ville->SetSelIndex(num); moddi=0;}
  else moddi--;
}



/// -----------------------------------------------------------
/// -----------------------------------------------------------


DEFINE_RESPONSE_TABLE1( TDialogCarte, TDialog )
  EV_WM_PAINT,

  EV_COMMAND( IDC_OK, Fin ),
  EV_COMMAND( IDC_CANCEL, Fin2 ),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_ANNEE,ModifAnnee),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_MOIS,ModifMois),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_JOUR,ModifJour),
  EV_CBN_SELCHANGE(IDC_CARTTYPE,ModifType),
  EV_CBN_SELCHANGE(IDC_COMBOBOX_VILLE,ModifVille),
  EV_EN_CHANGE	(IDC_EDIT_LONGI,ModifEdit),
  EV_EN_CHANGE	(IDC_EDIT_LATIT,ModifEdit),

END_RESPONSE_TABLE;

//--------------- TMagnitudesDialog ---------------

void
TMagnitudesDialog::SetupWindow()
{
  TDialog::SetupWindow();
  // -2 -> 6 => *10 => -20 -> 60 ; 80=60-(-20)
  ::SetScrollRange(GetDlgItem(IDC_HSCROLL_MAGNI), SB_CTL, 0, 80, FALSE);
  ::SetScrollPos(GetDlgItem(IDC_HSCROLL_MAGNI), SB_CTL, (int)(Magni*10.0)+20, TRUE);
	char ss[10];
  sprintf(ss,"%3.1lf  ",Magni);
  SetDlgItemText(IDC_AFF_MAGNI, ss);
}

void
TMagnitudesDialog::EvHScroll(UINT scrollCode, UINT thumbPos, HWND WndCtrl)
{
  UINT Pos = ::GetScrollPos(WndCtrl, SB_CTL);
  const int PageStep = 10;

  switch (scrollCode) {
  case SB_LINEUP:
    Pos--;
    break;
  case SB_LINEDOWN:
    Pos++;
    break;
  case SB_PAGEUP:
    Pos -= PageStep;
    break;
  case SB_PAGEDOWN:
    Pos += PageStep;
    break;
  case SB_THUMBPOSITION:
  case SB_THUMBTRACK:
    Pos = thumbPos;
    break;
  }
  ::SetScrollPos(WndCtrl, SB_CTL, Pos, TRUE);

  Magni=(double)(Pos)/10.0-2.0;
  char ss[10];
  sprintf(ss,"%3.1lf  ",Magni);
  SetDlgItemText(IDC_AFF_MAGNI, ss);
}

void
TMagnitudesDialog::CClose()
{

  //*Magnitudes = (double)(::GetScrollPos(GetDlgItem(IDC_HSCROLL_MAGNI), SB_CTL))/10.0;
  *Magnitudes=Magni;
  CloseWindow(IDOK);
}

DEFINE_RESPONSE_TABLE1(TMagnitudesDialog, TDialog)
  EV_WM_HSCROLL,
  EV_COMMAND(IDOK,CClose),

END_RESPONSE_TABLE;




//--------------- TMagnitudesCataDialog ---------------

void
TMagnitudesCataDialog::SetupWindow()
{
  TDialog::SetupWindow();
  char ss[10];
  // magnitude bright star
  // -2 -> 6 => *10 => -20 -> 60 ; 80=60-(-20)
  ::SetScrollRange(GetDlgItem(IDC_HSCROLL_BRIGHT), SB_CTL, 0, 80, FALSE);
  ::SetScrollPos(GetDlgItem(IDC_HSCROLL_BRIGHT), SB_CTL, (int)(Magni*10.0)+20, TRUE);
  sprintf(ss,"%3.1lf  ",Magni);
  SetDlgItemText(IDC_EDIT_BRIGHT, ss);

  // magnitude min catalogue
  // -2 -> 6 => *10 => -20 -> 60 ; 80=60-(-20)
  ::SetScrollRange(GetDlgItem(IDC_HSCROLL_MINCATA), SB_CTL, 0, 180, FALSE);
  ::SetScrollPos(GetDlgItem(IDC_HSCROLL_MINCATA), SB_CTL, (int)(MagniMin*10.0)+20, TRUE);
  sprintf(ss,"%3.1lf  ",MagniMin);
  SetDlgItemText(IDC_EDIT_MINCATA, ss);

  // magnitude max catalogue
  // -2 -> 16 => *10 => -20 -> 160 ; 180=160-(-20)
  ::SetScrollRange(GetDlgItem(IDC_HSCROLL_MAXCATA), SB_CTL, 0, 180, FALSE);
  ::SetScrollPos(GetDlgItem(IDC_HSCROLL_MAXCATA), SB_CTL, (int)(MagniMax*10.0)+20, TRUE);
  sprintf(ss,"%3.1lf  ",MagniMax);
  SetDlgItemText(IDC_EDIT_MAXCATA, ss);
}

void
TMagnitudesCataDialog::EvHScroll(UINT scrollCode, UINT thumbPos, HWND WndCtrl)
{
  UINT Pos = ::GetScrollPos(WndCtrl, SB_CTL);
  const int PageStep = 10;

  switch (scrollCode) {
  case SB_LINEUP:
    Pos--;
    break;
  case SB_LINEDOWN:
    Pos++;
    break;
  case SB_PAGEUP:
    Pos -= PageStep;
    break;
  case SB_PAGEDOWN:
    Pos += PageStep;
    break;
  case SB_THUMBPOSITION:
  case SB_THUMBTRACK:
    Pos = thumbPos;
    break;
  }
  ::SetScrollPos(WndCtrl, SB_CTL, Pos, TRUE);
  char ss[10];
  if(WndCtrl==GetDlgItem(IDC_HSCROLL_BRIGHT)){
		Magni=(double)(Pos)/10.0-2.0;
		sprintf(ss,"%3.2lf  ",Magni);
		SetDlgItemText(IDC_EDIT_BRIGHT, ss);
  }
  if(WndCtrl==GetDlgItem(IDC_HSCROLL_MINCATA)){
		MagniMin=(double)(Pos)/10.0-2.0;
		sprintf(ss,"%3.2lf  ",MagniMin);
		SetDlgItemText(IDC_EDIT_MINCATA, ss);
  }
  if(WndCtrl==GetDlgItem(IDC_HSCROLL_MAXCATA)){
		MagniMax=(double)(Pos)/10.0-2.0;
		sprintf(ss,"%3.2lf  ",MagniMax);
		SetDlgItemText(IDC_EDIT_MAXCATA, ss);
  }
}

void
TMagnitudesCataDialog::CClose()
{

  //*Magnitudes = (double)(::GetScrollPos(GetDlgItem(IDC_HSCROLL_MAGNI), SB_CTL))/10.0;
  *Magnitudes=Magni;
  *MagnitudesMin=MagniMin;
  *MagnitudesMax=MagniMax;
  // mise a jour fichier ini
	char string[40];
	sprintf(string,"%d",(int)(*Magnitudes*100.));
	WritePrivateProfileString( "Catalogue", "Magnitude", string, IniFilename );
	sprintf(string,"%d",(int)(*MagnitudesMax*100.));
	WritePrivateProfileString( "Catalogue", "Magnitude Maximale", string, IniFilename );
	sprintf(string,"%d",(int)(*MagnitudesMin*100.));
	WritePrivateProfileString( "Catalogue", "Magnitude Minimale", string, IniFilename );
   CloseWindow(IDOK);
}

DEFINE_RESPONSE_TABLE1(TMagnitudesCataDialog, TDialog)
  EV_WM_HSCROLL,
  EV_COMMAND(IDOK,CClose),
END_RESPONSE_TABLE;


//-----------------------------------------
// choix du catalogue

static dialogs5Xfer dialogs5Data;

TCatalogueDialog::TCatalogueDialog(TWindow* parent,int *dis,int *cata)
		  : TWindow(parent), TDialog(parent, CATALOGUE) {

				 SetTransferBuffer(&dialogs5Data);
				disk=dis;
				catalog=cata;
				box_LecteurCD=new TComboBox(this,IDC_COMBOBOX_DISK);
				GscCata=new TCheckBox(this,IDC_CHECK_GSC);
		  }

TCatalogueDialog::~TCatalogueDialog(){
 box_LecteurCD->~TComboBox();
 GscCata->~TCheckBox();
}

void TCatalogueDialog::Fin(){
int i;
	/* print the drive letters available */
	for (i=0;i<kk;i++)
	{
		box_LecteurCD->DeleteString(0);
	}
	// mise a jour fichier ini
	char string[40];
	sprintf(string,"%d",*disk);
	WritePrivateProfileString( "Catalogue", "CD-ROM Drive", string, IniFilename );
	sprintf(string,"%d",*catalog);
	WritePrivateProfileString( "Catalogue", "Guide Star Catalog", string, IniFilename );

	CloseWindow(IDOK);
}




	/// -----------------------------------------------------------
void TCatalogueDialog::SetupWindow() {
	 TDialog::SetupWindow();
	 int save, disko,trouv=0;
    kk=0;
    char stringo[10];
	/* save original drive */
	save = getdisk();
	/* print the drive letters available */
	for (disko = 0;disko < 26;++disko)
	{
		setdisk(disko);
		if (disko == getdisk()){
			sprintf(stringo,"%c:", disko + 'a');
			box_LecteurCD->AddString(stringo);
			tabdisk[kk]=disko;
			if (*disk==disko&&trouv==0) {trouv=1;box_LecteurCD->SetSelIndex(kk);}
			kk++;
		}
	}
	setdisk(save);
	if (trouv==0) {box_LecteurCD->SetSelIndex(0);}

   //catalogue choisi
	if (*catalog==1) GscCata->SetCheck(BF_CHECKED);

}

  /// -----------------------------------------------------------
  /// -----------------------------------------------------------


void TCatalogueDialog::ChoixGsc(){
	// GscCata->SetCheck(BF_CHECKED);
   /*
	 void BNClicked();
	 void SetCheck(uint check);
	 uint GetCheck() const;
	 Checked	BF_CHECKED
Unchecked	BF_UNCHECKED
	  */
	  if (*catalog!=1) *catalog=1;
	  else *catalog=0;
}

void TCatalogueDialog::ModifDisk(){
	*disk=tabdisk[box_LecteurCD->GetSelIndex()];
}
/// -----------------------------------------------------------
/// -----------------------------------------------------------


DEFINE_RESPONSE_TABLE1( TCatalogueDialog, TDialog )

	EV_CBN_SELCHANGE(IDC_COMBOBOX_DISK,ModifDisk),
	EV_BN_CLICKED(IDC_CHECK_GSC,ChoixGsc),
	EV_COMMAND(IDOK,Fin),

END_RESPONSE_TABLE;




