#include <owl\dc.h>
#include "cartecie.h"
#include "gsc.h"
#include "horaire.h"
#include <dir.h>

//projection guillaume ou "peter"
void carte_du_ciel(date2 *datum,systeme *sys,TMemoryDC *memdc,HBRUSH pinceau[30],HPEN crayon[30],bool lignes,bool ngcs,bool messier,bool asteroides,double Magnitudes,bool PPrint,bool NB,bool RColor,bool NAME)
{
memdc->SetBkColor(RGB(0,0,70));
 //j'initialise mes variables
int i,k,l;
float r,a;
double ha,hasol,Az;
//float rsol,asol;
int x,y;
int xsol,ysol;
//double x1,x2,y1;
double antea,anter,antex,antey;
int consligne;
//double angle;
int iccon,Couleur;
if (NB==true) iccon=20; else iccon=0;
//j'initialise mes icones
TIcon Galaxie(_hInstance,(TResId)(galaxie-iccon));
TIcon GalaxieSpirale(_hInstance,(TResId)(galaxies-iccon));
TIcon GalaxieSpiraleBarree(_hInstance,(TResId)(galaxiesb-iccon));
TIcon GalaxieElliptique(_hInstance,(TResId)(galaxiee-iccon));
TIcon AmasOuvert(_hInstance,(TResId)(amaso-iccon));
TIcon AmasGlobulaire(_hInstance,(TResId)(amasg-iccon));
TIcon Nebuleuse(_hInstance,(TResId)(nebuleuse-iccon));

TIcon Merc(_hInstance,(TResId)(merc-iccon));
TIcon Venu(_hInstance,(TResId)(venu-iccon));
TIcon Mar(_hInstance,(TResId)(mar-iccon));
TIcon Jupi(_hInstance,(TResId)(jupi-iccon));
TIcon Satu(_hInstance,(TResId)(satu-iccon));
TIcon Plut(_hInstance,(TResId)(pluton-iccon));
TIcon sol(_hInstance,(TResId)(solei-iccon));
TIcon Uranus(_hInstance,(TResId)(uranus-iccon));
TIcon Neptune(_hInstance,(TResId)(neptune-iccon));
TIcon Lune(_hInstance,(TResId)(lune));
TIcon Comet(_hInstance,(TResId)(commet-iccon));

TIcon Eclipse1(_hInstance,(TResId)(ECLIPSE1));
TIcon Eclipse2(_hInstance,(TResId)(ECLIPSE2));


//..............................................................................
//..............................................................................
//..............................................................................
//azimutal!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//sys: pointeur sur le systeme
double longi=sys->getlongitude();       //11.5
double lati=sys->getlatitude();       //45.5
double longitude=0.0;
double latitude=90.0;
if (lati<0) latitude =-90.0;
//modif

date2* datetronquee=new date2();
double H,teta,tsj;//teta temps sideral local a greenwich a0 hUT, tsj le temps en siecle juliens local

//calcul la position des objets
sys->calculposition(datum);


// calcul de teta temps sideral
datetronquee->setjour(datum->getjour());
datetronquee->setmois(datum->getmois());
datetronquee->setannee(datum->getannee());
datetronquee->miseajour();
tsj=datetronquee->getsieclejulien();
teta=6.6460656+2400.051262*tsj+0.00002581*tsj*tsj;
teta=teta/24.0;
teta=teta-floor(teta);
teta=teta*24.0;//temps sideral a greenwich a 0h
teta=teta+(  (double) datum->getheure()+ ( (double)datum->getminute()/60.0 )*1.002737908);
teta=15.0*teta;//nous voila en degre

//fait il jour?????????????????????????
//pour le savoir on calcule la hateur du sol au lmieu considr
				r=sys->getsun()->getdeclinaison();
				a=sys->getsun()->getascensiondroite();
				H=teta-(longi+a);

hasol=rd(  asin ( sin(dr(r))*sin(dr(lati))+cos(dr(r))*cos(dr(lati))*cos(dr(H)) ));

//jour---------------------------------









// dessin du fond
if(PPrint==false) memdc->SelectObject(crayon[2]);
else memdc->SelectObject(crayon[0]);

//LE SOLEIL
				r=sys->getsun()->getdeclinaison();
				a=sys->getsun()->getascensiondroite();
				H=teta-(longitude+a);
if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
		  ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));

if(PPrint==true) memdc->SelectObject(pinceau[1]); //blanc
else {

  // si dans ellipse : il fait jour
  if (hasol>5.0) memdc->SelectObject(pinceau[4]); //jour
  if (hasol>4.0 && hasol<=5.0) memdc->SelectObject(pinceau[29]);
  if (hasol>3.0 && hasol<=4.0) memdc->SelectObject(pinceau[28]);
  if (hasol>2.0 && hasol<=3.0) memdc->SelectObject(pinceau[27]);
  if (hasol>1.0 && hasol<=2.0) memdc->SelectObject(pinceau[26]);
  if (hasol>0.0 && hasol<=1.0) memdc->SelectObject(pinceau[25]);
  if (hasol>-1.0 && hasol<=0.0) memdc->SelectObject(pinceau[24]);
  if (hasol>-3.0 && hasol<=-1.0) memdc->SelectObject(pinceau[23]);
  if (hasol>-5.0 && hasol<=-3.0) memdc->SelectObject(pinceau[22]);
  if (hasol>-10.0 && hasol<=-5.0) memdc->SelectObject(pinceau[21]);
  if (hasol<=-10.0) memdc->SelectObject(pinceau[3]); //nuit

}
//l'ellipse du tour
memdc->Ellipse(sys->ScrL()/2-sys->ScrR(),40,sys->ScrL()/2+sys->ScrR(),40+sys->ScrR()*2);
//l'ellipse de l'equateur celeste
memdc->Ellipse(sys->ScrL()/2-(2.0/3.0)*sys->ScrR(),40+(1.0/3.0)*sys->ScrR(),sys->ScrL()/2+(2.0/3.0)*sys->ScrR(),40+sys->ScrR()*(5.0/3.0));

//l'ellipse de ce qui est visible
memdc->SelectObject(crayon[1]);
if (lati<0) {lati=-lati; longi=longi+180;}
double cor=-0.003778*lati+1.34;//ca sort de mon chapeau(linarisation a l'ordre 1d'une putain de formule)!!!!!!!
//memdc->Ellipse(sys->ScrL()/2-(2.0/3.0)*sys->ScrR()*cor,40+(1.0/3.0)*sys->ScrR()+((90.0-lati)/135.0)*sys->ScrR(),sys->ScrL()/2+(2.0/3.0)*cor*sys->ScrR(),40+sys->ScrR()*(5.0/3.0)+((90.0-lati)/135.0)*sys->ScrR());
Arc(*memdc,sys->ScrL()/2-(2.0/3.0)*sys->ScrR()*cor,40+(1.0/3.0)*sys->ScrR()+((90.0-lati)/135.0)*sys->ScrR(),sys->ScrL()/2+(2.0/3.0)*cor*sys->ScrR(),40+sys->ScrR()*(5.0/3.0)+((90.0-lati)/135.0)*sys->ScrR(),0,0,0,0/*sys->ScrL()/2-(2.0/3.0)*sys->ScrR()*cor,-1000,sys->ScrL()/2+(2.0/3.0)*cor*sys->ScrR(),-1000*/); //haut
//Arc(*memdc,sys->ScrL()/2-(2.0/3.0)*sys->ScrR()*cor,40+(1.0/3.0)*sys->ScrR()+((90.0-lati)/135.0)*sys->ScrR(),sys->ScrL()/2+(2.0/3.0)*cor*sys->ScrR(),40+sys->ScrR()*(5.0/3.0)+((90.0-lati)/135.0)*sys->ScrR(),sys->ScrL()/2-(2.0/3.0)*sys->ScrR()*cor,1000,sys->ScrL()/2+(2.0/3.0)*cor*sys->ScrR(),1000); //bas

longi=-longi;

if (ha>-45.0){
	  ha=((90.0-ha)/135.0)*sys->ScrR();
	  xsol=(int)((sys->ScrL()/2.0)+ha*sin(dr(Az+longi)))-16;
	  ysol=(int)(40+sys->ScrR()+ha*cos(dr(Az+longi)))-16;
	  memdc->DrawIcon(xsol,ysol,sol);

}// if ha





//****************************************
// dessin des lignes entre etoiles

if (lignes==true) {
  memdc->SelectObject(crayon[16]);// crayon pointill bleu
  for(i=0;i<sys->getnbrconstellation();i++){
	 for(l=0;l<sys->getconstellation(i)->Nombre;l++){
	 k=0;
		anter=sys->getconstellation(i)->Star[l]->getdeclinaison();
		antea=sys->getconstellation(i)->Star[l]->getascensiondroite();
		H=teta-(longitude+antea);
		if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(anter))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(anter))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(anter))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(anter))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
		ha=rd(  asin ( sin(dr(anter))*sin(dr(latitude))+cos(dr(anter))*cos(dr(latitude))*cos(dr(H)) ));




		if (ha>-45.0){
	  ha=((90.0-ha)/135.0)*sys->ScrR();
		 antex=(int)((sys->ScrL()/2)+ha*sin(dr(Az+longi)));
		 antey=(int)((40+sys->ScrR())+ha*cos(dr(Az+longi)));//calcul position ds carte

		 consligne=sys->getconstellation(i)->Star[l]->getligne(k);
		  while(consligne>=0 && k<max_lignes){
			r=sys->getconstellation(i)->Star[consligne]->getdeclinaison();
			a=sys->getconstellation(i)->Star[consligne]->getascensiondroite();
			H=teta-(longitude+a);
			if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)
					Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
			else	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
			ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));

			if (ha>-45.0){
	  ha=((90.0-ha)/135.0)*sys->ScrR();
			  x=(int)((sys->ScrL()/2)+ha*sin(dr(Az+longi)));
			  y=(int)((40+sys->ScrR())+ha*cos(dr(Az+longi)));//calcul position ds carte
           //memdc->DrawIcon(x-16,y-16,sol);
			  memdc->MoveTo(antex,antey);
			  memdc->LineTo(x,y);
			}// if ha >0
			k++;
			consligne=sys->getconstellation(i)->Star[l]->getligne(k);
		}// while
	 }// if anteha>0
	 }// for l
  }//for i
}// if ligne=true




//******************************
//dessin des etoiles
double magg;
 if (RColor==false){
	if (PPrint==false){
		memdc->SelectObject(crayon[1]);memdc->SelectObject(pinceau[1]); }
	else {memdc->SelectObject(crayon[0]);memdc->SelectObject(pinceau[0]); }
 }
memdc->SetBkMode(TRANSPARENT);
memdc->SetTextColor(RGB(250,150,100));

int SkyR,SkyG,SkyB;
if (PPrint==true){SkyR=255;SkyG=255;SkyB=255;}
else {
	  // si dans ellipse : il fait jour
  if (hasol>5.0) {SkyR=0;SkyG=0;SkyB=255;} //jour
  if (hasol>4.0 && hasol<=5.0) {i=29;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (hasol>3.0 && hasol<=4.0) {i=28;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (hasol>2.0 && hasol<=3.0) {i=27;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (hasol>1.0 && hasol<=2.0) {i=26;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (hasol>0.0 && hasol<=1.0) {i=25;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (hasol>-1.0 && hasol<=0.0) {i=24;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (hasol>-3.0 && hasol<=-1.0) {i=23;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (hasol>-5.0 && hasol<=-3.0) {i=22;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (hasol>-10.0 && hasol<=-5.0) {i=21;SkyR=0;SkyG=0;SkyB=(float)i*255./10.;}
  if (hasol<=-10.0) {SkyR=0;SkyG=0;SkyB=0;} //nuit
 	
  }
for(i=0;i<sys->getnbrconstellation();i++)
	{
  for(l=0;l<sys->getconstellation(i)->Nombre;l++){
  // choix de la couleur
  if (RColor==true){
		Couleur=CouleurEtoile(sys,i,l);
		memdc->SelectObject(crayon[Couleur]);memdc->SelectObject(pinceau[Couleur]);
  }


//je passe en azimutal
//**************Azimutal*************************
//c'est parti conversion des declin ascdr en azimut hauteur
r=sys->getconstellation(i)->Star[l]->getdeclinaison();
a=sys->getconstellation(i)->Star[l]->getascensiondroite();
H=teta-(longitude+a);
if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
		  ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
//**************************************************

if (ha>-45.0){
	  ha=((90.0-ha)/135.0)*sys->ScrR();
	  x=(int)((sys->ScrL()/2)+ha*sin(dr(Az+longi)));
	  y=(int)((40+sys->ScrR())+ha*cos(dr(Az+longi)));//calcul position ds carte


		 //sauvegarde les coordonnees
		 sys->getconstellation(i)->Star[l]->setx(x);
		 sys->getconstellation(i)->Star[l]->sety(y);
			//
		 magg=sys->getconstellation(i)->Star[l]->getmagnitude();

		 if(magg<Magnitudes) {
				DrawStar(memdc,x,y,magg,CouleurEtoile(sys,i,l),SkyR,SkyG,SkyB,pinceau,crayon,PPrint,NB,RColor,1.,NAME,sys->getconstellation(i)->Star[l]->getnom());
       }

		} // if r
  }//for l
}//for i





//dessin des messier
if(messier==true){
for(i=0;i<sys->getnbrngc();i++)
	{     if (sys->getngc(i)->getabrev()[0]=='M')
	{

	r=sys->getngc(i)->getdeclinaison();
	a=sys->getngc(i)->getascensiondroite();
	//je passe en azimutal
//c'est parti conversion des declin ascdr en azimut hauteur

H=teta-(longitude+a);
if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);
		  ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
//**************************************************

	if (ha>-45.0){
	  ha=((90.0-ha)/135.0)*sys->ScrR();
	  x=(int)((sys->ScrL()/2)+ha*sin(dr(Az+longi)));
	  y=(int)((40+sys->ScrR())+ha*cos(dr(Az+longi)));//calcul position ds carte


		sys->getngc(i)->setx(x);
		sys->getngc(i)->sety(y);
				x-=16;y-=16;
				if(sys->getngc(i)->gettype()==1 ) memdc->DrawIcon(x,y,Nebuleuse);
				if(sys->getngc(i)->gettype()==2 ) memdc->DrawIcon(x,y,AmasGlobulaire);
				if(sys->getngc(i)->gettype()==3 ) memdc->DrawIcon(x,y,AmasOuvert);
				if(sys->getngc(i)->gettype()==4 ) memdc->DrawIcon(x,y,Galaxie);
				if(sys->getngc(i)->gettype()==5 ) memdc->DrawIcon(x,y,GalaxieElliptique);
				if(sys->getngc(i)->gettype()==6 ) memdc->DrawIcon(x,y,GalaxieSpirale);
				if(sys->getngc(i)->gettype()==7 ) memdc->DrawIcon(x,y,GalaxieSpiraleBarree);



	} // if r
	} // if M
}//for i
}



//******************************
//dessin des ngc
if(ngcs==true){
for(i=0;i<sys->getnbrngc();i++)
	{ if (sys->getngc(i)->getabrev()[0]=='N')
	{

	r=sys->getngc(i)->getdeclinaison();
	a=sys->getngc(i)->getascensiondroite();
//je passe en azimutal
//**************Azimutal*************************
//c'est parti conversion des declin ascdr en azimut hauteur
H=teta-(longitude+a);
if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  >0){
	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	}
	else if (sin(dr(H))>0) Az=mespr(180);
		  else Az=mespr(-180);ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
//**************************************************
if (ha>-45.0){
	  ha=((90.0-ha)/135.0)*sys->ScrR();
	  x=(int)((sys->ScrL()/2)+ha*sin(dr(Az+longi)));
	  y=(int)((40+sys->ScrR())+ha*cos(dr(Az+longi)));//calcul position ds carte


		sys->getngc(i)->setx(x);
		sys->getngc(i)->sety(y);
				x-=16;y-=16;
				if(sys->getngc(i)->gettype()==1 ) memdc->DrawIcon(x,y,Nebuleuse);
				if(sys->getngc(i)->gettype()==2 ) memdc->DrawIcon(x,y,AmasGlobulaire);
				if(sys->getngc(i)->gettype()==3 ) memdc->DrawIcon(x,y,AmasOuvert);
				if(sys->getngc(i)->gettype()==4 ) memdc->DrawIcon(x,y,Galaxie);
				if(sys->getngc(i)->gettype()==5 ) memdc->DrawIcon(x,y,GalaxieElliptique);
				if(sys->getngc(i)->gettype()==6 ) memdc->DrawIcon(x,y,GalaxieSpirale);
				if(sys->getngc(i)->gettype()==7 ) memdc->DrawIcon(x,y,GalaxieSpiraleBarree);
				if(sys->getngc(i)->gettype()==8 ) memdc->DrawIcon(x,y,Galaxie);

	} // if r
	}// fi N
}//for i
}



//******************************************************************************
// dessin des cometes
int j=0;
while (sys->tabselected[j]!=-1&& j<2999){
	i=sys->tabselected[j++];

	sys->getcomet(i)->calculposition(datum,sys->getsun());

	r=sys->getcomet(i)->getdeclinaison();
	a=sys->getcomet(i)->getascensiondroite();
	//je passe en azimutal
	//**************Azimutal*************************
	//c'est parti conversion des declin ascdr en azimut hauteur
	H=teta-(longitude+a);
	if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	else	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
	ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
	//**************************************************
	if (ha>-45.0){
	  ha=((90.0-ha)/135.0)*sys->ScrR();
	  x=(int)((sys->ScrL()/2)+ha*sin(dr(Az+longi)));
	  y=(int)((40+sys->ScrR())+ha*cos(dr(Az+longi)));//calcul position ds carte


			 sys->getcomet(i)->setx(x);
			 sys->getcomet(i)->sety(y);
			x-=16;y-=16;
					memdc->DrawIcon(x,y,Comet);

	} // if r

} // while asteroides









//******************************
//dessin des planetes
for(i=0;i<sys->getnbrplanete();i++)
	{
	if (i==2) i++; // saute la Terre
	r=sys->getplanete(i)->getdeclinaison();
	a=sys->getplanete(i)->getascensiondroite();
//je passe en azimutal
//c'est parti conversion des declin ascdr en azimut hauteur
H=teta-(longitude+a);
if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));
//fin azimutal

	if (ha>-45.0){
	  ha=((90.0-ha)/135.0)*sys->ScrR();
	  x=(int)((sys->ScrL()/2)+ha*sin(dr(Az+longi)));
	  y=(int)((40+sys->ScrR())+ha*cos(dr(Az+longi)));//calcul position ds carte
	  // sauvegarde pour information
	  sys->getplanete(i)->setx(x);
	  sys->getplanete(i)->sety(y);


			x-=16;
			y-=16;
			//epuisons les planetes connues
			if(strcmp(sys->getplanete(i)->getnom(),"Mercure")==0)
				{  memdc->DrawIcon(x,y,Merc);}

			if(strcmp(sys->getplanete(i)->getnom(),"Venus")==0)
				{  memdc->DrawIcon(x,y,Venu);}

			if(strcmp(sys->getplanete(i)->getnom(),"Mars")==0)
				{  memdc->DrawIcon(x,y,Mar);}

			if(strcmp(sys->getplanete(i)->getnom(),"Jupiter")==0)
				{  memdc->DrawIcon(x,y,Jupi);}

			if(strcmp(sys->getplanete(i)->getnom(),"Saturne")==0)
				{  memdc->DrawIcon(x,y,Satu);}

			if(strcmp(sys->getplanete(i)->getnom(),"Uranus")==0)
				{  memdc->DrawIcon(x,y,Uranus);}

			if(strcmp(sys->getplanete(i)->getnom(),"Neptune")==0)
				{  memdc->DrawIcon(x,y,Neptune);}

			if(strcmp(sys->getplanete(i)->getnom(),"Pluton")==0)
				{  memdc->DrawIcon(x,y,Plut);
				}

			if(strcmp(sys->getplanete(i)->getnom(),"Planete")==0)
				{  //memdc->DrawIcon(x,y,Plan);
				}

			if(strcmp(sys->getplanete(i)->getnom(),"Asteroide")==0)
				{  //memdc->DrawIcon(x,y,Asteroide);
				}





	  }//if ha >0

	  //}// if 175
}   //for





// pour la lune
r=sys->getplanete(2)->getsatellite(0)->getdeclinaison();
a=sys->getplanete(2)->getsatellite(0)->getascensiondroite();
//je passe en azimutal
//c'est parti conversion des declin ascdr en azimut hauteur
H=teta-(longitude+a);
if(  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) )  <0)  Az=mespr(180+rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
else	Az=mespr(rd(  atan (sin(dr(H))/  ( cos(dr(H))*sin(dr(latitude))-tan(dr(r))*cos(dr(latitude)) ) ) ));
ha=rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));

 if (ha>-45.0){
	  ha=((90.0-ha)/135.0)*sys->ScrR();
	  x=(int)((sys->ScrL()/2)+ha*sin(dr(Az+longi)));
	  y=(int)((40+sys->ScrR())+ha*cos(dr(Az+longi)));//calcul position ds carte




				x-=16;
				y-=16;
				memdc->DrawIcon(x,y,Lune);
				 }
//-----------------------------
// pour les eclipses de soleil
if (abs(r-sys->getsun()->getdeclinaison())<0.3 && abs(a-sys->getsun()->ascensiondroite)<0.3) memdc->DrawIcon(x,y,Eclipse1);


  // destruction des icones
Neptune.~TIcon();
Uranus.~TIcon();
Comet.~TIcon();
Lune.~TIcon();
GalaxieSpirale.~TIcon();
GalaxieSpiraleBarree.~TIcon();
GalaxieElliptique.~TIcon();
AmasOuvert.~TIcon();
AmasGlobulaire.~TIcon();
Galaxie.~TIcon();
Merc.~TIcon();
Venu.~TIcon();
Mar.~TIcon();
Jupi.~TIcon();
Satu.~TIcon();
Plut.~TIcon();
Nebuleuse.~TIcon();
sol.~TIcon();
Eclipse1.~TIcon();
Eclipse2.~TIcon();


memdc->SetBkMode(OPAQUE);

if (PPrint==true) memdc->SetTextColor(RGB(0,0,0));
else memdc->SetTextColor(RGB(0,0,0));

memdc->SetBkMode(TRANSPARENT);
//memdc->TextOut(sys->ScrL()/2-15,28,"Nord",4);
//memdc->TextOut(sys->ScrL()/5-15,30+sys->ScrR()/5,"Est",3);
//memdc->TextOut(sys->ScrL()*4/5-20,30+sys->ScrR()/5,"Ouest",5);
memdc->SetBkMode(OPAQUE);

  }

void Legende(date2 *datum,systeme *sys,TMemoryDC *memdc,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB){
//-------------------
//la legende
int b,a=40,aaa=305,c=14;
int iccon;
if (NB==true) iccon=20; else iccon=0;
TIcon Galaxie(_hInstance,(TResId)(galaxie-iccon));
TIcon GalaxieSpirale(_hInstance,(TResId)(galaxies-iccon));
TIcon GalaxieSpiraleBarree(_hInstance,(TResId)(galaxiesb-iccon));
TIcon GalaxieElliptique(_hInstance,(TResId)(galaxiee-iccon));
TIcon AmasOuvert(_hInstance,(TResId)(amaso-iccon));
TIcon AmasGlobulaire(_hInstance,(TResId)(amasg-iccon));
TIcon Nebuleuse(_hInstance,(TResId)(nebuleuse-iccon));

TIcon Merc(_hInstance,(TResId)(merc-iccon));
TIcon Venu(_hInstance,(TResId)(venu-iccon));
TIcon Mar(_hInstance,(TResId)(mar-iccon));
TIcon Jupi(_hInstance,(TResId)(jupi-iccon));
TIcon Satu(_hInstance,(TResId)(satu-iccon));
TIcon sol(_hInstance,(TResId)(solei-iccon));
TIcon Uranus(_hInstance,(TResId)(uranus-iccon));
TIcon Neptune(_hInstance,(TResId)(neptune-iccon));
TIcon Plut(_hInstance,(TResId)(pluton-iccon));
TIcon Lune(_hInstance,(TResId)(lune));

TIcon Comet(_hInstance,(TResId)(commet-iccon));

TIcon Eclipse1(_hInstance,(TResId)(ECLIPSE1));
TIcon Eclipse2(_hInstance,(TResId)(ECLIPSE2));

	if(PPrint==false){
		memdc->SelectObject(pinceau[18]);
		memdc->SelectObject(crayon[18]);
		memdc->SetTextColor(RGB(0,0,100));
		memdc->SetBkColor(RGB(120,120,200));
	}
	else{
	  memdc->SelectObject(pinceau[1]);
		memdc->SelectObject(crayon[1]);
		memdc->SetTextColor(RGB(200,0,0));
		memdc->SetBkColor(RGB(255,255,255));
	}
	if(PPrint==false){
	  // relief de la boite legende

	}
	else{
		memdc->MoveTo(sys->ScrL(),0);
		memdc->LineTo(sys->ScrL(),sys->ScrH());
	}
 if(NB==true) memdc->SetTextColor(RGB(0,0,0));
 memdc->SetBkMode(TRANSPARENT);
memdc->TextOut(sys->ScrL()+70*(sys->ScrW()-sys->ScrL())/232,2,"LEGENDE",7);

memdc->SetTextColor(RGB(0,0,0));

//memdc->DrawIcon(510,50,Grandeetoile);
if(PPrint==false){
	memdc->SelectObject(crayon[1]);
	memdc->SelectObject(pinceau[1]);
}
else{
	memdc->SelectObject(crayon[0]);
	memdc->SelectObject(pinceau[0]);
}
	memdc->Ellipse(sys->ScrL()+26-3,a-3,sys->ScrL()+26+3,a+3);
	memdc->TextOut(sys->ScrL()+50,a-8,"Etoile M<0",10);

a+=c;
	memdc->Ellipse(sys->ScrL()+26-2,a-2,sys->ScrL()+26+2,a+2);
	memdc->TextOut(sys->ScrL()+50,a-8,"Etoile 0<M<2.5",14);

a+=c;
	memdc->Ellipse(sys->ScrL()+26-1,a-1,sys->ScrL()+26+1,a+1);
	memdc->TextOut(sys->ScrL()+50,a-8,"Etoile 2.5<M<3.5",16);

a+=c;
if(PPrint==false)
	SetPixel(*memdc,sys->ScrL()+26-1,a-1,RGB(255,255,255));
else SetPixel(*memdc,sys->ScrL()+26-1,a-1,RGB(0,0,0));
	memdc->TextOut(sys->ScrL()+50,a-8,"Etoile M>3.5",12);
	

b=a+c;
//planetes
memdc->DrawIcon(sys->ScrL()+10,b,Merc);
memdc->TextOut(sys->ScrL()+50,b+5,"Mercure",7);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Venu);
memdc->TextOut(sys->ScrL()+50,b+5,"Venus",5);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Mar);
memdc->TextOut(sys->ScrL()+50,b+5,"Mars",4);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Jupi);
memdc->TextOut(sys->ScrL()+50,b+5,"Jupiter",7);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Satu);
memdc->TextOut(sys->ScrL()+50,b+5,"Saturne",7);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Uranus);
memdc->TextOut(sys->ScrL()+50,b+5,"Uranus",6);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Neptune);
memdc->TextOut(sys->ScrL()+50,b+5,"Neptune",7);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Plut);
memdc->TextOut(sys->ScrL()+50,b+5,"Pluton",6);

//--------------------
// la phase de la lune
aaa=b+c+6+15;
// moments des phases
  //savoir ou en est l'ombre (quelle  phase)
  double phase1,phase2,partie;
  int i;
  phase1=((datum->getannee()+(datum->getmois()+datum->getjour()/31.0)/12)-1900)*12.3685;
  if (phase1>=0){
		phase2=phase1-floor(phase1);
		if (phase2<0.6&&phase2>0.099) partie=2;
		else partie=1;
  }
  else{
		phase2=phase1-ceil(phase1);
		if (phase2>0.599||phase2<0.1) partie=2;
		else partie=1;
  }
//fraction du disque illuminee
  double frac;
  frac=(sys->getplanete(2)->getsatellite(0)->fractionillumnee(datum,sys->getsun()));

  // dessine la lune dans la legende
  for(i=-8;i<8;i++){
		memdc->SelectObject(crayon[3]);
		if (PPrint==false)memdc->SelectObject(crayon[3]);
		else memdc->SelectObject(crayon[1]);
		memdc->MoveTo(sys->ScrL()+26-8*cos(asin(abs(i)/8.0)),aaa+i);
		memdc->LineTo(sys->ScrL()+26+8*cos(asin(abs(i)/8.0)),aaa+i);
		// partie blanche
		if (PPrint==false)memdc->SelectObject(crayon[1]);
		else memdc->SelectObject(crayon[3]);
		 //	char sstring[2];
	 //	itoa(phase2*10,sstring,10);
	 //	memdc->TextOut(100,100,sstring,1);
		if (partie==1){
		  memdc->MoveTo(sys->ScrL()+26-8*cos(asin(abs(i)/8.0)),aaa+i);
		  memdc->LineTo(sys->ScrL()+26+8*(-1+2.0*frac)*cos(asin(abs(i)/8.0)),aaa+i);
		  }
		else {
		  memdc->MoveTo(sys->ScrL()+26+8*cos(asin(abs(i)/8.0)),aaa+i);
		  memdc->LineTo(sys->ScrL()+26+8*(1-2.0*frac)*cos(asin(abs(i)/8.0)),aaa+i);
		  }

  }
memdc->TextOut(sys->ScrL()+50,aaa-8,"Lune",4);

b=aaa+13;
// objets ngc
memdc->DrawIcon(sys->ScrL()+10,b,Galaxie);
memdc->TextOut(sys->ScrL()+50,b+5,"Galaxie",7);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,GalaxieSpirale);
memdc->TextOut(sys->ScrL()+50,b+5,"Galaxie spirale",15);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,GalaxieSpiraleBarree);
memdc->TextOut(sys->ScrL()+50,b+5,"Galaxie sp. barre",18);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,GalaxieElliptique);
memdc->TextOut(sys->ScrL()+50,b+5,"Galaxie elliptique",18);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,AmasOuvert);
memdc->TextOut(sys->ScrL()+50,b+5,"Amas ouvert",11);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,AmasGlobulaire);
memdc->TextOut(sys->ScrL()+50,b+5,"Amas globulaire",15);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Nebuleuse);
memdc->TextOut(sys->ScrL()+50,b+5,"Nebuleuse",9);
b+=c+2;
memdc->DrawIcon(sys->ScrL()+10,b,Comet);
memdc->TextOut(sys->ScrL()+50,b+5,"Astroides",10);
b+=c+15;
// date
char txt[30];
char txt1[30];
datum->date4(txt1);
sprintf(txt,"Heure GMT : %s",txt1 );
memdc->TextOut(sys->ScrL()+20,b,txt,strlen(txt));
b+=c;
date4l(datum,txt1);
sprintf(txt,"Heure Locale : %s",txt1);
memdc->TextOut(sys->ScrL()+20,b,txt,strlen(txt));
b+=c+10;

// position
memdc->SetBkMode(TRANSPARENT);
sprintf(txt,"Ville : %s",sys->cityname);
memdc->TextOut(sys->ScrL()+20,b,txt,strlen(txt));
b+=c;
sprintf(txt,"Longitude : %4.2lf",sys->getlongitude() );
memdc->TextOut(sys->ScrL()+20,b,txt,strlen(txt));
b+=c;
sprintf(txt,"Latitude : %4.2lf",sys->getlatitude() );
memdc->TextOut(sys->ScrL()+20,b,txt,strlen(txt));


Neptune.~TIcon();
Uranus.~TIcon();
Comet.~TIcon();
Lune.~TIcon();
GalaxieSpirale.~TIcon();
GalaxieSpiraleBarree.~TIcon();
GalaxieElliptique.~TIcon();
AmasOuvert.~TIcon();
AmasGlobulaire.~TIcon();
Galaxie.~TIcon();
Merc.~TIcon();
Venu.~TIcon();
Mar.~TIcon();
Jupi.~TIcon();
Satu.~TIcon();
Plut.~TIcon();
Nebuleuse.~TIcon();
sol.~TIcon();
Eclipse1.~TIcon();
Eclipse2.~TIcon();

}


void affichage_par_secteur(date2 *datum,systeme *sys,TMemoryDC *memdc,int x1,int y1,int x2,int y2,int /*interrupteur*/,HBRUSH pinceau[30],HPEN crayon[30],bool lignes,bool ngcs,bool messier,bool asteroides,double Magnitudes,bool PPrint,bool NB,bool RColor,bool NAME)
{
//sys: pointeur sur le systeme
sys->calculposition(datum);
if (PPrint==false){
memdc->SelectObject(crayon[2]);
memdc->SelectObject(pinceau[3]);
}
else{
memdc->SelectObject(crayon[0]);
memdc->SelectObject(pinceau[1]);
}
memdc->Rectangle(5,30,sys->ScrL()-20,sys->ScrH()-15);


//j'initialise mes variables
int i,Couleur;
float r,a;
int x,y,temp,k;
double antea,anter,antex,antey;
int consligne;
double angle;
int iccon;
if (NB==true) iccon=20; else iccon=0;
//j'initialise mes icones

TIcon Galaxie(_hInstance,(TResId)(galaxie-iccon));
TIcon GalaxieSpirale(_hInstance,(TResId)(galaxies-iccon));
TIcon GalaxieSpiraleBarree(_hInstance,(TResId)(galaxiesb-iccon));
TIcon GalaxieElliptique(_hInstance,(TResId)(galaxiee-iccon));
TIcon AmasOuvert(_hInstance,(TResId)(amaso-iccon));
TIcon AmasGlobulaire(_hInstance,(TResId)(amasg-iccon));
TIcon Nebuleuse(_hInstance,(TResId)(nebuleuse-iccon));

TIcon Merc(_hInstance,(TResId)(merc-iccon));
TIcon Venu(_hInstance,(TResId)(venu-iccon));
TIcon Mar(_hInstance,(TResId)(mar-iccon));
TIcon Jupi(_hInstance,(TResId)(jupi-iccon));
TIcon Satu(_hInstance,(TResId)(satu-iccon));
TIcon sol(_hInstance,(TResId)(solei-iccon));
TIcon Uranus(_hInstance,(TResId)(uranus-iccon));
TIcon Neptune(_hInstance,(TResId)(neptune-iccon));
TIcon Plut(_hInstance,(TResId)(pluton-iccon));
TIcon Lune(_hInstance,(TResId)(lune));

TIcon Comet(_hInstance,(TResId)(commet-iccon));

TIcon Eclipse1(_hInstance,(TResId)(ECLIPSE1));
TIcon Eclipse2(_hInstance,(TResId)(ECLIPSE2));

// afficher l'heure et les coordonnes des coins
 if (PPrint==false) {memdc->SetTextColor(RGB(200,200,200));memdc->SetBkColor(RGB(0,0,0));}
 else {memdc->SetTextColor(RGB(0,0,0));memdc->SetBkColor(RGB(250,250,250));}
//datum->afficherdate(*memdc,7,6,PPrint);

if (PPrint==false) {memdc->SetTextColor(RGB(200,200,200));memdc->SetBkColor(RGB(0,0,0));}
else {memdc->SetTextColor(RGB(0,0,0));memdc->SetBkColor(RGB(255,255,255));}
char inter[3];
char inter2[4];
int xx2=x2,xx1=x1;
if(y1>y2) {temp=y1; y1=y2; y2=temp;}
if (x1<0) x1+=360;
if(x1>=x2) x2+=360;

memdc->SetBkMode(TRANSPARENT);
itoa((int)((float)xx2/15.),inter,10);
  strncat(inter,"h",1);
  memdc->TextOut(7,sys->ScrH()-30,inter,strlen(inter));
itoa((int)((float)xx1/15.),inter,10);
  strncat(inter,"h",1);
  memdc->TextOut(sys->ScrL()-50,sys->ScrH()-30,inter,strlen(inter));
itoa(y2,inter2,10);
  strncat(inter2,"",1);
  memdc->TextOut(sys->ScrL()-50,32,inter2,strlen(inter2));
itoa(y1,inter2,10);
  strncat(inter2,"",1);
  memdc->TextOut(sys->ScrL()-50,sys->ScrH()-50,inter2,strlen(inter2));

//je met a jour l'heure des ascensions droite->en deg
//x1=x1*15;
//x2=x2*15;

//if(x1>x2) {temp=x1; x1=x2; x2=temp;}
//if(y1>y2) {temp=y1; y1=y2; y2=temp;}

int sauvex1,sauvex2,sauvey1,sauvey2;
sauvex1=x1;
sauvex2=x2;
sauvey1=y1;
sauvey2=y2;

//j'aime pas les divisions par 0
if((x1==x2) || (y1==y2)) {(x1=x1+1);y1=y1+1;}//goto fincausediv0;

//****************************************
// dessin des lignes entre etoiles
int l;
if (lignes==true) {
  memdc->SelectObject(crayon[16]);// crayon pointill bleu
  for(i=0;i<sys->getnbrconstellation();i++){
	for(l=0;l<sys->getconstellation(i)->Nombre;l++){
	 k=0;
	 anter=sys->getconstellation(i)->Star[l]->getdeclinaison();
	antea=sys->getconstellation(i)->Star[l]->getascensiondroite();

			 anter=90.0-anter;
			 y1=90-y1;
			 y2=90-y2;

			 if(antea<x1) antea+=360;
			 antey=(int)(sys->ScrH()-15 -((anter-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 antex=(int)(sys->ScrL()-20 -((antea-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));
			 //restauration apres le bordel
				x1=sauvex1;
				x2=sauvex2;
				y1=sauvey1;
				y2=sauvey2;
			 if (antex>5&&antex<sys->ScrL()-20&&antey>30&&antey<sys->ScrH()-15){

		  consligne=sys->getconstellation(i)->Star[l]->getligne(k);
		  while(consligne>=0 && k<max_lignes){
			r=sys->getconstellation(i)->Star[consligne]->getdeclinaison();
			a=sys->getconstellation(i)->Star[consligne]->getascensiondroite();


			 r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));
          //restauration apres le bordel
				x1=sauvex1;
				x2=sauvex2;
				y1=sauvey1;
				y2=sauvey2;
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){

		  if (abs(antex-x)>sys->ScrL()/2 ){   // probleme au bord
				if (antex>sys->ScrL()-sys->ScrL()/4 && x<sys->ScrL()/4){
				  memdc->MoveTo(antex,antey);
				  memdc->LineTo(sys->ScrL()-20,antey+(y-antey)*(sys->ScrL()-20-antex)/(sys->ScrL()-20-antex+x-5));
				  memdc->MoveTo(5,antey+(y-antey)*(sys->ScrL()-20-antex)/(sys->ScrL()-20-antex+x-5));
				  memdc->LineTo(x,y);
				 }
				 if (x>sys->ScrL()-sys->ScrL()/4 && antex<sys->ScrL()/4){
				  memdc->MoveTo(x,y);
				  memdc->LineTo(sys->ScrL()-20,y+(antey-y)*(sys->ScrL()-20-x)/(sys->ScrL()-20-x+antex-5));
				  memdc->MoveTo(5,y+(antey-y)*(sys->ScrL()-20-x)/(sys->ScrL()-20-x+antex-5));
				  memdc->LineTo(antex,antey);
				 }
			 }// if abs
			 else {
			  memdc->MoveTo(antex,antey);
			  memdc->LineTo(x,y);
			 } //else
			}// if r<120
			k++;
			consligne=sys->getconstellation(i)->Star[l]->getligne(k);
		}// while
	 }// if anter
	 }//for l
  }//for i
}// if ligne=true

//******************************
//dessin des etoiles
double magg;
int SkyR,SkyG,SkyB;
if (PPrint==false){SkyR=0;SkyG=0;SkyB=0;}
else {SkyR=255;SkyG=255;SkyB=255;}
//------------------------
// guide star catalog


if(abs(y1-y2)<20 && abs(x1-x2)<20 && *sys->GuideStarCatalog==1){ // dimensions assez petites
	int save;
	save = getdisk();
	//double coefff=-0.01*(abs(y1-y2)*abs(x1-x2))+3;
	int iii,result=IDOK,n;
	char filename[15];
	char dirname[50];
	char allname[50];
	double ascc1,ascc2,decc1,decc2;
	if (y1>y2) {decc1=y2;decc2=y1;}
	else {decc1=y1;decc2=y2;}
	if (x1>x2) {ascc1=x2;ascc2=x1;}
	else {ascc1=x1;ascc2=x2;}
	FILE * fitfile;
	ListeFichierGsc tableau;
   GscInfo StarInfo;
	tableau=LireFichierRegion (*sys->disk,ascc1,ascc2,decc1,decc2);
  //	printf("%d\n",tableau.Nombre);
	//--------
	for(iii=0;iii<tableau.Nombre;iii++){
  // for(iii=0;iii<1;iii++){
	  if(tableau.Numero[iii]<10000) sprintf(filename,"%d.gsc",tableau.Numero[iii]);
	  if(tableau.Numero[iii]<1000) sprintf(filename,"0%d.gsc",tableau.Numero[iii]);
	  if(tableau.Numero[iii]<100) sprintf(filename,"00%d.gsc",tableau.Numero[iii]);
	  if(tableau.Numero[iii]<10) sprintf(filename,"000%d.gsc",tableau.Numero[iii]);

	  if (tableau.Numero[iii]>=9490 &&tableau.Numero[iii]<9537)strcpy(dirname,"gsc\\S8230\\");
	if (tableau.Numero[iii]>=9346 &&tableau.Numero[iii]<9490)strcpy(dirname,"gsc\\S7500\\");
	if (tableau.Numero[iii]>=9134 &&tableau.Numero[iii]<9346)strcpy(dirname,"gsc\\S6730\\");
	if (tableau.Numero[iii]>=8840 &&tableau.Numero[iii]<9134)strcpy(dirname,"gsc\\S6000\\");
	if (tableau.Numero[iii]>=8464 &&tableau.Numero[iii]<8840)strcpy(dirname,"gsc\\S5230\\");
	if (tableau.Numero[iii]>=8022 &&tableau.Numero[iii]<8464)strcpy(dirname,"gsc\\S4500\\");
	if (tableau.Numero[iii]>=7523 &&tableau.Numero[iii]<8022)strcpy(dirname,"gsc\\S3730\\");
	if (tableau.Numero[iii]>=6989 &&tableau.Numero[iii]<7523)strcpy(dirname,"gsc\\S3000\\");
	if (tableau.Numero[iii]>=6412 &&tableau.Numero[iii]<6989)strcpy(dirname,"gsc\\S2230\\");
	if (tableau.Numero[iii]>=5838 &&tableau.Numero[iii]<6412)strcpy(dirname,"gsc\\S1500\\");
	if (tableau.Numero[iii]>=5260 &&tableau.Numero[iii]<5838)strcpy(dirname,"gsc\\S0730\\");
	if (tableau.Numero[iii]>=4663 &&tableau.Numero[iii]<5260)strcpy(dirname,"gsc\\S0000\\");
	if (tableau.Numero[iii]>=4615 &&tableau.Numero[iii]<4663)strcpy(dirname,"gsc\\N8230\\");
	if (tableau.Numero[iii]>=4492 &&tableau.Numero[iii]<4615)strcpy(dirname,"gsc\\N7500\\");
	if (tableau.Numero[iii]>=4294 &&tableau.Numero[iii]<4492)strcpy(dirname,"gsc\\N6730\\");
	if (tableau.Numero[iii]>=4014 &&tableau.Numero[iii]<4294)strcpy(dirname,"gsc\\N6000\\");
	if (tableau.Numero[iii]>=3652 &&tableau.Numero[iii]<4014)strcpy(dirname,"gsc\\N5230\\");
	if (tableau.Numero[iii]>=3246 &&tableau.Numero[iii]<3652)strcpy(dirname,"gsc\\N4500\\");
	if (tableau.Numero[iii]>=2781 &&tableau.Numero[iii]<3246)strcpy(dirname,"gsc\\N3730\\");
	if (tableau.Numero[iii]>=2259 &&tableau.Numero[iii]<2781)strcpy(dirname,"gsc\\N3000\\");
	if (tableau.Numero[iii]>=1729 &&tableau.Numero[iii]<2259)strcpy(dirname,"gsc\\N2230\\");
	if (tableau.Numero[iii]>=1178 &&tableau.Numero[iii]<1729)strcpy(dirname,"gsc\\N1500\\");
	if (tableau.Numero[iii]>=594 &&tableau.Numero[iii]<1178)strcpy(dirname,"gsc\\N0730\\");
	if (tableau.Numero[iii]>=0 &&tableau.Numero[iii]<594)strcpy(dirname,"gsc\\N0000\\");

	  sprintf(allname,"%c:\\%s%s",'a'+*sys->disk,dirname,filename);

	fitfile=fopen(allname,"rb");
	  if ( fitfile==NULL && result==IDOK){
		  fclose(fitfile);
		  if(tableau.Numero[iii]>=5260)
				result=MessageBox(0,"Insrez le CD-Rom n 2 du Guide Star Catalog","Fichier introuvable",MB_OKCANCEL);
		  else
				result=MessageBox(0,"Insrez le CD-Rom n 1 du Guide Star Catalog","Fichier introuvable",MB_OKCANCEL);
		  if (result==IDOK) fitfile=fopen(allname,"rb");
		  else {
				iii=tableau.Nombre;// pour pas boucler 10000 fois
		  }
	  }

		if (result==IDOK){

			n=AllerDebutFichierGSC(fitfile);
			while (n-->0)
			{
				StarInfo=LireGSC(fitfile);
				// afficher etoile
				//------------
				StarInfo.dec=90.0-StarInfo.dec;
				 y1=90-y1;
				y2=90-y2;
				 if(StarInfo.asc<x1) StarInfo.asc+=360;
				y=(int)(sys->ScrH()-15 -((StarInfo.dec-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
				 x=(int)(sys->ScrL()-20 -((StarInfo.asc-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));


				
				 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
					magg=StarInfo.mag;
				//	SetPixel(*memdc,x,y,RGB(255,255,255));
					if (magg<*sys->MinMagni && magg>*sys->MaxMagni)
							DrawStar(memdc,x,y,magg,1,SkyR,SkyG,SkyB,pinceau,crayon,PPrint,NB,RColor,3.,NAME,"");
							
				 }// if x>
				x1=sauvex1;
				x2=sauvex2;
				y1=sauvey1;
				y2=sauvey2;
			  }// while
			//--------
			//printf("\nasc: %lf\ndec: %lf\nmag :%lf\n",StarInfo.asc,StarInfo.dec,StarInfo.mag);
			fclose(fitfile);

		  } // if result=idok
	  }   // for
	  setdisk(save);
}//if  fenetre trop grande

	  //---------------

 if (RColor==false){
	if (PPrint==false){
		memdc->SelectObject(crayon[1]);memdc->SelectObject(pinceau[1]); }
	else {memdc->SelectObject(crayon[0]);memdc->SelectObject(pinceau[0]); }
 }
memdc->SetBkMode(TRANSPARENT);
memdc->SetTextColor(RGB(250,150,100));

for(i=0;i<sys->getnbrconstellation();i++)
	{
  for(l=0;l<sys->getconstellation(i)->Nombre;l++){
  // choix de la couleur
  if (RColor==true){
		Couleur=CouleurEtoile(sys,i,l);
		memdc->SelectObject(crayon[Couleur]);memdc->SelectObject(pinceau[Couleur]);
  }
	r=sys->getconstellation(i)->Star[l]->getdeclinaison();
	a=sys->getconstellation(i)->Star[l]->getascensiondroite();
			 r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

			 sys->getconstellation(i)->Star[l]->setx(x);
			 sys->getconstellation(i)->Star[l]->sety(y);
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
	  magg=sys->getconstellation(i)->Star[l]->getmagnitude()+0.01;
				if(magg<Magnitudes) DrawStar(memdc,x,y,magg,CouleurEtoile(sys,i,l),SkyR,SkyG,SkyB,pinceau,crayon,PPrint,NB,RColor,1.,NAME,sys->getconstellation(i)->Star[l]->getnom());

			  }// if x>
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;

  }//for l
}//for i




/*

//******************************
// dessin de la voie lactee

bool lactee=true;
if (lactee==true){
	int tabx[89],taby[89]; // l1->89, l2->74
	double r,a;
	int i;
	for(i=0;i<89;i++) {
		a=sys->getlactee()->getascensiondroite(1,i);
		r=sys->getlactee()->getdeclinaison(1,i);
			 r=90.0-r;
			 a=360.0-a;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			 if(a>x2) a-=360;
			 taby[i]=(int)(495.0 -((r-(float)y1)*490)/((float)y2-(float)y1));
			 tabx[i]=(int)(495.0 -((a-(float)x1)*490)/((float)x2-(float)x1));
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
	}
	bipoint *result;
	//bipoint *nuevo;
	memdc->SelectObject(crayon[10]);
	 //dessin de la premiere ligne
		//result=multiplication(tabx,taby,89,2);//rajoute des points
		for(i=0;i<88;i++){

		  //nuevo=nouveaux_pts(result[i],result[i+1]);
		  //memdc->MoveTo(nuevo[0].x,nuevo[0].y);
		  //memdc->LineTo(nuevo[1].x,nuevo[1].y);
		  memdc->MoveTo(tabx[i],taby[i]);
		  memdc->LineTo(tabx[i+1],taby[i+1]);
		}

		for(i=0;i<74;i++) {
		a=sys->getlactee()->getascensiondroite(2,i);
		r=sys->getlactee()->getdeclinaison(2,i);
			 r=90.0-r;
			 a=360.0-a;
			 y1=90-y1;
			 y2=90-y2;
			 x1=360-x1;
			 x2=360-x2; //ouf, chang de repere
			 if(a>x2) a-=360;
			 taby[i]=(int)(495.0 -((r-(float)y1)*490)/((float)y2-(float)y1));
			 tabx[i]=(int)(495.0 -((a-(float)x1)*490)/((float)x2-(float)x1));
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
	}
  //	bipoint *result;
	//bipoint *nuevo;
	memdc->SelectObject(crayon[1]);
	 //dessin de la premiere ligne
		//result=multiplication(tabx,taby,89,2);//rajoute des points
		for(i=0;i<74;i++){

		  //nuevo=nouveaux_pts(result[i],result[i+1]);
		  //memdc->MoveTo(nuevo[0].x,nuevo[0].y);
		  //memdc->LineTo(nuevo[1].x,nuevo[1].y);
		  memdc->MoveTo(tabx[i],taby[i]);
		  memdc->LineTo(tabx[i+1],taby[i+1]);
		}

}// if lactee
 */
//******************************
//dessin des Messier
if(messier==true){
for(i=0;i<sys->getnbrngc();i++)
{ if (sys->getngc(i)->getabrev()[0]=='M')
	{

	r=sys->getngc(i)->getdeclinaison();
	a=sys->getngc(i)->getascensiondroite();

	   r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

			 sys->getngc(i)->setx(x);
			 sys->getngc(i)->sety(y);
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
				x-=16;y-=16;

				if(sys->getngc(i)->gettype()==1 ) memdc->DrawIcon(x,y,Nebuleuse);
				if(sys->getngc(i)->gettype()==2 ) memdc->DrawIcon(x,y,AmasGlobulaire);
				if(sys->getngc(i)->gettype()==3 ) memdc->DrawIcon(x,y,AmasOuvert);
				if(sys->getngc(i)->gettype()==4 ) memdc->DrawIcon(x,y,Galaxie);
				if(sys->getngc(i)->gettype()==5 ) memdc->DrawIcon(x,y,GalaxieElliptique);
				if(sys->getngc(i)->gettype()==6 ) memdc->DrawIcon(x,y,GalaxieSpirale);
				if(sys->getngc(i)->gettype()==7 ) memdc->DrawIcon(x,y,GalaxieSpiraleBarree);
				} // if x>
	  x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
	}// if M

}//for i
} //if ngc
if(ngcs==true){
for(i=0;i<sys->getnbrngc();i++)
{ if (sys->getngc(i)->getabrev()[0]=='N')
	{

	r=sys->getngc(i)->getdeclinaison();
	a=sys->getngc(i)->getascensiondroite();

	   r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

			 sys->getngc(i)->setx(x);
			 sys->getngc(i)->sety(y);
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
				x-=16;y-=16;

				if(sys->getngc(i)->gettype()==1 ) memdc->DrawIcon(x,y,Nebuleuse);
				if(sys->getngc(i)->gettype()==2 ) memdc->DrawIcon(x,y,AmasGlobulaire);
				if(sys->getngc(i)->gettype()==3 ) memdc->DrawIcon(x,y,AmasOuvert);
				if(sys->getngc(i)->gettype()==4 ) memdc->DrawIcon(x,y,Galaxie);
				if(sys->getngc(i)->gettype()==5 ) memdc->DrawIcon(x,y,GalaxieElliptique);
				if(sys->getngc(i)->gettype()==6 ) memdc->DrawIcon(x,y,GalaxieSpirale);
				if(sys->getngc(i)->gettype()==7 ) memdc->DrawIcon(x,y,GalaxieSpiraleBarree);
				if(sys->getngc(i)->gettype()==8 ) memdc->DrawIcon(x,y,Galaxie);
				} // if x>
	  x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
} // if N
}//for i
} //if ngc

//******************************************************************************
// dessin des cometes
int j=0;
while (sys->tabselected[j]!=-1 && j<2999){
	i=sys->tabselected[j++];

	sys->getcomet(i)->calculposition(datum,sys->getsun());
	r=sys->getcomet(i)->getdeclinaison();
	a=sys->getcomet(i)->getascensiondroite();
			 r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

			 sys->getcomet(i)->setx(x);
			 sys->getcomet(i)->sety(y);


			 // sauvegarde

			 // affichage
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
					x-=16;y-=16;
					memdc->DrawIcon(x,y,Comet);

			 }// if x>
          x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;

} // while asteroides

//****************************
// pour le soleil

r=sys->getsun()->getdeclinaison();
a=sys->getsun()->getascensiondroite();

			  r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
// soleil en taille reel
					 float lx,ly;
					 lx=0.533/2.;
					 ly=lx/float(y2-y1)*(sys->ScrH()-55);
					 lx=lx/float(x2-x1)*(sys->ScrH()-55);
					 if(lx<0) lx=-lx;
					 if(ly<0) ly=-ly;
					 if(lx<3.) lx=3.;
					 if(ly<3.) ly=3.;
					 if(NB==false){
					 memdc->SelectObject(pinceau[6]);
					 memdc->SelectObject(crayon[6]);
					 }
					 else {
					 memdc->SelectObject(pinceau[3]);
					 memdc->SelectObject(crayon[3]);
					 }
						 memdc->Ellipse(x-lx,y-ly,x+lx,y+ly);
					 /*
					y-=16;
			 		x-=16;


					 memdc->DrawIcon(x,y,sol);
					 */

		}

		//restauration apres le bordel
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
//*************************************************
//lecture du tableau de planete jusqu'a epuisement
for(i=0;i<sys->getnbrplanete();i++)
		{
  if (i==2) i++; // saute la Terre
	angle=sys->getplanete(2)->getlongitude()-sys->getplanete(i)->getlongitude();
  if (angle<-180) angle+=360;
  if (angle>180) angle-=360;
  if (abs(angle)<177){
	r=sys->getplanete(i)->getdeclinaison();
	a=sys->getplanete(i)->getascensiondroite();

			  r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

		 // sauvegarde pour information
		 sys->getplanete(i)->setx(x);
		 sys->getplanete(i)->sety(y);
		 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
			 y-=16;
			 x-=16;
			//epuisons les objets connus

			if(strcmp(sys->getplanete(i)->getnom(),"Mercure")==0)
				{  memdc->DrawIcon(x,y,Merc);}

			if(strcmp(sys->getplanete(i)->getnom(),"Venus")==0)
				{  memdc->DrawIcon(x,y,Venu);}

			if(strcmp(sys->getplanete(i)->getnom(),"Mars")==0)
				{  memdc->DrawIcon(x,y,Mar);}

			if(strcmp(sys->getplanete(i)->getnom(),"Jupiter")==0)
				{  memdc->DrawIcon(x,y,Jupi);}

			if(strcmp(sys->getplanete(i)->getnom(),"Saturne")==0)
				{  memdc->DrawIcon(x,y,Satu);}

			if(strcmp(sys->getplanete(i)->getnom(),"Uranus")==0)
				{  memdc->DrawIcon(x,y,Uranus);}

			if(strcmp(sys->getplanete(i)->getnom(),"Neptune")==0)
				{  memdc->DrawIcon(x,y,Neptune);}

			if(strcmp(sys->getplanete(i)->getnom(),"Pluton")==0)
				{  memdc->DrawIcon(x,y,Plut);
				}
			} // si dans fenetere
			//restauration apres le bordel
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;

	  /*
	  // pour les satellites
	  for (k=0;k<sys->getplanete(i)->getnbrsatellite();k++){
			r=sys->getplanete(i)->getsatellite(k)->getdeclinaison();
			 a=sys->getplanete(i)->getsatellite(k)->getascensiondroite();

			 if(((y1<r) && (r<y2)) && ((x1<a) && (a<x2))){ //si visible ds la fenetre demande
					 r=90.0-r;
					 a=360.0-a;
					 y1=90-y1;
					 y2=90-y2;
					 x1=360-x1;
					 x2=360-x2; //ouf, chang de repere
			 if(a>x2) a-=360;
					 y=(int)(495.0 -((r-(float)y1)*490)/((float)y2-(float)y1));
					 x=(int)(495.0 -((a-(float)x1)*490)/((float)x2-(float)x1));
					 y-=16;
					 x-=16;

					 if(strcmp(sys->getplanete(i)->getsatellite(k)->getnom(),"lune")==0)
					 {  memdc->DrawIcon(x,y,Lune);}
					 else memdc->DrawIcon(x,y,Plan);

			  }
	  //restauration apres le bordel
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
			}
			 */
	  }// if 170
}  // for planete
//************************************
 // pour la lune

			r=sys->getplanete(2)->getsatellite(0)->getdeclinaison();
			 a=sys->getplanete(2)->getsatellite(0)->getascensiondroite();

				  r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
					 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

					 sys->getplanete(2)->getsatellite(0)->setx(x);
					 sys->getplanete(2)->getsatellite(0)->sety(y);
					 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){

			 // affiche lune avec son vrai diametre
			 double lx,ly;
					 lx=180./M_PI*sys->getplanete(2)->getsatellite(0)->getrayon()/1000*sys->getplanete(2)->getsatellite(0)->getdistancealamere();
					 ly=lx/float(y2-y1)*(sys->ScrH()-55);
					 lx=lx/float(x2-x1)*(sys->ScrH()-55);
                if(lx<0) lx=-lx;
					 if(ly<0) ly=-ly;
					 if(lx<3.) lx=3.;
					 if(ly<3.) ly=3.;
					 if(NB==false){
					 memdc->SelectObject(pinceau[1]);
					 memdc->SelectObject(crayon[1]);
					 }
					 else {
					 memdc->SelectObject(pinceau[3]);
					 memdc->SelectObject(crayon[3]);
					 }
					 memdc->Ellipse(x-lx,y-ly,x+lx,y+ly);


			  //	  x-=16;y-=16;		memdc->DrawIcon(x,y,Lune);

			  }
	  //restauration apres le bordel
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;

			fincausediv0 :


Neptune.~TIcon();
Uranus.~TIcon();
Comet.~TIcon();
Lune.~TIcon();
GalaxieSpirale.~TIcon();
GalaxieSpiraleBarree.~TIcon();
GalaxieElliptique.~TIcon();
AmasOuvert.~TIcon();
AmasGlobulaire.~TIcon();
Galaxie.~TIcon();
Merc.~TIcon();
Venu.~TIcon();
Mar.~TIcon();
Jupi.~TIcon();
Satu.~TIcon();
Plut.~TIcon();
Nebuleuse.~TIcon();
sol.~TIcon();
Eclipse1.~TIcon();
Eclipse2.~TIcon();




}

void affichage_par_secteur_trainee(date2 *datum,systeme *sys,TMemoryDC *memdc,int x1,int y1,int x2,int y2,HBRUSH pinceau[30],HPEN crayon[30],bool lignes,bool ngcs,bool messier,bool asteroides,double Magnitudes,bool PPrint,bool NB,bool RColor,bool NAME)
{

 int pas =24;
 int nbrj =500;
 int Couleur;
 date2*datum2;
 datum2=new date2();
 SetCursor(LoadCursor(NULL, (TResId)IDC_WAIT));
// dessin du cadre
if (PPrint==false) {
memdc->SelectObject(crayon[2]);
memdc->SelectObject(pinceau[3]);
}
else {
memdc->SelectObject(crayon[0]);
memdc->SelectObject(pinceau[1]);
}
memdc->Rectangle(5,30,sys->ScrL()-20,sys->ScrH()-15);


//j'initialise mes variables
int i,j;
float r,a;
double x,y,temp,k,xold,yold;
double antea,anter,antex,antey;
int consligne;
//double angle;
int iccon;
if (NB==true) iccon=20; else iccon=0;
//j'initialise mes icones

TIcon Galaxie(_hInstance,(TResId)(galaxie-iccon));
TIcon GalaxieSpirale(_hInstance,(TResId)(galaxies-iccon));
TIcon GalaxieSpiraleBarree(_hInstance,(TResId)(galaxiesb-iccon));
TIcon GalaxieElliptique(_hInstance,(TResId)(galaxiee-iccon));
TIcon AmasOuvert(_hInstance,(TResId)(amaso-iccon));
TIcon AmasGlobulaire(_hInstance,(TResId)(amasg-iccon));
TIcon Nebuleuse(_hInstance,(TResId)(nebuleuse-iccon));


TIcon sol(_hInstance,(TResId)(solei-iccon));
TIcon Lune(_hInstance,(TResId)(lune));
TIcon Comet(_hInstance,(TResId)(lune));

TIcon Eclipse1(_hInstance,(TResId)(ECLIPSE1));
TIcon Eclipse2(_hInstance,(TResId)(ECLIPSE2));
// afficher l'heure et les coordonnes des coins
 if (PPrint==false) {memdc->SetTextColor(RGB(200,200,200));memdc->SetBkColor(RGB(0,0,0));}
 else {memdc->SetTextColor(RGB(0,0,0));memdc->SetBkColor(RGB(250,250,250));}

 if (PPrint==false) {memdc->SetTextColor(RGB(200,200,200));memdc->SetBkColor(RGB(0,0,0));}
 else {memdc->SetTextColor(RGB(0,0,0));memdc->SetBkColor(RGB(250,250,250));}
char inter[3];
char inter2[4];
int xx2=x2,xx1=x1;
if(y1>y2) {temp=y1; y1=y2; y2=temp;}
if (x1<0) x1+=360;
if(x1>=x2) x2+=360;

memdc->SetBkMode(TRANSPARENT);
itoa((int)((float)xx2/15.),inter,10);
  strncat(inter,"h",1);
  memdc->TextOut(7,sys->ScrH()-30,inter,strlen(inter));
itoa((int)((float)xx1/15.),inter,10);
  strncat(inter,"h",1);
  memdc->TextOut(sys->ScrL()-50,sys->ScrH()-30,inter,strlen(inter));
itoa(y2,inter2,10);
  strncat(inter2,"",1);
  memdc->TextOut(sys->ScrL()-50,32,inter2,strlen(inter2));
itoa(y1,inter2,10);
  strncat(inter2,"",1);
  memdc->TextOut(sys->ScrL()-50,sys->ScrH()-50,inter2,strlen(inter2));


int sauvex1,sauvex2,sauvey1,sauvey2;
sauvex1=x1;
sauvex2=x2;
sauvey1=y1;
sauvey2=y2;

//j'aime pas les divisions par 0
//if((x1==x2) || (y1==y2)) goto fincausediv0;
  if(x1==x2) x1=x2+1;
  if(y1==y2) y1=y2+1;
int l;
//int sx,sy;
//int ax1,ay1;
//bool restart=true;

//******************************************
// voie lactee


//****************************************
// dessin des lignes entre etoiles
if (lignes==true) {
  memdc->SelectObject(crayon[16]);// crayon pointille bleu
  for(i=0;i<sys->getnbrconstellation();i++){
	for(l=0;l<sys->getconstellation(i)->Nombre;l++){
	 k=0;
	 anter=sys->getconstellation(i)->Star[l]->getdeclinaison();
	antea=sys->getconstellation(i)->Star[l]->getascensiondroite();

			 anter=90.0-anter;
			 y1=90-y1;
			 y2=90-y2;
			 if(antea<x1) antea+=360;
			 antey=(int)(sys->ScrH()-15 -((anter-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 antex=(int)(sys->ScrL()-20 -((antea-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

							//restauration apres le bordel
				x1=sauvex1;
				x2=sauvex2;
				y1=sauvey1;
				y2=sauvey2;
		  consligne=sys->getconstellation(i)->Star[l]->getligne(k);
		  while(consligne>=0 && k<max_lignes){
			r=sys->getconstellation(i)->Star[consligne]->getdeclinaison();
			a=sys->getconstellation(i)->Star[consligne]->getascensiondroite();

			  r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

			 //restauration apres le bordel
				x1=sauvex1;
				x2=sauvex2;
				y1=sauvey1;
				y2=sauvey2;
            // if dans fenetre:
           if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15&&antex>5&&antex<sys->ScrL()-20&&antey>30&&antey<sys->ScrH()-15){

			  if (abs(antex-x)>sys->ScrL()/2 ){   // probleme au bord
				if (antex>sys->ScrL()-sys->ScrL()/4 && x<sys->ScrL()/4){
				  memdc->MoveTo(antex,antey);
				  memdc->LineTo(sys->ScrL()-20,antey+(y-antey)*(sys->ScrL()-20-antex)/(sys->ScrL()-20-antex+x-5));
				  memdc->MoveTo(5,antey+(y-antey)*(sys->ScrL()-20-antex)/(sys->ScrL()-20-antex+x-5));
				  memdc->LineTo(x,y);
				 }
				 if (x>sys->ScrL()-sys->ScrL()/4 && antex<sys->ScrL()/4){
				  memdc->MoveTo(x,y);
				  memdc->LineTo(sys->ScrL()-20,y+(antey-y)*(sys->ScrL()-20-x)/(sys->ScrL()-20-x+antex-5));
				  memdc->MoveTo(5,y+(antey-y)*(sys->ScrL()-20-x)/(sys->ScrL()-20-x+antex-5));
				  memdc->LineTo(antex,antey);
				 }
			 }// if abs
			 else {
					memdc->MoveTo(antex,antey);
					memdc->LineTo(x,y);

			 } //else
			 } // if dans fenetre
			k++;
			consligne=sys->getconstellation(i)->Star[l]->getligne(k);
		}// while
    }//for l
  }//for i
}// if ligne=true

//******************************
//dessin des etoiles
double magg;
 if (RColor==false){
	if (PPrint==false){
		memdc->SelectObject(crayon[1]);memdc->SelectObject(pinceau[1]); }
	else {memdc->SelectObject(crayon[0]);memdc->SelectObject(pinceau[0]); }
 }
memdc->SetBkMode(TRANSPARENT);
memdc->SetTextColor(RGB(250,150,100));
int SkyR,SkyG,SkyB;
if (PPrint==false){SkyR=0;SkyG=0;SkyB=0;}
else {SkyR=255;SkyG=255;SkyB=255;}
for(i=0;i<sys->getnbrconstellation();i++)
	{
  for(l=0;l<sys->getconstellation(i)->Nombre;l++){
  // choix de la couleur
  if (RColor==true){
		Couleur=CouleurEtoile(sys,i,l);
		memdc->SelectObject(crayon[Couleur]);memdc->SelectObject(pinceau[Couleur]);
  }
	r=sys->getconstellation(i)->Star[l]->getdeclinaison();
	a=sys->getconstellation(i)->Star[l]->getascensiondroite();
	 r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

			 sys->getconstellation(i)->Star[l]->setx(x);
			 sys->getconstellation(i)->Star[l]->sety(y);
			 if (x>5&&x<sys->ScrL()-15&&y>30&&y<sys->ScrH()-15){
	  magg=sys->getconstellation(i)->Star[l]->getmagnitude();
				if(magg<Magnitudes) DrawStar(memdc,x,y,magg,CouleurEtoile(sys,i,l),SkyR,SkyG,SkyB,pinceau,crayon,PPrint,NB,RColor,1.,NAME,sys->getconstellation(i)->Star[l]->getnom());

			  }//if x>...
			x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;

  }//for l
}//for i

//******************************
//dessin des messier
if(messier==true){
for(i=0;i<sys->getnbrngc();i++)
{ if(sys->getngc(i)->getabrev()[0]=='M')
	{

	r=sys->getngc(i)->getdeclinaison();
	a=sys->getngc(i)->getascensiondroite();

		  r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

          sys->getngc(i)->setx(x);
			 sys->getngc(i)->sety(y);
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
				x-=16;y-=16;

				if(sys->getngc(i)->gettype()==1 ) memdc->DrawIcon(x,y,Nebuleuse);
				if(sys->getngc(i)->gettype()==2 ) memdc->DrawIcon(x,y,AmasGlobulaire);
				if(sys->getngc(i)->gettype()==3 ) memdc->DrawIcon(x,y,AmasOuvert);
				if(sys->getngc(i)->gettype()==4 ) memdc->DrawIcon(x,y,Galaxie);
				if(sys->getngc(i)->gettype()==5 ) memdc->DrawIcon(x,y,GalaxieElliptique);
				if(sys->getngc(i)->gettype()==6 ) memdc->DrawIcon(x,y,GalaxieSpirale);
				if(sys->getngc(i)->gettype()==7 ) memdc->DrawIcon(x,y,GalaxieSpiraleBarree);
				if(sys->getngc(i)->gettype()==8 ) memdc->DrawIcon(x,y,Galaxie);
				}// if x>
	  x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
} // if M
}//for i
} //if ngc

//******************************
//dessin des ngc
if(ngcs==true){
for(i=0;i<sys->getnbrngc();i++)
  { if(sys->getngc(i)->getabrev()[0]=='N')
	{

	r=sys->getngc(i)->getdeclinaison();
	a=sys->getngc(i)->getascensiondroite();

		  r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

          sys->getngc(i)->setx(x);
			 sys->getngc(i)->sety(y);
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
				x-=16;y-=16;

				if(sys->getngc(i)->gettype()==1 ) memdc->DrawIcon(x,y,Nebuleuse);
				if(sys->getngc(i)->gettype()==2 ) memdc->DrawIcon(x,y,AmasGlobulaire);
				if(sys->getngc(i)->gettype()==3 ) memdc->DrawIcon(x,y,AmasOuvert);
				if(sys->getngc(i)->gettype()==4 ) memdc->DrawIcon(x,y,Galaxie);
				if(sys->getngc(i)->gettype()==5 ) memdc->DrawIcon(x,y,GalaxieElliptique);
				if(sys->getngc(i)->gettype()==6 ) memdc->DrawIcon(x,y,GalaxieSpirale);
				if(sys->getngc(i)->gettype()==7 ) memdc->DrawIcon(x,y,GalaxieSpiraleBarree);
				if(sys->getngc(i)->gettype()==8 ) memdc->DrawIcon(x,y,Galaxie);
				}// if x>
	  x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;
}//if N
}//for i
} //if ngc


//******************************************************************************
// dessin des cometes
j=0;
while (sys->tabselected[j]!=-1&& j<2999){
	i=sys->tabselected[j++];

	sys->getcomet(i)->calculposition(datum,sys->getsun());
	r=sys->getcomet(i)->getdeclinaison();
	a=sys->getcomet(i)->getascensiondroite();
			 r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

			 sys->getcomet(i)->setx(x);
			 sys->getcomet(i)->sety(y);


			 // sauvegarde

			 // affichage
			 if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15){
					x-=16;y-=16;
					memdc->DrawIcon(x,y,Comet);

			 }// if x>
          x1=sauvex1;
			x2=sauvex2;
			y1=sauvey1;
			y2=sauvey2;

} // while asteroides

//******************************************************************************
xold=0;
yold=0;
//lecture du tableau de planete jusqu'a epuisement
for(i=0;i<sys->getnbrplanete();i++)
	{
   if(i==2) i++;
	// calcule la position initiale
	sys->getplanete(i)->calculposition(datum,sys->getsun());
	r=sys->getplanete(i)->getdeclinaison();
	a=sys->getplanete(i)->getascensiondroite();

			  r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
			 y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
			 x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));

			 // sauvegarde pour information
			 sys->getplanete(i)->setx(-100);
			 sys->getplanete(i)->sety(0);
			 memdc->SelectObject(crayon[i+4]);
			 if (NB==true)memdc->SelectObject(crayon[0]);
				memdc->MoveTo(x,y);
				xold=x;
				yold=y;
				datum2->setsieclejulien(datum->getsieclejulien());
				//restauration apres le bordel
				x1=sauvex1;
				x2=sauvex2;
				y1=sauvey1;
				y2=sauvey2;
		// boucle sur le temps
				for(j=1;j<nbrj;j++)
					{
					datum2->ajoutheure(pas);
					datum2->antimiseajour();
					sys->getplanete(i)->calculposition(datum2,sys->getsun());
					r=sys->getplanete(i)->getdeclinaison();
					a=sys->getplanete(i)->getascensiondroite();


									 r=90.0-r;
			 y1=90-y1;
			 y2=90-y2;
			 if(a<x1) a+=360;
									y=(int)(sys->ScrH()-15 -((r-(float)y1)*(sys->ScrH()-40))/((float)y2-(float)y1));
									x=(int)(sys->ScrL()-20 -((a-(float)x1)*(sys->ScrL()-25))/((float)x2-(float)x1));


									//qd on passed'1 cot a l'autre de la carte il ne s'agit pas de faire un trait a travers tout
									if (x>5&&x<sys->ScrL()-20&&y>30&&y<sys->ScrH()-15 &&floor((double)(x-xold))<50 && floor(double(y-yold))<50 && xold>5 && xold<sys->ScrL()-20 && yold>30 && yold<sys->ScrH()-15)
										 memdc->LineTo(x,y);

									else memdc->MoveTo(x,y);
										xold=x;
										yold=y;

									//restauration apres le bordel
									x1=sauvex1;
									x2=sauvex2;
									y1=sauvey1;
									y2=sauvey2;
												}
 }

 // pour la lune
	sys->getplanete(2)->getsatellite(0)->setx(-100);
	sys->getplanete(2)->getsatellite(0)->sety(0);








fincausediv0 :


Comet.~TIcon();
Lune.~TIcon();
GalaxieSpirale.~TIcon();
GalaxieSpiraleBarree.~TIcon();
GalaxieElliptique.~TIcon();
AmasOuvert.~TIcon();
AmasGlobulaire.~TIcon();
Galaxie.~TIcon();

Nebuleuse.~TIcon();
sol.~TIcon();
Eclipse1.~TIcon();
Eclipse2.~TIcon();
SetCursor(LoadCursor(NULL, (TResId)IDC_ARROW));

}



///**************
// legende pour trainee
void Legendet(date2 *datum,systeme *sys,TMemoryDC *memdc,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB){
//-------------------
//la legende
int b,a=40,aaa=305,c=14;
int iccon;
if (NB==true) iccon=20; else iccon=0;
TIcon Galaxie(_hInstance,(TResId)(galaxie-iccon));
TIcon GalaxieSpirale(_hInstance,(TResId)(galaxies-iccon));
TIcon GalaxieSpiraleBarree(_hInstance,(TResId)(galaxiesb-iccon));
TIcon GalaxieElliptique(_hInstance,(TResId)(galaxiee-iccon));
TIcon AmasOuvert(_hInstance,(TResId)(amaso-iccon));
TIcon AmasGlobulaire(_hInstance,(TResId)(amasg-iccon));
TIcon Nebuleuse(_hInstance,(TResId)(nebuleuse-iccon));

TIcon Merc(_hInstance,(TResId)(merc-iccon));
TIcon Venu(_hInstance,(TResId)(venu-iccon));
TIcon Mar(_hInstance,(TResId)(mar-iccon));
TIcon Jupi(_hInstance,(TResId)(jupi-iccon));
TIcon Satu(_hInstance,(TResId)(satu-iccon));
TIcon sol(_hInstance,(TResId)(solei-iccon));
TIcon Uranus(_hInstance,(TResId)(uranus-iccon));
TIcon Neptune(_hInstance,(TResId)(neptune-iccon));
TIcon Plut(_hInstance,(TResId)(pluton-iccon));
TIcon Lune(_hInstance,(TResId)(lune));
TIcon Comet(_hInstance,(TResId)(commet-iccon));

TIcon Eclipse1(_hInstance,(TResId)(ECLIPSE1));
TIcon Eclipse2(_hInstance,(TResId)(ECLIPSE2));


	if(PPrint==false){
		memdc->SelectObject(pinceau[18]);
		memdc->SelectObject(crayon[18]);
		memdc->SetTextColor(RGB(0,0,100));
		//memdc->SetBkColor(RGB(120,120,200));
		memdc->SetBkMode(TRANSPARENT);
	}
	else{
	  memdc->SelectObject(pinceau[1]);
		memdc->SelectObject(crayon[1]);
		memdc->SetTextColor(RGB(200,0,0));
		memdc->SetBkColor(RGB(255,255,255));
	}

	if(PPrint==false){

	}
	else{
		memdc->MoveTo(sys->ScrL(),0);
		memdc->LineTo(sys->ScrL(),sys->ScrH());
	}
 if(NB==true) memdc->SetTextColor(RGB(0,0,0));
memdc->TextOut(sys->ScrL()+70*(sys->ScrW()-sys->ScrL())/232,2,"LEGENDE",7);

memdc->SetTextColor(RGB(0,0,0));

//memdc->DrawIcon(510,50,Grandeetoile);
if(PPrint==false){
	memdc->SelectObject(crayon[1]);
	memdc->SelectObject(pinceau[1]);
}
else{
	memdc->SelectObject(crayon[0]);
	memdc->SelectObject(pinceau[0]);
}
	memdc->Ellipse(sys->ScrL()+26-3,a-3,sys->ScrL()+26+3,a+3);
	memdc->TextOut(sys->ScrL()+50,a-8,"Etoile M<0",10);

a+=c;
	memdc->Ellipse(sys->ScrL()+26-2,a-2,sys->ScrL()+26+2,a+2);
	memdc->TextOut(sys->ScrL()+50,a-8,"Etoile 0<M<2.5",14);

a+=c;
	memdc->Ellipse(sys->ScrL()+26-1,a-1,sys->ScrL()+26+1,a+1);
	memdc->TextOut(sys->ScrL()+50,a-8,"Etoile 2.5<M<3.5",16);

a+=c;
if(PPrint==false)
	SetPixel(*memdc,sys->ScrL()+26-1,a-1,RGB(255,255,255));
else SetPixel(*memdc,sys->ScrL()+26-1,a-1,RGB(0,0,0));
	memdc->TextOut(sys->ScrL()+50,a-8,"Etoile M>3.5",12);
	/*
a+=c;
	memdc->Ellipse(526-1,a-1,526+1,a+1);
	memdc->MoveTo(527+2,a+3);
	memdc->LineTo(527+3,a+3);
	memdc->TextOut(550,a-8,"Etoile double",13);
	*/

b=a+c;
//planetes
memdc->DrawIcon(sys->ScrL()+10,b,Merc);
memdc->TextOut(sys->ScrL()+50,b+5,"Mercure",7);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Venu);
memdc->TextOut(sys->ScrL()+50,b+5,"Venus",5);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Mar);
memdc->TextOut(sys->ScrL()+50,b+5,"Mars",4);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Jupi);
memdc->TextOut(sys->ScrL()+50,b+5,"Jupiter",7);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Satu);
memdc->TextOut(sys->ScrL()+50,b+5,"Saturne",7);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Uranus);
memdc->TextOut(sys->ScrL()+50,b+5,"Uranus",6);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Neptune);
memdc->TextOut(sys->ScrL()+50,b+5,"Neptune",7);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Plut);
memdc->TextOut(sys->ScrL()+50,b+5,"Pluton",6);

int i,correction=0;
for(i=0;i<sys->getnbrplanete();i++)
	{
		if(i==2) correction=1; // supprime la terre
		else{
			memdc->SelectObject(crayon[i+4]);

			if (NB==true) memdc->SelectObject(crayon[0]);
			memdc->MoveTo(sys->ScrL()+7,(i-correction)*c+111);
			memdc->LineTo(sys->ScrL()+15,(i-correction)*c+111);
		}
	}
//--------------------
// la phase de la lune
aaa=b+c+6+15;
// moments des phases
  //savoir ou en est l'ombre (quelle  phase)
  double phase1,phase2,partie;
  phase1=((datum->getannee()+(datum->getmois()+datum->getjour()/31.0)/12)-1900)*12.3685;
  if (phase1>=0){
		phase2=phase1-floor(phase1);
		if (phase2<0.6&&phase2>0.099) partie=2;
		else partie=1;
  }
  else{
		phase2=phase1-ceil(phase1);
		if (phase2>0.599||phase2<0.1) partie=2;
		else partie=1;
  }
//fraction du disque illuminee
  double frac;
  frac=(sys->getplanete(2)->getsatellite(0)->fractionillumnee(datum,sys->getsun()));

  // dessine la lune dans la legende
  for(i=-8;i<8;i++){
		memdc->SelectObject(crayon[3]);
		if (PPrint==false)memdc->SelectObject(crayon[3]);
		else memdc->SelectObject(crayon[1]);
		memdc->MoveTo(sys->ScrL()+26-8*cos(asin(abs(i)/8.0)),aaa+i);
		memdc->LineTo(sys->ScrL()+26+8*cos(asin(abs(i)/8.0)),aaa+i);
		// partie blanche
				if (PPrint==false)memdc->SelectObject(crayon[1]);
		else memdc->SelectObject(crayon[3]);
		 //	char sstring[2];
	 //	itoa(phase2*10,sstring,10);
	 //	memdc->TextOut(100,100,sstring,1);
		if (partie==1){
		  memdc->MoveTo(sys->ScrL()+26-8*cos(asin(abs(i)/8.0)),aaa+i);
		  memdc->LineTo(sys->ScrL()+26+8*(-1+2.0*frac)*cos(asin(abs(i)/8.0)),aaa+i);
		  }
		else {
		  memdc->MoveTo(sys->ScrL()+26+8*cos(asin(abs(i)/8.0)),aaa+i);
		  memdc->LineTo(sys->ScrL()+26+8*(1-2.0*frac)*cos(asin(abs(i)/8.0)),aaa+i);
		  }

  }
memdc->TextOut(sys->ScrL()+50,aaa-8,"Lune",4);

b=aaa+13;
// objets ngc
memdc->DrawIcon(sys->ScrL()+10,b,Galaxie);
memdc->TextOut(sys->ScrL()+50,b+5,"Galaxie",7);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,GalaxieSpirale);
memdc->TextOut(sys->ScrL()+50,b+5,"Galaxie spirale",15);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,GalaxieSpiraleBarree);
memdc->TextOut(sys->ScrL()+50,b+5,"Galaxie sp. barre",18);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,GalaxieElliptique);
memdc->TextOut(sys->ScrL()+50,b+5,"Galaxie elliptique",18);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,AmasOuvert);
memdc->TextOut(sys->ScrL()+50,b+5,"Amas ouvert",11);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,AmasGlobulaire);
memdc->TextOut(sys->ScrL()+50,b+5,"Amas globulaire",15);
b+=c;
memdc->DrawIcon(sys->ScrL()+10,b,Nebuleuse);
memdc->TextOut(sys->ScrL()+50,b+5,"Nebuleuse",9);
b+=c+2;
memdc->DrawIcon(sys->ScrL()+10,b,Comet);
memdc->TextOut(sys->ScrL()+50,b+5,"Astroides",10);
b+=c+10;
// date
char txt[30];
char txt1[30];
datum->date4(txt1);
sprintf(txt,"Heure GMT : %s",txt1 );
memdc->TextOut(sys->ScrL()+20,b,txt,strlen(txt));
b+=c;
date4l(datum,txt1);
sprintf(txt,"Heure Locale : %s",txt1);
memdc->TextOut(sys->ScrL()+20,b,txt,strlen(txt));
b+=c+10;
// position
memdc->SetBkMode(TRANSPARENT);
sprintf(txt,"Ville : %s",sys->getcityname() );
memdc->TextOut(sys->ScrL()+20,b,txt,strlen(txt));
b+=c;
sprintf(txt,"Longitude : %4.2lf",sys->getlongitude() );
memdc->TextOut(sys->ScrL()+20,b,txt,strlen(txt));
b+=c;
sprintf(txt,"Latitude : %4.2lf",sys->getlatitude() );
memdc->TextOut(sys->ScrL()+20,b,txt,strlen(txt));

Neptune.~TIcon();
Uranus.~TIcon();
Comet.~TIcon();
Lune.~TIcon();
GalaxieSpirale.~TIcon();
GalaxieSpiraleBarree.~TIcon();
GalaxieElliptique.~TIcon();
AmasOuvert.~TIcon();
AmasGlobulaire.~TIcon();
Galaxie.~TIcon();
Merc.~TIcon();
Venu.~TIcon();
Mar.~TIcon();
Jupi.~TIcon();
Satu.~TIcon();
Plut.~TIcon();
Nebuleuse.~TIcon();
sol.~TIcon();
Eclipse1.~TIcon();
Eclipse2.~TIcon();

}

void Informations(int x,int y,systeme *sys,TMemoryDC *memdc,HBRUSH Pinceau[30],HPEN Crayon[30],bool ngcs,bool messier,double Magnitudes){

//initialisation des variables
  int i,l,ni=0,nl=0,t=-10,tb=450;
  char string[20];
  TIcon Choix0(_hInstance,(TResId)choix0);
  TIcon Choix1(_hInstance,(TResId)choix1);
  memdc->SetBkMode(TRANSPARENT);

//regarde  quoi correspondent les coordonnees

//-------
// planete
for(i=sys->getnbrplanete()-1;i>=0;i--){
	if (x>sys->getplanete(i)->getx()-3
		&& x<sys->getplanete(i)->getx()+3
		&& y>sys->getplanete(i)->gety()-3
		&& y<sys->getplanete(i)->gety()+3
		&& t<0){
		ni=i; // numero
		t=1; //type d'objet
		sprintf(string,"Plante:%s",sys->getplanete(i)->getnom());
		memdc->TextOut(sys->ScrL()+65,tb,string,strlen(string));
	}//if
}// for i

//--------
// lune
if (x>sys->getplanete(2)->getsatellite(0)->getx()-3
		&& x<sys->getplanete(2)->getsatellite(0)->getx()+3
		&& y>sys->getplanete(2)->getsatellite(0)->gety()-3
		&& y<sys->getplanete(2)->getsatellite(0)->gety()+3
		&& t<0){
		//ni=i; // numero
		t=0; //type d'objet
			sprintf(string,"Lune");
			memdc->TextOut(sys->ScrL()+80,tb,string,strlen(string));
		}//if


//--------
//etoile
	double magg;
  for(i=sys->getnbrconstellation()-1;i>=0;i--)
	{
	 for(l=0;l<sys->getconstellation(i)->Nombre;l++){
		  magg=sys->getconstellation(i)->Star[l]->getmagnitude();
		  if(magg>90. && magg<190.) magg-=100.;
		  if(magg>190. && magg<290.)magg-=200.;
		if(x>sys->getconstellation(i)->Star[l]->getx()-3
			&& x<sys->getconstellation(i)->Star[l]->getx()+3
			&& y>sys->getconstellation(i)->Star[l]->gety()-3
			&& y<sys->getconstellation(i)->Star[l]->gety()+3
			&& magg<=Magnitudes
			&& t<0){
			ni=i;nl=l;t=2;
			if (sys->getconstellation(i)->Star[l]->getnom()[1]!=0)
				sprintf(string,"Etoile:%s",sys->getconstellation(i)->Star[l]->getnom());
			else
				sprintf(string,"Etoile:%s",sys->getconstellation(i)->Star[l]->getabrev());
			memdc->TextOut(sys->ScrL()+65,tb,string,strlen(string));
			sprintf(string,"Constellation:%s",sys->getconstellation(i)->Nom);
			memdc->TextOut(sys->ScrL()+30,tb+20,string,strlen(string));
		}  //if
	 }  //for l
	}  // for i

	//-----
	//ngc
if ( messier==true){
	for(i=0;i<sys->getnbrngc();i++)
	{
	if(x>sys->getngc(i)->getx()-3
			&& x<sys->getngc(i)->getx()+3
			&& y>sys->getngc(i)->gety()-3
			&& y<sys->getngc(i)->gety()+3
			&& sys->getngc(i)->getabrev()[0]=='M'
			&& t<0){
			ni=i;nl=0;
			t=2+sys->getngc(i)->gettype();
			sprintf(string,"%s",sys->getngc(i)->getabrev());
			memdc->TextOut(sys->ScrL()+70,tb,string,strlen(string));
		  }    //if x
	 }// for i
  }// if messier
if ( ngcs==true){
	for(i=0;i<sys->getnbrngc();i++)
	{
	if(x>sys->getngc(i)->getx()-3
			&& x<sys->getngc(i)->getx()+3
			&& y>sys->getngc(i)->gety()-3
			&& y<sys->getngc(i)->gety()+3
			&& sys->getngc(i)->getabrev()[0]=='N'
			&& t<0){
			ni=i;nl=0;
			t=2+sys->getngc(i)->gettype();
			sprintf(string,"%s",sys->getngc(i)->getabrev());
			memdc->TextOut(sys->ScrL()+70,tb,string,strlen(string));
		  }    //if x
	 }// for i
  }// if ngcs
  // asteroide
  int j=0;
while (sys->tabselected[j]!=-1&& j<2999){
	i=sys->tabselected[j];

	if(x>sys->getcomet(i)->getx()-3
			&& x<sys->getcomet(i)->getx()+3
			&& y>sys->getcomet(i)->gety()-3
			&& y<sys->getcomet(i)->gety()+3
			&& t<0){
			ni=i;nl=0;
         t=11;
			sprintf(string,"Astroide:%s",sys->getcomet(i)->getnom());
			memdc->TextOut(sys->ScrL()+70,tb,string,strlen(string));

       // memdc->DrawIcon(-16+sys->getcomet(sys->tabselected[i])->getx(),-16+sys->getcomet(sys->tabselected[i])->gety(),Choix1);

		  }    //if x
        j++;
	 }// while i
 
//entoure
	 if (t==2)// etoiles
	 {
  //entoure toutes les toiles de la constellation
	 if(strcmp(sys->getconstellation(ni)->Nom,"-")!=0){
			for(i=0;i<sys->getconstellation(ni)->Nombre;i++){
			  if (sys->getconstellation(ni)->Star[i]->getx()>5
					&&  sys->getconstellation(ni)->Star[i]->getx()<sys->ScrL()-20
					&& sys->getconstellation(ni)->Star[i]->gety()>30
					&& sys->getconstellation(ni)->Star[i]->gety()<sys->ScrH()-15
					&& sys->getconstellation(ni)->Star[i]->getmagnitude()<Magnitudes)
							memdc->DrawIcon(-16+sys->getconstellation(ni)->Star[i]->getx(),-16+sys->getconstellation(ni)->Star[i]->gety(),Choix1);
			}    //fir i
			memdc->DrawIcon(sys->getconstellation(ni)->Star[nl]->getx()-16,sys->getconstellation(ni)->Star[nl]->gety()-16,Choix0);
	 }
 } //if t
	 Choix0.~TIcon();
	 Choix1.~TIcon();

}



bool systeme::DansEllipse(int x,int y){
  if (
			(	(Convx(x)-ScrL()/2)/10.
				*(Convx(x)-ScrL()/2)/10.
				+(Convy(y)-(40+ScrR()))/10.
				*(Convy(y)-(40+ScrR()))/10.
			)<(Ell_yr*Ell_yr/100.+Ell_xr*Ell_xr/100.)
		) return TRUE;
  else return false;
}
int systeme::Convx(int x){
  return (int)(  ScrL()/2+( (double)x-(Ell_lef+(Ell_xr)) )*(ScrL()-5)/Ell_xr  );
}
int systeme::Convy(int y){
  return (int)(  40+ScrR()+( (double)y-(Ell_top+(Ell_yr)) )*(ScrR()-5)/Ell_yr  );
  //336 centre de l'ellipse
  //159
}

int CouleurEtoile(systeme *sys,int i,int l){
	 char Spectral;
	 int coull=1;
	 Spectral=sys->getconstellation(i)->Star[l]->getcouleur()[0];
	 if (Spectral=='A') // bleu a blanc
			coull=10;
	 if (Spectral=='G') // blanc a jaune
			coull=14;
	 if (Spectral=='M') // rouge
			coull=5;
	 if (Spectral=='B') // bleu
			coull=4;
	 if (Spectral=='K') // orange a rouge
			coull=7;
	 if (Spectral=='O') // bleu
			coull=10;
	 if (Spectral=='F') // blanc
			coull=1;

return coull;
}

