#ifndef CARTECIEL_H
#define CARTECIEL_H

#include "ciel.rh"
#include "systeme.h"
#include "outil.h"

#include <math.h>
#include <string.h>
#include <owl/dc.h>
#include <stdlib.h>

void carte_du_ciel(date2* datum,systeme *sys,TMemoryDC *memdc,HBRUSH pinceau[30],HPEN crayon[30],bool lignes=true,bool ngcs=true,bool messier=true,bool asteroides=true,double Magnitudes=6.0,bool PPrint=false,bool NB=false,bool RColor=false,bool NAME=FALSE);
void affichage_par_secteur(date2* datum,systeme *sys,TMemoryDC *memdc,int x1,int y1,int x2,int y2,int interrupteur,HBRUSH pinceau[30],HPEN crayon[30],bool lignes=true,bool ngcs=true,bool messier=true,bool asteroides=true,double Magnitudes=6.0,bool PPrint=false,bool NB=false,bool RColor=false,bool NAME=FALSE);
void affichage_par_secteur_trainee(date2* datum,systeme *sys,TMemoryDC *memdc,int x1,int y1,int x2,int y2,HBRUSH pinceau[30],HPEN crayon[30],bool lignes=true,bool ngcs=true,bool messier=true,bool asteroides=true,double Magnitudes=6.0,bool PPrint=false,bool NB=false,bool RColor=false,bool NAME=FALSE);
void carte_du_ciel2(date2* datum,systeme *sys,TMemoryDC *memdc,HBRUSH pinceau[30],HPEN crayon[30],bool lignes=true,bool ngcs=true,bool messier=true,bool asteroides=true,double Magnitudes=6.0,bool PPrint=false,bool NB=false,bool RColor=false,bool NAME=FALSE);

void Legende(date2 *datum,systeme *sys,TMemoryDC *memdc,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint=false,bool NB=false);
//void dessine_etoile(int taille,TMemoryDC memdc, HPEN crayon[30],int x, int y)
void Legendet(date2 *datum,systeme *sys,TMemoryDC *memdc,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint=false,bool NB=false);
void Informations(int x,int y,systeme *sys,TMemoryDC *memdc,HBRUSH pinceau[30],HPEN crayon[30],bool ngcs,bool messier,double Magnitudes);

void azimutal_affichercoordonnee(double azim,double haut,TMemoryDC &memdc,systeme* sys);
void mercator_affichercoordonnee(double asc,double dec,TMemoryDC &memdc,systeme* sys);
//void affichage_remanant(date2 *datum,systeme *sys,TMemoryDC memdc,int x1,int y1,int x2,int y2,int interrupteur,HBRUSH pinceau[30],HPEN crayon[30])
void DrawStar(TMemoryDC *memdc,int x,int y,double magni,int Couleur,int SkyR,int SkyG,int SkyB,HBRUSH pinceau[30],HPEN crayon[30],bool PPrint,bool NB,bool RColor,double coef,bool NAME,char* name);

int CouleurEtoile(systeme *sys,int i,int l); //retourne la vraie couleur en fonction du type spectral

#define xmin 5
#define ymin 5
#define xmax 495
#define ymax 495

//DEFINITION DE LA CLASSE BIPOINT
class bipoint
{
public:
	float x; 
	float y;
};

//MULTIPLICATION DU NB DE POINTS
	//tabx, taby : tableaux des abscisses et des ordonnes.
	//n : nombre d'lments des tableaux tabx et taby;
	//multiple : multiplication du nombre de points
	//bipoint * : tableau de (n-1)*multiple+1 bipoints, contenant l'ensemble des coordonnes
bipoint * multiplication(int * tabx,int * taby,int n,int multiple);
	//fonctions intermdiares
	float L(int i,float t,int n);
	float X(float t,int * tabx,int n);
	float Y(float t,int * taby,int n);
	bipoint interp(float ,int * ,int * ,int );


//POUR SAVOIR SI LES 2 POINTS SONT DANS LE CARRE
bool dans_carre(bipoint P);

//POUR CREER SI BESOIN 2 NOUVEAUX POINTS A L'INTERIEUR DU RECTANGLE
bipoint * nouveaux_pts(bipoint P1,bipoint P2);
	//fonctions intermdiares
	bipoint * intersection(bipoint P1,bipoint P2,bipoint P3,bipoint P4);
	bool entre_pts(bipoint P1,bipoint P2,bipoint P);

#endif
