#include "comet.h"
#include <stdio.h>

void comet::setdate(double peri,double equi){
  tpassperi=peri;
  equiref=equi;
}

void comet::calculposition(date2*d,soleil*sun)

{ //calcul de position pour petites planetes et cometes
//debugggggggggggggggggggggggggggggggggggggggggggggggggg
//FILE* dech=fopen("dechets.txt","w");
//pas d'anomalie moyenne mais un moyen mouvement diurne
struct eo
{double L;
 double a;
 double e;
 double i;
 double o;
 double O;
 double M;

};
eo com;

com.L=L[0];
com.a=a[0];
com.e=e[0];
com.i=I[0];
com.o=o[0];
com.O=O[0];
com.M=M[0];

//debugggggggggggggggggggggggggggggg
/*fprintf(dech,"L=%f\n",com.L);
fprintf(dech,"a=%f\n",com.a);
fprintf(dech,"e=%f\n",com.e);
fprintf(dech,"i=%f\n",com.i);
fprintf(dech,"o=%f\n",com.o);
fprintf(dech,"O=%f\n",com.O);
fprintf(dech,"M=%f\n",com.M);
fprintf(dech,"\n");
*/


double t=d->getsieclejulien(); //la date d'observation!!!!!!

double tref=equiref;//c'est la date de l'equinoxe de reference

double tperi=tpassperi;



//calcul de epsilon

struct eo_soleil

{double L;

 double e;

 double M;

 double epsilon;

};



struct eo_soleil sol;



sol.L=mespr(mise_a_jour(sun->getL(),t));

sol.e=mise_a_jour(sun->gete(),t);

sol.M=mespr(mise_a_jour(sun->getM(),t));

sol.epsilon=mise_a_jour(sun->getepsilon(),tref);//tref et non t, mais on revient a t ds pas longtemps



double F,G,H,P,Q,R,aa,bb,cc,A,B,C,r,x,y,z,X,Y,Z;

//calcul de f g h p q r

F=cos(dr(com.O));

G=sin(dr(com.O))*cos(dr(sol.epsilon));

H=sin(dr(com.O))*sin(dr(sol.epsilon));



P=-1.*sin(dr(com.O))*cos(dr(com.i));

Q=cos(dr(com.O))*cos(dr(com.i))*cos(dr(sol.epsilon))-sin(dr(com.i))*sin(dr(sol.epsilon));

R=cos(dr(com.O))*cos(dr(com.i))*sin(dr(sol.epsilon))+sin(dr(com.i))*cos(dr(sol.epsilon));



//calcul de aa,bb,cc

aa=sqrt((F*F+P*P));

bb=sqrt((G*G+Q*Q));

cc=sqrt((H*H+R*R));



//calcul de A,B,C
/*
if (P>0) A=rd(atan(F/P)); else if (P<0)A=180.+rd(atan(F/P)); //else if (F>=0) A=90.0;else A=-90.0;

if (Q>0) B=rd(atan(G/Q)); else if (Q<0)B=180.+rd(atan(G/Q)); //else if (G>=0) B=90.0;else A=-90.0;

if (R>0) C=rd(atan(H/R)); else if (R<0)C=180.+rd(atan(H/R)); //else if (H>=0) C=90.0;else A=-90.0;
*/
if (P>0) A=rd(atan(F/P)); else A=180.+rd(atan(F/P));

if (Q>0) B=rd(atan(G/Q)); else B=180.+rd(atan(G/Q));

if (R>0) C=rd(atan(H/R)); else C=180.+rd(atan(H/R));


//calcul de l'anomalie moyenne du corps M

com.M=(t-tperi)*(0.985609/(com.a*sqrt(com.a)))*36525.0; //////scounch!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



//tpassperi=t-com.M*a*sqrt(a)*36525./0.9856076686;

//teste avant

//les variables intermdiaires

double E,v;

//calcul de E anomalie excentrique par methode point fixe

///////////////////

int i;

E=dr(com.M);



for (i=0;i<100;i++)

{

E=(dr(com.M)+com.e*sin(E));

}

E=rd(E);



//calcul anomalie vraie
v=rd(2*atan(  sqrt(( (1+com.e)/(1-com.e) ))  * tan(dr(E)/2)  ));



//calcul r

r=com.a*(1-com.e*cos( dr(E) ) );/////////////////////



//calcul de x y z

x=r*aa*sin(dr(A+com.o+v));

y=r*bb*sin(dr(B+com.o+v));

z=r*cc*sin(dr(C+com.o+v));

//teste avant

//calcul de X Y Z

//Calcul des coordonnes du soleil*****************************************

//cette fois calculs grace au tmps

//calcul de Es par la methode du point fixe

sol.epsilon=mise_a_jour(sun->getepsilon(),t);//car epsilon pas a jour

double Es,vs,Os,Rs;

Es=dr(sol.M);

for (i=0;i<20;i++)

{

Es=(dr(sol.M)+sol.e*sin(Es));

}

Es=mespr(rd(Es));



//calcul de vs

vs=rd(2*atan(  sqrt(((1+sol.e)/(1-sol.e)))  * tan(dr(Es)/2)  ));



//calcul de la longitude vraie Os

Os=mespr(sol.L+vs-sol.M);



//Calcul du rayon Rs

Rs=1.0000002*(1-sol.e*cos(dr(Es)));



X=Rs*cos(dr(Os));

Y=Rs*sin(dr(Os))*cos(dr(sol.epsilon));

Z=Rs*sin(dr(Os))*sin(dr(sol.epsilon));









//calcul des coordonnes geocentriques

if ((X+x)>0) ascensiondroite=rd( atan( (Y+y)/(X+x) ) );
else{
	if (X+x==0) ascensiondroite=rd( M_PI_2 );
	else ascensiondroite=180+rd( atan( (Y+y)/(X+x) ) );
}
distancealamere=sqrt( absd((X+x)*(X+x) + (Y+y)*(Y+y) + (Z+z)*(Z+z)) );

declinaison=rd(asin((Z+z)/distancealamere));



//calcul des coordonnes heliocentriqes

distanceausoleil=sqrt((x*x + y*y + z*z) );

latitude=0; //inutile de la calculer

if (x>0) longitude=rd( atan( y/x ) );
else{
	if (x!=0) longitude=rd( M_PI+atan( y/x ) );
	else longitude=M_PI_2;
	}



 //debugggggggggggggggggggggggggggggggggggggggggggggggggg
/*fprintf(dech,"F=%f\n",F);
fprintf(dech,"G=%f\n",G);
fprintf(dech,"H=%f\n",H);
fprintf(dech,"P=%f\n",P);
fprintf(dech,"Q=%f\n",Q);
fprintf(dech,"R=%f\n",R);
fprintf(dech,"A=%f\n",A);
fprintf(dech,"B=%f\n",B);
fprintf(dech,"C=%f\n",C);
fprintf(dech,"a=%f\n",aa);
fprintf(dech,"b=%f\n",bb);
fprintf(dech,"c=%f\n",cc);
fprintf(dech,"\n");

fprintf(dech,"tSJ=%f\n",t);
fprintf(dech,"tjJ=%f\n",t*36525.0+2415020.0);
fprintf(dech,"tperiSJ=%f\n",tperi);
fprintf(dech,"tperiJJ=%f\n",tperi*36525.0+2415020.0);

fprintf(dech,"tps depuis perihelie=%f\n",(t-tperi)*36525.0);
fprintf(dech,"n=%f\n",(0.985609/(com.a*sqrt(com.a))));
fprintf(dech,"M=%f\n",com.M);
fprintf(dech,"\n");
fprintf(dech,"E=%f\n",E);
fprintf(dech,"r=%f\n",r);
fprintf(dech,"v=%f\n",v);
fprintf(dech,"\n");
fprintf(dech,"x=%f\n",x);
fprintf(dech,"y=%f\n",y);
fprintf(dech,"z=%f\n",z);
fprintf(dech,"X=%f\n",X);
fprintf(dech,"Y=%f\n",Y);
fprintf(dech,"Z=%f\n",Z);
fprintf(dech,"E=%f\n",E);
fclose(dech);


*/









}

