
#include <stdio.h>
#include <string.h>

#include "comment.h"
double hauteur(double r,double a, date2 * dat, systeme *sys)   //r=dec   a= ascen droite
{
date2 *datum=new date2(*dat);
datum->antimiseajour();
sys->calculposition(datum);
//pour le calcul des postions azimutales
double longitude=sys->getlongitude();       //11.5
double latitude=sys->getlatitude();       //45.5
date2* datetronquee=new date2();
double H,teta,tsj;//teta temps sideral local a greenwich a0 hUT, tsj le temps en siecle juliens local

  //au dessus

// calcul de teta temps sideral
datetronquee->setjour(datum->getjour());
datetronquee->setmois(datum->getmois());
datetronquee->setannee(datum->getannee());
datetronquee->miseajour();
tsj=datetronquee->getsieclejulien();
teta=6.6460656+2400.051262*tsj+0.00002581*tsj*tsj;
teta=teta/24.0;
teta=teta-floor(teta);
teta=teta*24.0;//temps sideral a greenwich a 0h
teta=teta+(  (double) datum->getheure()+ ( (double)datum->getminute()/60.0 )*1.002737908);

teta=15.0*teta;//nous voila en degre

  H=teta-(longitude+a);
  return rd(  asin ( sin(dr(r))*sin(dr(latitude))+cos(dr(r))*cos(dr(latitude))*cos(dr(H)) ));

}

//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------

void commentaire (date2 *datum,systeme *sys,char* filename)
{
  double has, ha;

 //la ou sont stockes les commentaires finis
 FILE * fptr=fopen(filename,"wt");
datum->antimiseajour();
sys->calculposition(datum);

 //creation structures de donnees
  eveplanet tabeveplanet[8];
  eveplanet sol;

 //gestion GMT
date2 datuma(*datum);//datuma est la date locale donc a afficher
datuma.ajouterheuredecimale(datuma.sbgmt);
datuma.antimiseajour();
fprintf(fptr,"Les heures affiches sont les heures locales de %s.\n Le dcalage par rapport  GMT est de %2.2f.\n",sys->cityname,datum->slgmt);

 //la date
 fprintf(fptr,"Date : %d %d %d \n Jour julien %f\n",datum->getjour(),datum->getmois(),datum->getannee(),(((float)datum->getsieclejulien())*36525.0+2415020.0));

 //evenements uniques
     //eclipses
     //de soleil
     if(  fabs(mespr(mespr(sys->getsun()->getascensiondroite())-mespr(sys->getplanete(2)->getsatellite(0)->getascensiondroite())))<0.5 && fabs(mespr(mespr(sys->getsun()->getdeclinaison())-mespr(sys->getplanete(2)->getsatellite(0)->getdeclinaison())))<0.5)
     fprintf(fptr,"******ECLIPSE DE SOLEIL******\n");

     //de lune
     if(fabs(mespr(sys->getsun()->getascensiondroite()-sys->getplanete(2)->getsatellite(0)->getascensiondroite())-180)<0.5 && fabs(mespr(sys->getsun()->getdeclinaison()-sys->getplanete(2)->getsatellite(0)->getdeclinaison())-180)<0.5)
     fprintf(fptr,"******ECLIPSE DE LUNE******\n");

	  //transits de venus


 //evenements annuels
	  //meteorites
	  if ( (datum->getmois()==1) && (datum->getjour()==2) || (datum->getjour()==3 )  )
		fprintf(fptr,"L'essaim d'toiles filantes des Bootides est visible au alentours de la constellation du Bouvier. Vitesse moyennes.\n");

	  if ( (datum->getmois()==4) && (datum->getjour()>=16) && (datum->getjour()<=22 )  )
		fprintf(fptr,"L'essaim d'toiles filantes des Lyrides est visible au alentours de la constellation de la Lyre. Le radian se situe prs de Vega. Vitesse leves et traines persistantes.\n");

	  if ( (datum->getmois()==5) && (datum->getjour()==1) || (datum->getjour()==16 )  )
		fprintf(fptr,"L'essaim d'toiles filantes des alpha Aquarides est visible au alentours de la constellation du Verseau. Le radian se situe prs de alpha du Verseau. Trs rapides,long parcours.\n");

	  if ( (datum->getmois()==7) && (datum->getjour()>=25) && (datum->getjour()<=30 )  )
		fprintf(fptr,"L'essaim d'toiles filantes des delta Aquarides est visible au alentours de la constellation du Verseau . Le radian se situe prs de delta du Verseau.Lentes,long parcours.\n");


	  if ( (datum->getmois()==8) && (datum->getjour()>=10) && (datum->getjour()<=12 )  )
		fprintf(fptr,"L'essaim d'toiles filantes des Perseides (faut-il le prsenter) est visible ddans la constellation de Perse, son radian tant prs de l'toile variable Algol. Rapides, traines jaunes. Sans doute l'une des plus belles pluies d'toiles de l'anne. A observer de prfrence le matin.\n");

	  if ( (datum->getmois()==10) && (datum->getjour()>=8) && (datum->getjour()<=10 )  )
		fprintf(fptr,"L'essaim d'toiles filantes des Draconides est visible au alentours de la constellation du Dragon. Vitesse moyennes.\n");

	  if ( (datum->getmois()==11) && (datum->getjour()>=9) && (datum->getjour()<=17 )  )
		fprintf(fptr,"L'essaim d'toiles filantes des Andromdides est visible au alentours de la constellation d'Andromde. Vitesse trs lente.\n");

	  if ( (datum->getmois()==12) && (datum->getjour()>=1) && (datum->getjour()<=12 )  )
		fprintf(fptr,"L'essaim d'toiles filantes des Gminides est visible au alentours de la constellation des Gmeaux. Vitesse moyennes, blanches, relativement nombreuses.\n");


	  //equinoxe et solstices
	  if ( (datum->getmois()==6) && (datum->getjour()==21)  )
		fprintf(fptr,"Solstice d't");

	  if ( (datum->getmois()==12) && (datum->getjour()==21)  )
		fprintf(fptr,"Solstice d'hiver");

	  if ( (datum->getmois()==3) && (datum->getjour()==23)  )
		fprintf(fptr,"Equinoxe de printemps");

	  if ( (datum->getmois()==9) && (datum->getjour()==23)  )
		fprintf(fptr,"Equinoxe d'automne");
  //au dessus
int i;


//*************************************************************************************
//********  planetes ******************************************************************
//*************************************************************************************


//trouver le soir suivant le + proche
//calcule has soleil
 has= hauteur(sys->getsun()->getdeclinaison(),sys->getsun()->getascensiondroite(),datum,sys);

i=0;
while (((has<0)) && (i<248)) //si il fait jour remonte au matin
{
  has= hauteur(sys->getsun()->getdeclinaison(),sys->getsun()->getascensiondroite(),datum,sys);
  datum->ajoutminute(-10);
  datum->antimiseajour();
  datuma.ajoutminute(-10);
  datuma.antimiseajour();
  i++;
}


//maintenant on est ds un jour on cherche le coucher
i=0;
while ((has>0) && (i<248)) //i sert au dessus des cercles polaires ou il fait pas nuit!
 {
	datum->ajoutminute(5);
   datum->antimiseajour();
   datuma.ajoutminute(5);
   datuma.antimiseajour();

	//hauteur du soleil
  has= hauteur(sys->getsun()->getdeclinaison(),sys->getsun()->getascensiondroite(),datum,sys);
  i++;
  if (has<0)
	 {
		sol.coucherh=datuma.getheure();
		sol.couchermn=datuma.getminute();
	 }//ifha

 }//whileha





if (i==248) {fprintf(fptr,"Cercle polaire!\n Bridage activ.\n"); goto fin;}

else //un soir a ete detecte
{
//charger les mag
for(i=0;i<8;i++)
  {
	if (i==2) i++; // saute la Terre
	tabeveplanet[i].mag=sys->getplanete(i)->getmag();
  }

//charger les % visibles
for(i=0;i<8;i++)
  {
	if (i==2) i++; // saute la Terre
	tabeveplanet[i].pourcen_visible=100.0*sys->getplanete(i)->getsurface();
  }





//faire un tour initial pour etat des lieux **************************************************
// plantes deja en l'air hlever=100
//en train de se lever -20
//pas leves -10
for(i=0;i<8;i++)
		{
  if (i==2) i++; // saute la Terre

//angle soleil terre planet
tabeveplanet[i].anglestp=sys->getsun()->getascensiondroite()-sys->getplanete(i)->getascensiondroite();



//quelles st les planets deja leves??
ha= hauteur(sys->getplanete(i)->getdeclinaison(),sys->getplanete(i)->getascensiondroite(),datum,sys);

if (ha>1.3) tabeveplanet[i].leverh=100;//deja levee

if (ha<0) tabeveplanet[i].leverh=-10;//pas levee

if (ha>=0 && ha<=1.3) tabeveplanet[i].leverh=-20;// en train de lever ou coucher!

tabeveplanet[i].coucherh=-100;
tabeveplanet[i].levermn=-100;
tabeveplanet[i].ha=ha;

}  // for planete



//*********************************la pure boucle********************************************
//*************************************************************************************************
while(has<0)//tant qu'il fait nuit
{
datum->ajoutminute(5);
datum->antimiseajour();
datuma.ajoutminute(5);
datuma.antimiseajour();

for(i=0;i<8;i++)
		{
  if (i==2) i++; // saute la Terre
//hauteur de la planete
ha= hauteur(sys->getplanete(i)->getdeclinaison(),sys->getplanete(i)->getascensiondroite(),datum,sys);


if(tabeveplanet[i].leverh==-20)//on ne savait pas trop si coucher ou lever
		{
	if (ha>tabeveplanet[i].ha) //c'etait un lever
	{
	tabeveplanet[i].leverh=datuma.getheure();
	tabeveplanet[i].levermn=datuma.getminute();
   tabeveplanet[i].ha=ha;
	}

	if (ha<tabeveplanet[i].ha)//c'etait un coucher
	 {
	tabeveplanet[i].coucherh=datuma.getheure();
	tabeveplanet[i].couchermn=datuma.getminute();
   tabeveplanet[i].leverh=100;
   tabeveplanet[i].ha=ha;
	}
      }


//passe a l'horizon
if (ha>0 && ha<1.3)//lever ou coucher!
  {

   if(tabeveplanet[i].leverh>=0)//coucher
		{
      //si la hauteur a augment alors fausse alerte:
      //elle est rasante ds la bande de detection
      if (tabeveplanet[i].ha<ha) {}
      else
      {
	tabeveplanet[i].coucherh=datuma.getheure();
	tabeveplanet[i].couchermn=datuma.getminute();
   tabeveplanet[i].ha=ha;
      }
   		}

	 if(tabeveplanet[i].leverh==-10)//lever
      {
      //si la hauteur a diminu alors fausse alerte:
      //elle est rasante ds la bande de detection
      if (tabeveplanet[i].ha>ha) {}
      else
      {
	tabeveplanet[i].leverh=datuma.getheure();
	tabeveplanet[i].levermn=datuma.getminute();
   tabeveplanet[i].ha=ha;
      }
     }

   tabeveplanet[i].ha=ha;
  }//if ha>0



if(tabeveplanet[i].haut<ha) tabeveplanet[i].haut =ha;//mise a jour hauteur eventuelle



}  // for planete



//recalculer has
  has= hauteur(sys->getsun()->getdeclinaison(),sys->getsun()->getascensiondroite(),datum,sys);
  if (has>180) has=has-360;


}//while has
sol.leverh=datuma.getheure();
sol.levermn=datuma.getminute();

}//else il faisait jour




for (i=0;i<8;i++)//nom des planetes
{
if(i==0) strcpy(tabeveplanet[i].nom,"Mercure");
if(i==1) strcpy(tabeveplanet[i].nom,"Venus");
if(i==3) strcpy(tabeveplanet[i].nom,"Mars");
if(i==4) strcpy(tabeveplanet[i].nom,"Jupiter");
if(i==5) strcpy(tabeveplanet[i].nom,"Saturne");
if(i==6) strcpy(tabeveplanet[i].nom,"Uranus");
if(i==7) strcpy(tabeveplanet[i].nom,"Neptune");

}//fori










//**************************************************************************************
//********exploitons nos donnees sur les planetes pr generer du pipo********************
//**************************************************************************************

//soleil
fprintf(fptr,"\nLe soleil se lve  %dh%d, il se couche  %dh%d.\n",sol.leverh,sol.levermn,sol.coucherh,sol.couchermn);

//planetes
for(i=0;i<8;i++)
{
if(i==2) i++;//saute la terre
fprintf(fptr,"\n");
if (i<2) //planet interieure
  {
	 if ((tabeveplanet[i].leverh>-1) && (tabeveplanet[i].leverh<25) )   fprintf(fptr," %s est visible le matin. Elle se lve  %dh%d. Elle est de magnitude %1.2f, et la partie visible est de %1.2f%.\n",tabeveplanet[i].nom,tabeveplanet[i].leverh,tabeveplanet[i].levermn,tabeveplanet[i].mag,tabeveplanet[i].pourcen_visible);

	 if ((tabeveplanet[i].coucherh>-1) && (tabeveplanet[i].coucherh<25) )   fprintf(fptr," %s est visible le soir. Elle se couche  %dh%d. Elle est de magnitude %1.2f, et la partie visible est de %1.2f%.\n",tabeveplanet[i].nom,tabeveplanet[i].coucherh,tabeveplanet[i].couchermn,tabeveplanet[i].mag,tabeveplanet[i].pourcen_visible);

//conjonction inf ou sup
if (fabs(tabeveplanet[i].anglestp)<2.0)
  {
    //inf ou sup
    if (sys->getplanete(i)->distancealamere<sys->getplanete(2)->distanceausoleil)
     fprintf(fptr," %s est en conjonction infrieure (=au plus proche de la terre).\n",tabeveplanet[i].nom);

    if (sys->getplanete(i)->distancealamere>sys->getplanete(2)->distanceausoleil)
     fprintf(fptr," %s est en conjonction suprieure (=au plus loin de la terre).\n",tabeveplanet[i].nom);
  }//ifabs


if (fabs(tabeveplanet[i].anglestp)<6.0 && fabs(tabeveplanet[i].anglestp)>2.0 )
  {
    //inf ou sup
    if (sys->getplanete(i)->distancealamere<sys->getplanete(2)->distanceausoleil)
     fprintf(fptr," %s est proche de sa conjonction infrieure (=au plus proche de la terre).\n",tabeveplanet[i].nom);

    if (sys->getplanete(i)->distancealamere>sys->getplanete(2)->distanceausoleil)
     fprintf(fptr," %s est proche de sa conjonction suprieure (=au plus loin de la terre).\n",tabeveplanet[i].nom);
  }//ifabs
}//ifinnerplanet




if (i==0)//specifique Mercure
  {
	 if (tabeveplanet[i].haut>0 && tabeveplanet[i].haut<8 ) fprintf(fptr," %s culmine  %3.2f de hauteur dans le ciel les conditions d'observation sont donc moyennes.\n",tabeveplanet[i].nom,tabeveplanet[i].haut);

if (tabeveplanet[i].haut>8 && tabeveplanet[i].haut<10 ) fprintf(fptr," %s culmine  %3.2f de hauteur dans le ciel les conditions d'observation sont donc bonnes.\n",tabeveplanet[i].nom,tabeveplanet[i].haut);

	 if (tabeveplanet[i].haut>10 && tabeveplanet[i].haut<20 ) fprintf(fptr," %s culmine  %3.2f de hauteur dans le ciel les conditions d'observation sont donc optimum, ne la rattez pas.\n",tabeveplanet[i].nom,tabeveplanet[i].haut);

    if (fabs(tabeveplanet[i].haut-15.0)<5.0)//elongation
	 fprintf(fptr," %s est proche de sa plus grande longation.\n",tabeveplanet[i].nom);
    
  }//mercure





if (i==1)//specifique Venus
  {
	 if (tabeveplanet[i].haut>0 && tabeveplanet[i].haut<10 ) fprintf(fptr," %s culmine  %3.2f de hauteur dans le ciel les conditions d'observation sont donc moyennes.\n",tabeveplanet[i].nom,tabeveplanet[i].haut);

	 if (tabeveplanet[i].haut>10 && tabeveplanet[i].haut<20 ) fprintf(fptr," %s culmine  %3.2f de hauteur dans le ciel les conditions d'observation sont donc bonnes.\n",tabeveplanet[i].nom,tabeveplanet[i].haut);

	 if (tabeveplanet[i].haut>20 && tabeveplanet[i].haut<90 ) fprintf(fptr," %s culmine  %3.2f de hauteur dans le ciel les conditions d'observation sont donc optimum.\n",tabeveplanet[i].nom,tabeveplanet[i].haut);


    if (fabs(tabeveplanet[i].haut-20.0)<5.0)//elongation
	 fprintf(fptr," %s est proche de sa plus grande longation.\n",tabeveplanet[i].nom);
  }//venus


if (i>2) //planet exterieure
  {
//se leve seulement
if ((tabeveplanet[i].leverh>-1) && (tabeveplanet[i].leverh<25) && (tabeveplanet[i].coucherh==-100) )   fprintf(fptr," %s se lve  %dh%d, puis est visible jusqu'au jour. Elle est de magnitude %1.2f, et la partie visible est de %1.2f%.\n",tabeveplanet[i].nom,tabeveplanet[i].leverh,tabeveplanet[i].levermn,tabeveplanet[i].mag,tabeveplanet[i].pourcen_visible);

//se couche seulement
if ((tabeveplanet[i].coucherh>-1) && (tabeveplanet[i].coucherh<25) && ((tabeveplanet[i].leverh<0) || (tabeveplanet[i].leverh>25) ) )   fprintf(fptr," %s est visible du coucher du soleil jusqu' son coucher  %dh%d. Elle est de magnitude %1.2f, et la partie visible est de %1.2f%.\n",tabeveplanet[i].nom,tabeveplanet[i].coucherh,tabeveplanet[i].couchermn,tabeveplanet[i].mag,tabeveplanet[i].pourcen_visible);

//leve et couche
if ((tabeveplanet[i].leverh>-1) && (tabeveplanet[i].leverh<25)&& (tabeveplanet[i].coucherh!=-100) )   fprintf(fptr,"%s se lve  %dh%d,et se couche  %dh%d. Elle est de magnitude %1.2f, et la partie visible est de %1.2f%.\n ",tabeveplanet[i].nom,tabeveplanet[i].leverh,tabeveplanet[i].levermn,tabeveplanet[i].coucherh,tabeveplanet[i].couchermn,tabeveplanet[i].mag,tabeveplanet[i].pourcen_visible);

//ne se leve ni ne se couche
if ((tabeveplanet[i].coucherh>-1) && (tabeveplanet[i].coucherh<25)&& (tabeveplanet[i].leverh<-1) && (tabeveplanet[i].leverh>25) )   fprintf(fptr,"%s n'est pas visible cette nuit.\n ",tabeveplanet[i].nom,tabeveplanet[i].leverh,tabeveplanet[i].levermn,tabeveplanet[i].mag,tabeveplanet[i].pourcen_visible);
  }


//conjonction
if (fabs(mespr(tabeveplanet[i].anglestp))<6.0 && fabs(mespr(tabeveplanet[i].anglestp))>3.0 )
  {
	 fprintf(fptr," %s est quasiment en conjonction.\n",tabeveplanet[i].nom);
  }//ifabs

if (fabs(mespr(tabeveplanet[i].anglestp))<=3.0 )
  {
    fprintf(fptr," %s est exactement en conjonction.\n",tabeveplanet[i].nom);
  }//ifabs

if (fabs(mespr(tabeveplanet[i].anglestp)-360)<6.0 && fabs(mespr(tabeveplanet[i].anglestp)-360)>3.0 )
  {
	 fprintf(fptr," %s est quasiment en conjonction.\n",tabeveplanet[i].nom);
  }//ifabs

if (fabs(mespr(tabeveplanet[i].anglestp)-360)<=3.0 )
  {
    fprintf(fptr," %s est exactement en conjonction.\n",tabeveplanet[i].nom);
  }//ifabs



//opposition
if (fabs(mespr(tabeveplanet[i].anglestp)-180.0)<6.0 && fabs(mespr(tabeveplanet[i].anglestp)-180)>3.0 )
  {
    fprintf(fptr," %s est quasiment en opposition ( l'oppos du soleil).\n",tabeveplanet[i].nom);
  }//ifabs

if (fabs(mespr(tabeveplanet[i].anglestp)-180.0)<=3.0 )
  {
    fprintf(fptr," %s est exactement en opposition ( l'oppos du soleil).\n",tabeveplanet[i].nom);
  }//ifabs

if (fabs(mespr(tabeveplanet[i].anglestp)-540.0)<6.0 && fabs(mespr(tabeveplanet[i].anglestp)-180)>3.0 )
  {
    fprintf(fptr," %s est quasiment en opposition ( l'oppos du soleil).\n",tabeveplanet[i].nom);
  }//ifabs

if (fabs(mespr(tabeveplanet[i].anglestp)-540.0)<=3.0 )
  {
    fprintf(fptr," %s est exactement en opposition ( l'oppos du soleil).\n",tabeveplanet[i].nom);
  }//ifabs

}//for planet

//quadrature
if (fabs(mespr(tabeveplanet[i].anglestp)-90.0)<6.0 && fabs(mespr(tabeveplanet[i].anglestp)-90)>3.0 )
  {
	 fprintf(fptr," %s est quasiment en quadrature.\n",tabeveplanet[i].nom);
  }//ifabs

if (fabs(mespr(tabeveplanet[i].anglestp)-90.0)<=3.0 )
  {
    fprintf(fptr," %s est exactement en quadrature.\n",tabeveplanet[i].nom);
  }//ifabs

  //quadrature
if (fabs(mespr(tabeveplanet[i].anglestp)-270.0)<6.0 && fabs(mespr(tabeveplanet[i].anglestp)-270)>3.0 )
  {
	 fprintf(fptr," %s est quasiment en quadrature.\n",tabeveplanet[i].nom);
  }//ifabs

if (fabs(mespr(tabeveplanet[i].anglestp)-270.0)<=3.0 )
  {
    fprintf(fptr," %s est exactement en quadrature.\n",tabeveplanet[i].nom);
  }//ifabs

//}//for planet

if (tabeveplanet[i].haut>5.0)
 fprintf(fptr," %s culminera  %3.2f dans le ciel.",tabeveplanet[i].nom,tabeveplanet[i].haut);

if (tabeveplanet[i].haut>30.0)
 fprintf(fptr," Elle sera donc bien visible.\n");

if (tabeveplanet[i].haut<30.0 && tabeveplanet[i].haut>15.0)
 fprintf(fptr," Elle sera donc un peu bas.\n");

if (tabeveplanet[i].haut<15.0 && tabeveplanet[i].haut>5.0)
 fprintf(fptr," Elle sera donc trs bas.\n");

  fin:						
 fclose(fptr);
}


