//--------------------------------------------------------------------------
// Le plantarium -- Copyright (c) 1998
//--------------------------------------------------------------------------
#ifndef DIALOGS1_H
#define DIALOGS1_H

#include <owl/dialog.h>
#include <owl/static.h>
#include <owl/button.h>
#include <owl/listbox.h>
#include <owl/combobox.h>

#include "constant.h"
#include "date.h"

#include "planetar.rh"


// pour les combobox
struct dialogs1Xfer {
//{{mainXFER_DATA}}
	 TComboBoxData  box_annee;
	 TComboBoxData  box_mois;
	 TComboBoxData  box_jour;
	 TComboBoxData  box_heure;

	 TComboBoxData  box_annee2;
	 TComboBoxData  box_mois2;
	 TComboBoxData  box_jour2;
	 TComboBoxData  box_heure2;
//{{mainXFER_DATA_END}}
};

class TDialogConjonctions: public TDialog {
private:

	TComboBox * box_annee;
	TComboBox * box_mois;
	TComboBox * box_jour;
	TComboBox * box_heure;
	TComboBox * box_annee2;
	TComboBox * box_mois2;
	TComboBox * box_jour2;
	TComboBox * box_heure2;
	date2 *d;
	date2 *d2;
   int annee,mois,jour,heure; // sauvegarde pour le cas ou cancel

public:
  TDialogConjonctions( TWindow* parent,date2*datum1,date2*datum2 );
  ~TDialogConjonctions();
  void SetupWindow() ;
  void EvPaint() ;

//  int  Execute() ;
  void Ignore();
  void Fin();
  void Fin2();

  void ModifAnnee();
  void ModifMois();
  void ModifJour();

  void ModifAnnee2();
  void ModifMois2();
  void ModifJour2();

  // pour les fonctions declenches par les boutons
  DECLARE_RESPONSE_TABLE( TDialogConjonctions );
};



#endif // DIALOGS1_H
