 //--------------------------------------------------------------------------
// Le plantarium -- Copyright (c) 1998
//--------------------------------------------------------------------------
#ifndef DIALOGS3_H
#define DIALOGS3_H

#include <owl/dialog.h>
#include <owl/static.h>
#include <owl/button.h>
#include <owl/listbox.h>
#include <owl/combobox.h>

#include "systeme.h"
#include "constant.h"
#include "date.h"

#include "planetar.rh"


// pour les combobox
struct dialogs3Xfer {
//{{mainXFER_DATA}}
	 TComboBoxData  box_annee;
	 TComboBoxData  box_mois;
	 TComboBoxData  box_jour;
	 TComboBoxData  box_heure;

	 TComboBoxData  box_annee2;
	 TComboBoxData  box_mois2;
	 TComboBoxData  box_jour2;
	 TComboBoxData  box_heure2;

	 TComboBoxData  box_objet;
//{{mainXFER_DATA_END}}
};

class TDialogDanse: public TDialog {
private:

	TComboBox * box_annee;
	TComboBox * box_mois;
	TComboBox * box_jour;
	TComboBox * box_heure;
	TComboBox * box_annee2;
	TComboBox * box_mois2;
	TComboBox * box_jour2;
	TComboBox * box_heure2;
   TComboBox * box_objet;
	date2 *d;
	date2 *d2;
   systeme * system;
   int *obj;
   int annee,mois,jour,heure; // sauvegarde pour le cas ou cancel
	int result;  //=0 si cancel, 1 sinon

public:
  TDialogDanse( TWindow* parent,date2*datum1,date2*datum2,systeme*sys,int *objet );
  ~TDialogDanse();
  void SetupWindow() ;
  void EvPaint() ;

  int  Execute() ;
  void Ignore();
  void Fin();
  void Fin2();

  void ModifAnnee();
  void ModifMois();
  void ModifJour();

  void ModifAnnee2();
  void ModifMois2();
  void ModifJour2();

  // pour les fonctions declenches par les boutons
  DECLARE_RESPONSE_TABLE( TDialogDanse );
};



#endif // DIALOGS3_H