#include "systeme.h"
#include "ciel.rh"
#include "date.h"
#include "danse.h"
#include "outil.h"

#include <owl/dc.h>
#include <string.h>


void danse(date2*d,date2*datum,systeme *sys,TMemoryDC &memdc,HBRUSH pinceau[16],HPEN crayon[16],int objet,bool PPrint,bool NB){
//mes variables
SetCursor(LoadCursor(NULL, (TResId)IDC_WAIT));
int k=objet;
if (k!=2){  // != Terre

double x,y;
double antex;
int t;
double zoomx,zoomy;
int angle,pointille=0,lpointille=0;     // angle= Terre,soleil,planete
//zoom en fonction de la planete
if (k==0){zoomx=10;zoomy=12;}
if (k==1){zoomx=5;zoomy=12;}
if (k>2){zoomx=1;zoomy=4.5;}

//definition d'un carre sur lequel est affiche les planetes
if (PPrint==false){
memdc.SelectObject(crayon[0]); //noir
memdc.SelectObject(pinceau[0]);                    //noir
memdc.SetTextColor(RGB(200,200,200));
memdc.SetBkColor(RGB(0,0,70));
memdc.SetBkMode(TRANSPARENT);
}
else {
memdc.SelectObject(crayon[1]);                    //blanc
memdc.SelectObject(pinceau[1]);                    //blanc
memdc.SetTextColor(RGB(0,0,0));
memdc.SetBkColor(RGB(255,255,255));
memdc.SetBkMode(TRANSPARENT);
}

//memdc.Rectangle(500,0,732,500);
if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
else memdc.SelectObject(crayon[0]);
memdc.Rectangle(5,30,sys->ScrW()-5,sys->ScrH()-5);
char titre[30]="La danse de ";
strcat(titre,sys->getplanete(k)->getnom());
memdc.TextOut((sys->ScrW()-strlen(titre)*5)/2,35,titre,strlen(titre));
memdc.MoveTo(sys->ScrW()/2-5,sys->ScrH()/2);
memdc.LineTo(sys->ScrW()/2+5,sys->ScrH()/2);
memdc.MoveTo(sys->ScrW()/2,sys->ScrH()/2-5);
memdc.LineTo(sys->ScrW()/2,sys->ScrH()/2+5);

// variables concernant les dates
double pas=17.63265*(k+1); //pas de calcul en heure
date2*datum2;
datum2=new date2();
 datum2->setannee(1996);
 datum2->setmois(1);
 datum2->setjour(1);
 datum2->miseajour();
// date de debut
datum2->setsieclejulien(d->getsieclejulien());
// calcul du pas en heure
pas=(datum->getsieclejulien()-d->getsieclejulien())*1788.9796;

// calcul de la position de la planete a la date datum2
sys->getsun()->calculposition(datum2);
  sys->getplanete(k)->calculposition(datum2,sys->getsun());
y=sys->getsun()->getdeclinaison()-sys->getplanete(k)->getdeclinaison();
x=sys->getsun()->getascensiondroite()-sys->getplanete(k)->getascensiondroite();
  while(y<-180) y+=360;
  while(y>180) y-=360;
  while(x<-180) x+=360;
  while(x>180) x-=360;
  antex=x;
  //icone de debut
memdc.Ellipse(sys->ScrW()/2+zoomx*x-2,sys->ScrH()/2+zoomy*y-2,sys->ScrW()/2+zoomx*x+3,sys->ScrH()/2+zoomy*y+3);
// legende
memdc.Ellipse(10,90,10+6,90+6);
memdc.TextOut(20,85,"Date de dbut",13);

//transformation pr affichage
memdc.MoveTo(sys->ScrW()/2+zoomx*x,sys->ScrH()/2+zoomy*y);


// boucle sur pour l'affichage
for(t=5;t<495;t++)
  {
  // mise a jour de la date
  datum2->ajoutheure(pas);
  datum2->antimiseajour();

  // calcul de la position du soleil et de la planete
  sys->getsun()->calculposition(datum2);
  sys->getplanete(k)->calculposition(datum2,sys->getsun());
  sys->getplanete(2)->calculposition(datum2,sys->getsun());  //Terre
  y=sys->getsun()->getdeclinaison()-sys->getplanete(k)->getdeclinaison();
  x=sys->getsun()->getascensiondroite()-sys->getplanete(k)->getascensiondroite();
  while(y<-180) y+=360;
  while(y>180) y-=360;
  while(x<-180) x+=360;
  while(x>180) x-=360;
  //dessin
  // choix du crayon en fonction du mois et de la position de la planete par rapport a la Terre et au soleil
  angle=sys->getplanete(2)->getlongitude()-sys->getplanete(k)->getlongitude();
  if (angle<-180) angle+=360;
  if (angle>180) angle-=360;
  if (abs(angle)<72)pointille=0;
  else pointille=1;
  if(floor(datum2->getmois()/2)*2 == datum2->getmois()) if (NB==false) memdc.SelectObject(crayon[9+pointille*2]);
																			else memdc.SelectObject(crayon[0]);
  else if (NB==false) memdc.SelectObject(crayon[10+pointille*2]);
		else memdc.SelectObject(crayon[0]);
  if ((x<-170 && antex>170)||(x>170 && antex<-170)) memdc.MoveTo(366+zoomx*x,250+zoomy*y);
  if (NB==true && pointille!=lpointille) memdc.Ellipse(366+zoomx*x-2,250+zoomy*y-2,366+zoomx*x+2,250+zoomy*y+2);
  lpointille=pointille;
  memdc.LineTo(sys->ScrW()/2+zoomx*x,(sys->ScrH()/2+zoomy*y));
  antex=x;
	}
 //Legende

	// afficher les dates
	char txte[50];
	sprintf(txte,"Date initiale : %d/%d/%d",d->getjour(),d->getmois(),d->getannee());
	memdc.TextOut(8,50,txte,strlen(txte));
	sprintf(txte,"Date finale : %d/%d/%d",datum->getjour(),datum->getmois(),datum->getannee());
	memdc.TextOut(8,70,txte,strlen(txte));


   //
	if (PPrint==false) memdc.SelectObject(crayon[2]);   //rouge
	else memdc.SelectObject (crayon[0]);
	int largeur,hauteur;
	largeur=floor(sys->ScrW()/4/zoomx);
	hauteur=floor(sys->ScrH()/4/zoomy);
	char text[15];
	//largeur gauche
	itoa(largeur,text,10);
	memdc.MoveTo(sys->ScrW()/4-5,sys->ScrH()/2);
	memdc.LineTo(sys->ScrW()/4+5,sys->ScrH()/2);
	memdc.MoveTo(sys->ScrW()/4,sys->ScrH()/2-5);
	memdc.LineTo(sys->ScrW()/4,sys->ScrH()/2+5);
	memdc.TextOut(sys->ScrW()/4,sys->ScrH()/2+7,text,strlen(text));
	//largeur droite
  //	text=itoa(-largeur,text,10);
	memdc.MoveTo(3*sys->ScrW()/4-5,sys->ScrH()/2);
	memdc.LineTo(3*sys->ScrW()/4+5,sys->ScrH()/2);
	memdc.MoveTo(3*sys->ScrW()/4,sys->ScrH()/2-5);
	memdc.LineTo(3*sys->ScrW()/4,sys->ScrH()/2+5);
	memdc.TextOut(3*sys->ScrW()/4,sys->ScrH()/2+7,text,strlen(text));
	//hauteur haut
	itoa(hauteur,text,10);
	memdc.MoveTo(sys->ScrW()/2-5,sys->ScrH()/4);
	memdc.LineTo(sys->ScrW()/2+5,sys->ScrH()/4);
	memdc.MoveTo(sys->ScrW()/2,sys->ScrH()/4-5);
	memdc.LineTo(sys->ScrW()/2,sys->ScrH()/4+5);
	memdc.TextOut(sys->ScrW()/2+7,sys->ScrH()/4-3,text,strlen(text));
	//hauteur bas
	//itoa(-hauteur,text,10);
	memdc.MoveTo(sys->ScrW()/2-5,3*sys->ScrH()/4);
	memdc.LineTo(sys->ScrW()/2+5,3*sys->ScrH()/4);
	memdc.MoveTo(sys->ScrW()/2,3*sys->ScrH()/4-5);
	memdc.LineTo(sys->ScrW()/2,3*sys->ScrH()/4+5);
	memdc.TextOut(sys->ScrW()/2+7,3*sys->ScrH()/4-3,text,strlen(text));

	}
	memdc.SetBkMode(OPAQUE);

   SetCursor(LoadCursor(NULL, (TResId)IDC_ARROW));
}