#ifndef ETOILE_H
#define ETOILE_H
#include "constant.h"

class etoile {
  private:
	 double declinaison;
	 double ascensiondroite;
	 double magnitude;
	 char nom [max_nom];
	 char abrev[max_nom];
	 char couleur[20]; // type spectral
	 int lignes[max_lignes];
    int X,Y;

  public:
	 // constructeur et destructeur
	 etoile(void);
	 etoile(char *,char*,double, double, double,char*);
	 ~etoile(void);

    // acces aux attributs prives
    double getdeclinaison(void);
    double getascensiondroite(void);
	 double getmagnitude(void);
	 char* getcouleur(void);
	 int getligne(int rang);

    void setdeclinaison(double);
    void setascensiondroite(double);
	 void setmagnitude(double);
	 void setcouleur(char*);
	 void setligne(int rang, int conste);

    
	 void setx(int);
	 void sety(int);
	 int getx(void);
	 int gety(void);

	 char* getnom();
    char* getabrev();
};

#endif
