#include <stdio.h>
#include <string.h>
#include <owl\window.h>

#include <dos.h>
#include <math.h>
#include <stdio.h>

#include <dir.h>
#include "gsc.h"




double AssemblerOctets(int *tab,int n){
  double result=0.;
  int i;
  double k=0.1,signe=1.;
  for (i=0;i<n;i++){
		if (tab[i]!=46) {k*=10.;}
		if (tab[i]==46) {i=n;}
  }
  for (i=0;i<n;i++){
		if (tab[i]==46) {}           // point
		if (tab[i]==32) {k/=10.;}    // espace
		if (tab[i]==43) {signe=+1.;k/=10.;} // signe +
		if (tab[i]==45) {signe=-1.;k/=10.;} // signe -
		if (tab[i]>=48 && tab[i]<58) {result+=signe*(double)(tab[i]-48)*k;k/=10.;}    // chiffre
  }

  return result;
}
int AssemblerOctetsInt(int *tab,int n){
  double result=0.;
  int i;
  double k=0.1,signe=1.;
  for (i=0;i<n;i++)k*=10.;
  for (i=0;i<n;i++){
		if (tab[i]==32) {k/=10.;}    // espace
		if (tab[i]==43) {signe=1.;k/=10.;} // signe +
		if (tab[i]==45) {signe=-1.;k/=10.;} // signe -
		if (tab[i]>=48 && tab[i]<58) {result+=signe*(double)(tab[i]-48)*k;k/=10.;}    // chiffre
  }

  return (int)result;
}


GscInfo LireGSC(FILE *fitfile){
	GscInfo result;
	int tab[9];
	//int n=9;
	int i;
	for(i=0;i<5;i++) fgetc(fitfile); // ID VERSION
	for (i=0;i<9;i++) tab[i]=fgetc(fitfile); // ID ASCENSCION DROITE
	result.asc=AssemblerOctets(tab,9);
	for (i=0;i<9;i++) tab[i]=fgetc(fitfile); // ID DECLINAISON
	result.dec=AssemblerOctets(tab,9);
	for(i=0;i<5;i++) fgetc(fitfile); // ERREUR POSITION
	for (i=0;i<5;i++) tab[i]=fgetc(fitfile); // ID ASCENSCION DROITE
	result.mag=AssemblerOctets(tab,5);
	for(i=0;i<12;i++) fgetc(fitfile); // divers

   return result;
}

int AllerDebutFichierGSC(FILE * fitfile){
  int i,c,k=10000,result=0;
  for(i=0;i<8640;i++) {
	 c=fgetc(fitfile);
	 if(i>=3225&&i<3229)   //NAXIS 2
		{ if(c!=32) result+=k*(c-48);
		  k/=10; }

  }
  // printf("%d\n",result);
  return result;
}
//--------------------------------------------
//
//			Dterminer les petites cartes qui conviennent
//
int AllerDebutFichierSmallRegion(FILE * fitfile){
  int i,c,k=10000,result=0;
  // int l=0;
  for(i=0;i<8646;i++) {
	 c=fgetc(fitfile);

	 if(i>=6105&&i<6110)   //NAXIS 2
		{ if(c!=32) result+=k*(c-48);
		  k/=10; }

		 //	if(i>6082 && i<6200) printf("%d %c\n",i,(char)c);
		 //	 if (c==(int)'X' && l==(int)'A') printf("%d \n",i);
		 //	 if (c==(int)'A' )l=c;
		 //	 else l=0;
		 // if( i>8000 && c!=(int)' ') printf("%d %c\n",i,(char)c);
  }
  //printf("%d\n",result);
  return result;
}
void LireSmallRegion(FILE *fitfile,ListeFichierGsc &tableau){
	int c,n=tableau.Nombre;
	c=AllerDebutFichierSmallRegion(fitfile);
	while (c-->0){
		 LireRegionS(fitfile,n,tableau);
		 if(tableau.Nombre>40) c=0;
	}

}
void LireRegionS(FILE *fitfile,int n,ListeFichierGsc &tableau){
	int i,tab[15];
	int numeroS,numeroL,depth;
	for (i=0;i<3;i++) tab[i]=fgetc(fitfile); //  en Heure
		numeroL=AssemblerOctetsInt(tab,3);
	fgetc(fitfile); fgetc(fitfile);
	for (i=0;i<5;i++) tab[i]=fgetc(fitfile); //  en Heure
		numeroS=AssemblerOctetsInt(tab,5);
	fgetc(fitfile); fgetc(fitfile);
	depth=-48+fgetc(fitfile);
	for(i=0;i<n;i++){  // comparaison avec les n zones deja trouvees
       /*tableau*/
	}
}


//--------------------------------------------
//
//			Dterminer la carte qui convient
//
int AllerDebutFichierRegion(FILE * fitfile){
  int i,c,k=10000,result=0;
  // int l;
  for(i=0;i<14400;i++) {
	 c=fgetc(fitfile);
	 if(i>=8985&&i<8990)   //NAXIS 2
		{ if(c!=32) result+=k*(c-48);
		  k/=10; }

			//if(i>8962 && i<9100) printf("%d %c\n",i,(char)c);
			// if (c==(int)'X' && l==(int)'A') printf("%d \n",i);
			// if (c==(int)'A' )l=c;
			// else l=0;
  }
 // printf("%d\n",result);
  return result;
}


int LireRegion(FILE *fitfile,double Asclo,
												double Aschi,
												double Declo,
												double Dechi,ListeFichierGsc &tableau){
	int result=0;
	int tab[9];
	//int n=9;
	int i,page;
	double lecture;
	double ascHi=0.,ascLo=0.,decHi=0.,decLo=0.;
	for(i=0;i<5;i++) tab[i]=fgetc(fitfile); // numero fichier
		page=AssemblerOctetsInt(tab,5);
	fgetc(fitfile);
	fgetc(fitfile); // espaces
	// ID ASCENSCION DROITE  LOW
	for (i=0;i<2;i++) tab[i]=fgetc(fitfile); //  en Heure
		ascLo+=15.*(float)AssemblerOctetsInt(tab,2);
	fgetc(fitfile);
	for (i=0;i<2;i++) tab[i]=fgetc(fitfile); //  en Minute
		ascLo+=0.25*(float)AssemblerOctetsInt(tab,2);
	fgetc(fitfile);
	for (i=0;i<5;i++) tab[i]=fgetc(fitfile); //  en Seconde
		ascLo+=0.00417*AssemblerOctets(tab,5);
	fgetc(fitfile);
	// ID ASCENSCION DROITE  HI
	for (i=0;i<2;i++) tab[i]=fgetc(fitfile); //  en Heure
		ascHi+=15.*(float)AssemblerOctetsInt(tab,2);
	fgetc(fitfile);
	for (i=0;i<2;i++) tab[i]=fgetc(fitfile); //  en Minute
		ascHi+=0.25*(float)AssemblerOctetsInt(tab,2);
	fgetc(fitfile);
	for (i=0;i<5;i++) tab[i]=fgetc(fitfile); //  en Seconde
		ascHi+=0.004167*(float)AssemblerOctets(tab,5);
	fgetc(fitfile);
	//----------------------------------------------------
	// ID declinaison  LOW
	for (i=0;i<3;i++) tab[i]=fgetc(fitfile); //  en degre
		decLo+=(float)AssemblerOctetsInt(tab,3);
	fgetc(fitfile);
	for (i=0;i<4;i++) tab[i]=fgetc(fitfile); //  en minutes
		if(decLo>=0) decLo+=0.0167*(float)AssemblerOctets(tab,4);
		else decLo-=0.0167*(float)AssemblerOctets(tab,4);
	fgetc(fitfile);
	// ID Declinaison  HI
	for (i=0;i<3;i++) tab[i]=fgetc(fitfile); //  en Heure
		decHi+=(float)AssemblerOctetsInt(tab,3);
	fgetc(fitfile);
	for (i=0;i<4;i++) tab[i]=fgetc(fitfile); //  en minutes
		if(decHi>=0) decHi+=0.0167*(float)AssemblerOctets(tab,4);
		else decHi-=0.0167*(float)AssemblerOctets(tab,4);
	if (decHi<decLo) {lecture=decLo; decLo=decHi;decHi=lecture; }
	if (decHi<Dechi+(decHi-decLo) && ascHi<Aschi+(ascHi-ascLo) &&
		 decHi>Declo && ascHi>Asclo && tableau.Nombre<40) {
			tableau.Numero[tableau.Nombre]=page;
			tableau.Dec[tableau.Nombre++]=decHi;
		//	printf("\nregion: %d %lf %lf %lf %lf\n",page,ascLo,ascHi,decLo,decHi);
	}

	return result;
}

ListeFichierGsc LireFichierRegion (int disko,double Asclo,
												double Aschi,
												double Declo,
												double Dechi){
	ListeFichierGsc result;
	result.Nombre=0;

	int c,resultar=IDOK;
	char Message[100],filename[100];
	sprintf(Message,"Insrez le lecteur CD-ROM : The Guide Star Catalog Version 1.1, Volume 1 ou Volume 2 dans le lecteur %c:",disko+'A');
	sprintf(filename,"%c:\\Tables\\Regions.tbl",disko+'a');
	FILE *fileregion;

	fileregion=fopen("Regions.tbl","rb");

	if (fileregion==NULL) {fclose(fileregion);fileregion=fopen(filename,"rb");}

	while (fileregion==NULL&& resultar==IDOK){
			fclose(fileregion);
			resultar=MessageBox(0,Message,"Fichier Introuvable",MB_OKCANCEL);
			if(resultar==IDOK) fileregion=fopen(filename,"rb");  // ici c'est le d, mais ca pourrai en etre un autre, verifier aussi le repertoire
	}
	if(resultar==IDOK){
		c=AllerDebutFichierRegion(fileregion);

        result.Nombre=0;
		while(c-->0){
			LireRegion(fileregion,Asclo,Aschi,Declo,Dechi,result);

			if (result.Nombre>=40) {
				MessageBox(0,"Zone trop grande pour utiliser toutes les toiles disponibles dans le Guide Star Catalog","Erreur",MB_OK);
				c=0;
			}
		}
		fclose(fileregion);
		/*
		if (result.Nombre<40) {
	 //	fileregion=fopen("SM_REG_X.tbl","rb");
	  //	LireSmallRegion(fileregion,result);
	  //	fclose(fileregion);
		}
		*/
	} // if resultar=IDOK
	else result.Nombre=-1;
	return result;
}

char * RepertoireCd(int n){
	char result[50];
	if (n>=9490 &&n<9537)strcpy(result,"gsc\\S8230\\");
	if (n>=9346 &&n<9490)strcpy(result,"gsc\\S7500\\");
	if (n>=9134 &&n<9346)strcpy(result,"gsc\\S6730\\");
	if (n>=8840 &&n<9134)strcpy(result,"gsc\\S6000\\");
	if (n>=8464 &&n<8840)strcpy(result,"gsc\\S5230\\");
	if (n>=8022 &&n<8464)strcpy(result,"gsc\\S4500\\");
	if (n>=7523 &&n<8022)strcpy(result,"gsc\\S3730\\");
	if (n>=6989 &&n<7523)strcpy(result,"gsc\\S3000\\");
	if (n>=6412 &&n<6989)strcpy(result,"gsc\\S2230\\");
	if (n>=5838 &&n<6412)strcpy(result,"gsc\\S1500\\");
	if (n>=5260 &&n<5838)strcpy(result,"gsc\\S0730\\");
	if (n>=4663 &&n<5260)strcpy(result,"gsc\\S0000\\");
	if (n>=4615 &&n<4663)strcpy(result,"gsc\\N8230\\");
	if (n>=4492 &&n<4615)strcpy(result,"gsc\\N7500\\");
	if (n>=4294 &&n<4492)strcpy(result,"gsc\\N6730\\");
	if (n>=4014 &&n<4294)strcpy(result,"gsc\\N6000\\");
	if (n>=3652 &&n<4014)strcpy(result,"gsc\\N5230\\");
	if (n>=3246 &&n<3652)strcpy(result,"gsc\\N4500\\");
	if (n>=2781 &&n<3246)strcpy(result,"gsc\\N3730\\");
	if (n>=2259 &&n<2781)strcpy(result,"gsc\\N3000\\");
	if (n>=1729 &&n<2259)strcpy(result,"gsc\\N2230\\");
	if (n>=1178 &&n<1729)strcpy(result,"gsc\\N1500\\");
	if (n>=594 &&n<1178)strcpy(result,"gsc\\N0730\\");
	if (n>=0 &&n<594)strcpy(result,"gsc\\N0000\\");

	return result;
}



/////////

   /*
int main (){
	int n; // nombre d'toiles NAXIS 2
	//printf("\n-> %lf %lf %lf %lf\n",0.,3.,0.,3.);

	int iii,result,i;
	char filename[15];
	char dirname[50];
	char allname[50];
	char *chemin;
	FILE * fitfile;
	ListeFichierGsc tableau;
   GscInfo StarInfo;
	tableau=LireFichierRegion (340.,350.,-3.,-1.);
	printf("%d\n",tableau.Nombre);

	//--------
	//tableau.Nombre=1;
	//tableau.Numero[0]=7;
	for(iii=0;iii<tableau.Nombre;iii++){
	  if(tableau.Numero[iii]<10000) sprintf(filename,"%d.gsc",tableau.Numero[iii]);
	  if(tableau.Numero[iii]<1000) sprintf(filename,"0%d.gsc",tableau.Numero[iii]);
	  if(tableau.Numero[iii]<100) sprintf(filename,"00%d.gsc",tableau.Numero[iii]);
	  if(tableau.Numero[iii]<10) sprintf(filename,"000%d.gsc",tableau.Numero[iii]);
	  if (tableau.Numero[iii]>=9490 &&tableau.Numero[iii]<9537)strcpy(dirname,"gsc\\S8230\\");
	if (tableau.Numero[iii]>=9346 &&tableau.Numero[iii]<9490)strcpy(dirname,"gsc\\S7500\\");
	if (tableau.Numero[iii]>=9134 &&tableau.Numero[iii]<9346)strcpy(dirname,"gsc\\S6730\\");
	if (tableau.Numero[iii]>=8840 &&tableau.Numero[iii]<9134)strcpy(dirname,"gsc\\S6000\\");
	if (tableau.Numero[iii]>=8464 &&tableau.Numero[iii]<8840)strcpy(dirname,"gsc\\S5230\\");
	if (tableau.Numero[iii]>=8022 &&tableau.Numero[iii]<8464)strcpy(dirname,"gsc\\S4500\\");
	if (tableau.Numero[iii]>=7523 &&tableau.Numero[iii]<8022)strcpy(dirname,"gsc\\S3730\\");
	if (tableau.Numero[iii]>=6989 &&tableau.Numero[iii]<7523)strcpy(dirname,"gsc\\S3000\\");
	if (tableau.Numero[iii]>=6412 &&tableau.Numero[iii]<6989)strcpy(dirname,"gsc\\S2230\\");
	if (tableau.Numero[iii]>=5838 &&tableau.Numero[iii]<6412)strcpy(dirname,"gsc\\S1500\\");
	if (tableau.Numero[iii]>=5260 &&tableau.Numero[iii]<5838)strcpy(dirname,"gsc\\S0730\\");
	if (tableau.Numero[iii]>=4663 &&tableau.Numero[iii]<5260)strcpy(dirname,"gsc\\S0000\\");
	if (tableau.Numero[iii]>=4615 &&tableau.Numero[iii]<4663)strcpy(dirname,"gsc\\N8230\\");
	if (tableau.Numero[iii]>=4492 &&tableau.Numero[iii]<4615)strcpy(dirname,"gsc\\N7500\\");
	if (tableau.Numero[iii]>=4294 &&tableau.Numero[iii]<4492)strcpy(dirname,"gsc\\N6730\\");
	if (tableau.Numero[iii]>=4014 &&tableau.Numero[iii]<4294)strcpy(dirname,"gsc\\N6000\\");
	if (tableau.Numero[iii]>=3652 &&tableau.Numero[iii]<4014)strcpy(dirname,"gsc\\N5230\\");
	if (tableau.Numero[iii]>=3246 &&tableau.Numero[iii]<3652)strcpy(dirname,"gsc\\N4500\\");
	if (tableau.Numero[iii]>=2781 &&tableau.Numero[iii]<3246)strcpy(dirname,"gsc\\N3730\\");
	if (tableau.Numero[iii]>=2259 &&tableau.Numero[iii]<2781)strcpy(dirname,"gsc\\N3000\\");
	if (tableau.Numero[iii]>=1729 &&tableau.Numero[iii]<2259)strcpy(dirname,"gsc\\N2230\\");
	if (tableau.Numero[iii]>=1178 &&tableau.Numero[iii]<1729)strcpy(dirname,"gsc\\N1500\\");
	if (tableau.Numero[iii]>=594 &&tableau.Numero[iii]<1178)strcpy(dirname,"gsc\\N0730\\");
	if (tableau.Numero[iii]>=0 &&tableau.Numero[iii]<594)strcpy(dirname,"gsc\\N0000\\");
	  sprintf(allname,"e:\\%s%s",dirname,filename);
	  printf("%s\n",allname);


	  fitfile=fopen(allname,"rb");
	  if (fitfile!=NULL){
			n=AllerDebutFichierGSC(fitfile);
			printf("%d\n",n);
			if (n>5) n=5;
			while (n-->0) {
				StarInfo=LireGSC(fitfile);
				// afficher etoile
				printf("asc: %lf\ndec: %lf\nmag :%lf\n",StarInfo.asc,StarInfo.dec,StarInfo.mag);
			}
			fclose(fitfile);
	  }
	  else printf("fichier introuvable\n");

	  result=IDOK;
	  while (fitfile==NULL&& result==IDOK) {
			fclose(fitfile);

		  //	if (tableau.dec[iii]>=-7.5)
		  //		result=MessageBox("Insrez le CD-Rom n 1 du Guide Star Catalog","Fichier introuvable",MB_OKCANCEL);
		  //	else
		  //		result=MessageBox("Insrez le CD-Rom n 2 du Guide Star Catalog","Fichier introuvable",MB_OKCANCEL);
         printf("erreur\n");
			result=IDOK;
			if(result==IDOK) {
				 int save, disk, disks;
             result=IDCANCEL;
				// save original drive
				save = getdisk();
				for (disk = 1;disk < 26;++disk)
				{
					setdisk(disk);
					if (disk == getdisk()){
						printf("%c: drive is available\n", disk + 'a');
						chemin=searchpath(allname);
						if(fitfile!=NULL){printf("fichier sur le lecteur :%c, chemin:%s\n", disk + 'a',chemin);fitfile=fopen(allname,"rb");disk=26;}
					}  //if disk
				} //for disk
				setdisk(save);
          }// if result==IDOK

	  }   // while result=IDOK && fitfile==NULL
	  if (result==IDOK){

			n=AllerDebutFichierGSC(fitfile);
			printf("%d\n",n);
			if (n>5) n=5;
			while (n-->0) {
			StarInfo=LireGSC(fitfile);
			// afficher etoile
			printf("asc: %lf\ndec: %lf\nmag :%lf\n",StarInfo.asc,StarInfo.dec,StarInfo.mag);
			}
			fclose(fitfile);

	  }

	  }

     return 0;

}
  */

