#include "outil.h"
#include <math.h>
#include <stdlib.h>
#include "objet.h"


void objetceleste::parallax(date2 * datum,double latitude,double longitude)
{

date2* datetronquee=new date2();
double p,u,a,b,deltaascdr;//a distance de l'observateur au plan de l'equateur, b distance a l'axe NS
double H,teta,tsj;//teta temps sideral local a greenwich a0 hUT, tsj le temps en siecle juliens local
double altitude =0.0;


//calcul de H
datetronquee->setjour(datum->getjour());
datetronquee->setmois(datum->getmois());
datetronquee->setannee(datum->getannee());
datetronquee->miseajour();
tsj=datetronquee->getsieclejulien();
teta=6.6460656+2400.051262*tsj+0.00002581*tsj*tsj;
teta=teta/24.0;
teta=teta-floor(teta);
teta=teta*24.0;//temps sideral a greenwich a 0h
teta=teta+(  (double) datum->getheure()+ ( (double)datum->getminute()/60.0 )*1.002737908);

teta=15.0*teta;//nous voila en degre



H=teta-(longitude+ascensiondroite);

//************************************************************************

//calcul de u, a et b
p=4.2634515116/distancealamere;
u=atan(0.99664719*tan(dr(latitude)));
a=0.99664719*sin(u)+(altitude/6378140.0)*sin(dr(latitude));
b=cos(u)+(altitude/6378140.0)*cos(dr(latitude));
deltaascdr=atan(  (-1.0*b*p*0.00001*sin(dr(H) )/(cos(dr(declinaison))-b*p*0.00001*cos(dr(H))) ) );



declinaison=rd( atan(    ( (sin(dr(declinaison))-a*p*0.00001)*cos(deltaascdr) )/  (cos(dr(declinaison))-b*p*0.00001*cos(dr(H)))    ));
ascensiondroite=mespr(ascensiondroite+rd(deltaascdr));


}