# ifndef PLANETE_H
# define PLANETE_H

//#include "systeme.h" // pour les constantes (max_satellite)
#include "objet.h"   // classe mere
#include "satellit.h"  // classe satellite
#include "constant.h"
#include "date.h"      //classe date pour les calculs
#include "soleil.h"

class planete : public objetceleste{
  private:
	 int nbrsat; //nbre de satellites
	 satellite * tabsat[max_satellite]; // tableau de pointeurs sur satellites

//methodes
  public:
  // constructeur - destructeur
	 planete(char*no,char*couleu,double rayo);
	 ~planete();

  //fonctions set
	 void setnbrsatellite(int);
	 void setsatellite(satellite* sat,int rang);

  // fonctions get
	 int getnbrsatellite();
	 satellite *getsatellite(int i);
  //eclairage de la planete
    double getphi();
	 double getsurface();
	 double getmag();

	 

  // fonctions calcul
	 void calculposition(date2*,soleil*);


	 double * correcteur(soleil * sun,date2 * datum);


};

#endif //PLANETE_H
