#ifndef SATURNE3d_H
#define SATURNE3d_H

#include "systeme.h"
#include "ciel.rh"
#include "outil.h"
#include "moskito.h"
#include "satsat.h"
#include <owl/dc.h>
#include <math.h>
void quicksaturne3d(date2* datum,systeme *sys,TMemoryDC * memdc2, Plan P,int k,HBRUSH pinceau[35],HPEN crayon[35],bool PPrint=false, bool NB=false,bool Actualiser=true );
void saturne3d(systeme *sys,TMemoryDC * memdc2, Plan P,int k,HBRUSH pinceau[35],HPEN crayon[35],bool PPrint=false, bool NB=false);

void DrawTrapeze(Trapeze Data,int couleur,double zoom,systeme *sys,TMemoryDC * memdc2, HBRUSH pinceau[35],HPEN crayon[35],bool PPrint=false, bool NB=false);

void satsat3d(systeme *sys,TMemoryDC * memdc,TMemoryDC * memdc2);
void satsat3dsatelites(date2* datum,systeme *sys,TMemoryDC * memdc2, Plan P,int k,HBRUSH pinceau[35],HPEN crayon[35],bool PPrint=false, bool NB=false,int phase=0, bool Actualiser=true);


#endif
