#include <stdio.h>
#include "soleil.h"
#include "date.h"
#include "outil.h"

//methodes
  // constructeur - destructeur
         soleil::soleil(char*no,char*couleu,int rayo) :objetceleste(no,couleu,rayo) {

         }
         soleil::~soleil(){}

  //
			void soleil::setepsilon(double epsi,int rang){
					 epsilon[rang]=epsi;
			}

			void soleil::calculposition(date2 *d)
			{
			//Calcul des coordonnees du soleil

//mise ajour du temps
double t=d->getsieclejulien();
//cette fois calculs grace au tmps
struct eo_soleil
{double L;
 double e;
 double M;
 double epsilon;
};

struct eo_soleil sol;

sol.L=mespr(mise_a_jour(L,t));
sol.e=mise_a_jour(e,t);
sol.M=mespr(mise_a_jour(M,t));
sol.epsilon=mise_a_jour(epsilon,t);


//calcul de E par la methode du point fixe
int i;
double E,v,O,adr;
E=dr(sol.M);

for (i=0;i<20;i++)
{
E=(dr(sol.M)+sol.e*sin(E));
}
E=rd(E);

//calcul de v
v=rd(2*atan(  sqrt((1+sol.e)/(1-sol.e))  * tan(dr(E)/2)  ));

//calcul de O
O=sol.L+v-sol.M;

//calcul de l'ascension droite adr
adr=rd(atan(cos(dr(sol.epsilon))*sin(dr(O))/cos(dr(O))));
if(cos(dr(O))<0) adr+=180;
if(adr<0) adr+=360;
ascensiondroite=adr;

//calcul de la declinaison
declinaison=rd(asin(sin(dr(sol.epsilon)))*sin(dr(O)));
distancealamere=1;

			}
			double* soleil::getepsilon(void) {return epsilon;}

